			             ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                      
FF00                  reg_pia0_ddra           equ     $ff00
FF00                  reg_pia0_pdra           equ     $ff00
FF01                  reg_pia0_cra            equ     $ff01
FF02                  reg_pia0_ddrb           equ     $ff02
FF02                  reg_pia0_pdrb           equ     $ff02
FF03                  reg_pia0_crb            equ     $ff03
                      
FF20                  reg_pia1_ddra           equ     $ff20
FF20                  reg_pia1_pdra           equ     $ff20
FF21                  reg_pia1_cra            equ     $ff21
FF22                  reg_pia1_ddrb           equ     $ff22
FF22                  reg_pia1_pdrb           equ     $ff22
FF23                  reg_pia1_crb            equ     $ff23
                      
                      ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                      
0000                  bas_err_NF              equ     $00     ; NF - Next without For (Not found)
0002                  bas_err_SN              equ     $02     ; SN - Syntax error
0004                  bas_err_RG              equ     $04     ; RG - Return without Gosub
0006                  bas_err_OD              equ     $06     ; OD - Out of DATA in READ
0008                  bas_err_FC              equ     $08     ; FC - Illegal Function call
000A                  bas_err_OV              equ     $0a     ; OV - Overflow, number too large
000C                  bas_err_OM              equ     $0c     ; OM - Out of memory
000E                  bas_err_UL              equ     $0e     ; UL - Undefined line
0010                  bas_err_BS              equ     $10     ; BS - Bad suscript
0012                  bas_err_DD              equ     $12     ; DD - Attempt to redimension array
0014                  bas_err_d0              equ     $14     ; /0 - Divide by 0
0016                  bas_err_ID              equ     $16     ; ID - Illegal direct statement
0018                  bas_err_TM              equ     $18     ; TM - Type mismatch
001A                  bas_err_OS              equ     $1a     ; OS - Out of String Space
001C                  bas_err_LS              equ     $1c     ; LS - String too long
001E                  bas_err_ST              equ     $1e     ; ST - String formula too complex
0020                  bas_err_CN              equ     $20     ; CN - Can't continue
0022                  bas_err_UF              equ     $22     ;   UF - 
0024                  bas_err_FD              equ     $24     ; FD - Faulty data
0026                  bas_err_AO              equ     $26     ; AO - File Already open
0028                  bas_err_DN              equ     $28     ;   DN - Device number
002A                  bas_err_IO              equ     $2a     ; IO - Input/output
002C                  bas_err_FM              equ     $2c     ; FM - Wrong File mode
002E                  bas_err_NO              equ     $2e     ; NO - File not open
0030                  bas_err_IE              equ     $30     ; IE - Input past end of file
0032                  bas_err_DS              equ     $32     ; DS - Direct statement in file
0034                  bas_err_NE              equ     $34     ;   NE - 
                      
                      ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                      
0006                  VALTYP                  equ     $0006   ; Variable type flag (0=numeric, else string)
006F                  DEVNUM                  equ     $006f   ; Current device number
0039                  VARPTR_last             equ     $0039   ; address of last variable used
0052                  VARPTR                  equ     $0052   ; VARPTR of variables is stored here
                      
0019                  bas_basic_start         equ     $0019   ; Start address of BASIC program
001B                  bas_scalar_start        equ     $001b   ; Start address of simple variables
001D                  bas_array_start         equ     $001d   ; Start address of array variables
001F                  bas_free_start          equ     $001f   ; Start of unused mem after BASIC program
0021                  bas_stack_top           equ     $0021   ; Top of stack, growing down
0023                  bas_string_top          equ     $0023   ; Top of free string space
0027                  bas_ram_top             equ     $0027   ; Top of RAM available to BASIC
0071                  bas_restart_flag        equ     $0071   ; cold restart if not 0x55 on reset
0072                  bas_restart_vector      equ     $0072   ; warm start if points to NOP
0088                  bas_cursor_pos          equ     $0088   ; Current VDU cursor addr (typ 0x0400-0x05ff)
008A                  bas_null                equ     $008a   ; Gen purpose 16bit scratch / 16bit zero
009C                  bas_lp_pos              equ     $009c   ; Printer head column posn == POS(-2)
009D                  bas_exec                equ     $009d   ; EXEC default entry address
00B0                  bas_usr_table_ptr       equ     $00b0   ; Ptr to start of USR table
00B7                  bas_gfx_end             equ     $00b7   ; Ptr to last byte+1 of current graphics mode
00BA                  bas_gfx_base            equ     $00ba   ; Ptr to first byte of current graphics mode
                      
012A                  bas_stub1               equ     $012a
012A                  bas_stub1_nwords        equ     $012a
012B                  bas_stub1_words         equ     $012b
012D                  bas_stub1_tok_handle    equ     $012d
012F                  bas_stub1_nfwords       equ     $012f
0130                  bas_stub1_fwords        equ     $0130
0132                  bas_stub1_ftok_handle   equ     $0132
                      
0134                  bas_stub2               equ     $0134
0134                  bas_stub2_nwords        equ     $0134
0135                  bas_stub2_words         equ     $0135
0137                  bas_stub2_tok_handle    equ     $0137
0139                  bas_stub2_nfwords       equ     $0139
013A                  bas_stub2_fwords        equ     $013a
013C                  bas_stub2_ftok_handle   equ     $013c
                      
013E                  bas_stub3               equ     $013e
                      
015E                  bas_ram_hooks           equ     $015e
015E                  bas_hook_dev_open       equ     $015e   ; Device open
0161                  bas_hook_verify_devn    equ     $0161   ; Verify device number
0164                  bas_hook_dev_init       equ     $0164   ; Device init
0167                  bas_hook_chrout         equ     $0167   ; Output char in A to DEVN
016A                  bas_hook_chrin          equ     $016a   ; Input char from DEVN to A
016D                  bas_hook_input          equ     $016d   ; Input from DEVN using INPUT
0170                  bas_hook_print          equ     $0170   ; Output to DEVN using PRINT
0173                  bas_hook_close_all      equ     $0173   ; Close all files
0176                  bas_hook_close          equ     $0176   ; Close file
0179                  bas_hook_interpret_tok  equ     $0179   ; Interpret token in A as command
017C                  bas_hook_reinput        equ     $017c   ; Re-request input from keyboard
017F                  bas_hook_check_keys     equ     $017f   ; Check keys - scan for BREAK, SHIFT+'@'
0182                  bas_hook_line_input     equ     $0182   ; Line input from DEVN using LINE INPUT
0185                  bas_hook_close_basic    equ     $0185   ; Close BASIC file read, goto cmd mode
0188                  bas_hook_check_eof      equ     $0188   ; Check EOF on DEVN
018B                  bas_hook_eval_expr      equ     $018b   ; Evaluate expression
018E                  bas_hook_user_error     equ     $018e   ; Called from bas_system_error
0191                  bas_hook_sys_error      equ     $0191   ; Called from bas_system_error
0194                  bas_hook_run            equ     $0194   ; Called by RUN
0197                  bas_hook_reset_basic    equ     $0197   ; Reset Basic Memory, edit/enter BASIC lines
019A                  bas_hook_next_command   equ     $019a   ; Get next command
019D                  bas_hook_assign_string  equ     $019d   ; Assign string variable
01A0                  bas_hook_screen_access  equ     $01a0   ; Screen access - CLS, GET, PUT
01A3                  bas_hook_tokenise       equ     $01a3   ; Tokenise line
01A6                  bas_hook_detokenise     equ     $01a6   ; De-Tokenise line
                      
                      ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                      
8006                  _POLCAT                 equ     $8006
8009                  _CBLINK                 equ     $8009
800C                  _CHROUT                 equ     $800c
800F                  _LPOUT                  equ     $800f
8012                  _JOYIN                  equ     $8012
8015                  _CASON                  equ     $8015
8018                  _CASOFF                 equ     $8018
801B                  _WRTLDR                 equ     $801b
801E                  _CBOUT                  equ     $801e
8021                  _CSRDON                 equ     $8021
8024                  _CBIN                   equ     $8024
8027                  _BITIN                  equ     $8027
802A                  _SERIN                  equ     $802a
802D                  _SEROUT                 equ     $802d
8030                  _SERSET                 equ     $8030
                      
A000                  __POLCAT                equ     $a000
A002                  __CHROUT                equ     $a002
A004                  __CSRDON                equ     $a004
A006                  __BLKIN                 equ     $a006
A008                  __BLKOUT                equ     $a008
A00A                  __JOYIN                 equ     $a00a
A00C                  __WRTLDR                equ     $a00c
                      
009F                  CHRGET                  equ     $009f
8A94                  GETVAR                  equ     $8a94
8B29                  GETUSR                  equ     $8b29
8B2D                  INTCNV                  equ     $8b2d
8C37                  GIVABF                  equ     $8c37   ; returns D as 16bit val in FAC
8D9F                  DELVAR                  equ     $8d9f
93BF                  MOVFM                   equ     $93bf
B54A                  OUTCHR                  equ     $b54a
B93E                  BLKIN                   equ     $b93e
B999                  BLKOUT                  equ     $b999
BBE5                  INCH                    equ     $bbe5
BCAB                  OUTCH                   equ     $bcab
BCF5                  TXLPCH                  equ     $bcf5
BD41                  SNDSEL                  equ     $bd41
BD52                  JOYIN                   equ     $bd52
BDA5                  BITIN                   equ     $bda5
BDAD                  CBIN                    equ     $bdad
BDCF                  CASON                   equ     $bdcf
BDDC                  CASOFF                  equ     $bddc
BDE7                  CSRDON                  equ     $bde7
BE12                  CBOUT                   equ     $be12
BE68                  WRTLDR                  equ     $be68
                      
83ED                  BasVect2                equ     $83ed
841F                  BasVect1                equ     $841f
89AA                  CkComa                  equ     $89aa
89AC                  CkChar                  equ     $89ac
8E51                  Get8Bit                 equ     $8e51
8E83                  Get16Bit                equ     $8e83
                      
00A5                  bas_poll_char           equ     $00a5   ; re-fetch next character
00A6                  bas_next_char           equ     $00a6   ; address of next character
831C                  L_831C                  equ     $831c		; move a data block backwards from $43 to $41 (end pointers), $47 old start address	
8331                  L_8331                  equ     $8331		; test if there is space in stack
8344                  bas_system_error        equ     $8344		; output error message
835E                  L_835E                  equ     $835e		; idem but entering the error code table
8371                  bas_ok_prompt           equ     $8371		; send Enter
837A                  L_837A                  equ     $837a		; Bucle de entrada (Basic interpreter)
837D                  L_837D                  equ     $837d		; same but with command line skipped 
83FF                  L_83FF                  equ     $83ff		; get a line from a Basic Program
8401                  L_8401                  equ     $8401		; same but entering the line to be searched in D
8417                  bas_erase_basic         equ     $8417   ; Erases program in memory same as NEW
8434                  bas_reset_stack         equ     $8434   ; Resets stack - all entries are lost
849F                  bas_run_basic           equ     $849f   ; RUNs BASIC program in mem
84ED                  bas_tok_handle          equ     $84ed
8512                  L_8512                  equ     $8512
851B                  bas_scan_key            equ     $851b
852B                  bas_wait_key            equ     $852b   ; Waits for key press, returns key in A
85E7                  L_85E7                  equ     $85e7
8605                  bas_ul_error            equ     $8605   ; ?UL ERROR
869A                  L_869A                  equ     $869a
872E                  L_872E                  equ     $872e
8872                  L_8872                  equ     $8872
8877                  bas_get_expression      equ     $8877   ; Eval next expr; puts VARPTR addr in $0052:0053
8882                  bas_tm_error            equ     $8882   ; ?TM ERROR
8887                  bas_get_string          equ     $8887   ; Compile string and put in free string space
899F                  L_899F                  equ     $899f
89B4                  bas_sn_error            equ     $89b4   ; ?SN ERROR
8A0B                  bas_ftok_handle         equ     $8a0b
8B8D                  bas_fc_error            equ     $8b8d   ; ?FC ERROR
8C52                  L_8C52                  equ     $8c52
8CB3                  L_8CB3                  equ     $8cb3
8CD7                  force_garbage_collect   equ     $8cd7   ; Forces garbage collection of string space
8DEA                  L_8DEA                  equ     $8dea
8E7E                  L_8E7E                  equ     $8e7e
8EA6                  bas_list_to_b           equ     $8ea6   ; LIST to device in B reg
8EE0                  L_8EE0                  equ     $8ee0
903D                  PRINT_dispatch          equ     $903d
90A1                  bas_print_crlf          equ     $90a1
90A5                  L_90A5                  equ     $90a5
90E5                  bas_print_string        equ     $90e5
90F5                  bas_print_space         equ     $90f5
90F8                  bas_print_question      equ     $90f8
9165                  L_9165                  equ     $9165
9473                  L_9473                  equ     $9473
957A                  bas_print_d             equ     $957a
9582                  bas_print_number        equ     $9582
9B7E                  L_9B7E                  equ     $9b7e
9C76                  bas_not_direct          equ     $9c76
9DD2                  L_9DD2                  equ     $9dd2
9EEE                  L_9EEE                  equ     $9eee
AA81                  bas_init_gfx_new        equ     $aa81
AA87                  bas_init_gfx_new_1      equ     $aa87
B3EA                  L_B3EA                  equ     $b3ea
B43C                  continue_basic_init     equ     $b43c
B44F                  bas_warm_start          equ     $b44f
B505                  bas_input_achar         equ     $b505   ; Input char from DEVN & $7f
B5BA                  L_B5BA                  equ     $b5ba
B5BC                  L_B5BC                  equ     $b5bc
B5D3                  L_B5D3                  equ     $b5d3
B631                  bas_no_error            equ     $b631   ; ?NO ERROR
B63C                  L_B63C                  equ     $b63c
B64C                  L_B64C                  equ     $b64c
B7CC                  bas_cpxub               equ     $b7cc   ; Copy B bytes from X to U
B7D4                  L_B7D4                  equ     $b7d4
B7DB                  L_B7DB                  equ     $b7db
B7E0                  L_B7E0                  equ     $b7e0
B81A                  L_B81A                  equ     $b81a
B835                  bas_OPEN_cont           equ     $b835   ; use BASIC's normal OPEN code
B848                  bas_fm_error            equ     $b848
B84B                  bas_io_error            equ     $b84b   ; ?IO ERROR
B84E                  bas_ao_error            equ     $b84e   ; ?AO ERROR
B851                  bas_dn_error            equ     $b851
BA77                  bas_clear_screen        equ     $ba77
BAC3                  bas_audio_off           equ     $bac3
BAED                  L_BAED                  equ     $baed
BC3A                  L_BC3A                  equ     $bc3a
                      
8514                  bas_RESTORE_dispatch    equ     $8514
85A5                  bas_RUN_dispatch        equ     $85a5
8EA4                  bas_LLIST_dispatch      equ     $8ea4
8EAA                  bas_LIST_dispatch       equ     $8eaa
                      
B4B3                  bas_msg_copyright       equ     $b4b3
                      
                      ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                      
                                      if !COCO
FF40                  reg_fdc_status          equ     $ff40
FF40                  reg_fdc_command         equ     $ff40
FF41                  reg_fdc_track           equ     $ff41
FF42                  reg_fdc_sector          equ     $ff42
FF43                  reg_fdc_data            equ     $ff43
                      
FF48                  reg_ddos_control        equ     $ff48
                                      else
                      reg_fdc_status          equ     $ff48
                      reg_fdc_command         equ     $ff48
                      reg_fdc_track           equ     $ff49
                      reg_fdc_sector          equ     $ff4a
                      reg_fdc_data            equ     $ff4b
                      
                      reg_ddos_control        equ     $ff40
                                      endif
                      
                      ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                      
0080                  ddos_err_NR             equ     $80     ; NR - Not ready
0082                  ddos_err_SK             equ     $82     ; SK - Seek error
0084                  ddos_err_WP             equ     $84     ; WP - Write protect
0086                  ddos_err_RT             equ     $86     ; RT - Record Type
0087                  ddos_err_TR             equ     $87     ; TR - Track
0088                  ddos_err_RF             equ     $88     ; RF - Record not found
008A                  ddos_err_CC             equ     $8a     ; CC - CRC check error
008C                  ddos_err_LD             equ     $8c     ; LD - Lost data
008E                  ddos_err_BT             equ     $8e     ; BT - Boot error
0090                  ddos_err_IV             equ     $90     ; IV - Invalid directory format
0092                  ddos_err_FD             equ     $92     ; FD - Directory full
0094                  ddos_err_DF             equ     $94     ; DF - Disk full
0096                  ddos_err_FS             equ     $96     ; FS - File spec
0098                  ddos_err_PT             equ     $98     ; PT - Protection
009A                  ddos_err_PE             equ     $9a     ; PE - Read past End
009C                  ddos_err_FF             equ     $9c     ; FF - File not found
009E                  ddos_err_FE             equ     $9e     ; FE - File exists
00A0                  ddos_err_NE             equ     $a0     ; NE - File does not exist
00A2                  ddos_err_TF             equ     $a2     ; TF - Too many files open
00A4                  ddos_err_PR             equ     $a4     ; PR - Protected
00A6                  ddos_err_ZZ             equ     $a6     ; ?? - Undefined
                      
0000                  fdop_restore            equ     0
0001                  fdop_seek               equ     1
0002                  fdop_read_sector        equ     2
0003                  fdop_write_sector_nr    equ     3
0004                  fdop_write_sector       equ     4
0005                  fdop_write_track        equ     5
0006                  fdop_read_address       equ     6
0007                  fdop_test_sector        equ     7
0008                  fdop_read_address_s0    equ     8
                      
001A                  num_ddos_tok            equ     $1a
                      
                      ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                      
00EA                  DSKCOM_data             equ     $00ea
00EA                  DSKCOM_command          equ     $00ea
00EB                  DSKCOM_drive            equ     $00eb
00EC                  DSKCOM_track            equ     $00ec
00ED                  DSKCOM_sector           equ     $00ed
00EE                  DSKCOM_bufptr           equ     $00ee
00F0                  DSKCOM_status           equ     $00f0
00F1                  DSKCOM_fcb              equ     $00f1
00F2                  DSKCOM_buflen           equ     $00f2
00F3                  DSKCOM_xferlen          equ     $00f3
00F4                  DSKCOM_disktype         equ     $00f4
00F5                  DSKCOM_rwv_flag         equ     $00f5
00F6                  DSKCOM_timeout          equ     $00f6
00F7                  DSKCOM_dunno            equ     $00f7
                      
                      ; drive structure
0000                  _struct_drive           org     0
0000                  drive_lsn_dir           rmb     2       ; 0
0002                  drive_reserved_sectors  rmb     1       ; 2
0003                  drive_lsn_first_free    rmb     2       ; 3
0005                  drive_num_open_files    rmb     1       ; 5
0006                  sizeof_drive            equ     *-_struct_drive ; 6
                      
                      ; buffer structure
0000                  _struct_buffer          org     0
0000                  buffer_lsn              rmb     2
0002                  buffer_in_use           rmb     1
0003                  buffer_drive            rmb     1
0004                  buffer_priority         rmb     1
0005                  buffer_address          rmb     2
0007                  sizeof_buffer           equ     *-_struct_buffer        ; 7
                      
                      ; fcb structure
0000                  _struct_fcb             org     0
0000                  fcb_file_name           rmb     8
0008                  fcb_file_ext            rmb     3
000B                  fcb_drive               rmb     1
000C                  fcb_read_ptr            rmb     3
000F                  fcb_attr                rmb     1
0010                  fcb_write_ptr           rmb     3
0013                  fcb_sec_preceeding1     rmb     2
0015                  fcb_block_lsn1          rmb     2
0017                  fcb_sec_consecutive1    rmb     1
0018                  fcb_sec_preceeding2     rmb     2
001A                  fcb_block_lsn2          rmb     2
001C                  fcb_sec_consecutive2    rmb     1
001D                  fcb_master_dirent       rmb     1
001E                  fcb_cur_cont_dirent     rmb     1
001F                  sizeof_fcb              equ     *-_struct_fcb   ; 31
                      
0004                  ddos_ndrives            equ     4
0004                  ddos_nbuffers           equ     4
000A                  ddos_nfcbs              equ     10
                      
0600                                          org     $0600
0600                  ddos_tmp0               rmb     1       ; $0600
0601                  ddos_tmp1               rmb     1       ; $0601
0602                                          rmb     3       ; $0602
0605                  ddos_timeout_count      rmb     1       ; $0605
0606                  ddos_command_mask       rmb     1       ; $0606
0607                  ddos_control_mask       rmb     1       ; $0607
0608                  ddos_verify_flag        rmb     1       ; $0608 - non-zero = on		; I think it's the contrary!!
0609                  ddos_status_mask        rmb     1       ; $0609
060A                  ddos_default_drive      rmb     1       ; $060a
060B                  ddos_fwrite_buf         rmb     2       ; $060b
060D                  ddos_auto_line_num      rmb     2       ; $060d
060F                  ddos_auto_line_inc      rmb     2       ; $060f
0611                  ddos_load_not_run       rmb     1       ; $0611
0612                  ddos_fread_flag         rmb     1       ; $0612
0613                  ddos_auto_flag          rmb     1       ; $0613 - non-zero = on
0614                  ddos_error_goto_flag    rmb     1       ; $0614
0615                  ddos_error_goto_line    rmb     2       ; $0615
0617                  ddos_erl_line_num       rmb     2       ; $0617
0619                  ddos_err_last           rmb     1       ; $0619
061A                  ddos_err_address        rmb     2       ; $061a
061C                  ddos_drives             rmb     ddos_ndrives*sizeof_drive       ; $061c (4 x 6 bytes)
0634                  ddos_buffers            rmb     ddos_nbuffers*sizeof_buffer     ; $0634 (4 x 7 bytes)
0650                  ddos_cur_drive_info     rmb     12      ; $0650
065C                                          rmb     5       ; $065c
0661                  ddos_0661               rmb     2       ; $0661
0663                  ddos_0663               rmb     1       ; $0663
0664                  ddos_0664               rmb     2       ; $0664
0666                                          rmb     1       ; $0666
0667                  ddos_0667               rmb     2       ; $0667
0669                  ddos_0669               rmb     2       ; $0669
066B                  ddos_066B               rmb     2       ; $066b
066D                  ddos_066D               rmb     2       ; $066d
066F                  ddos_066F               rmb     2       ; $066f
0671                  ddos_0671               rmb     2       ; $0671
0673                  ddos_0673               rmb     2       ; $0673
0675                  ddos_0675               rmb     2       ; $0675
0677                  ddos_0677               rmb     1       ; $0677
0678                                          rmb     2       ; $0678
067A                  ddos_067A               rmb     2       ; $067a
067C                  ddos_067C               rmb     1       ; $067c
067D                  ddos_067D               rmb     1       ; $067d
067E                  ddos_067E               rmb     1       ; $067e
067F                                          rmb     2       ; $067f
0681                  ddos_0681               rmb     1       ; $0681
0682                  ddos_0682               rmb     1       ; $0682
0683                  ddos_usr_vectors        rmb     20      ; $0683
0697                  ddos_drive_on           rmb     ddos_ndrives    ; $0697 (4 x 1 byte) flags
069B                  ddos_cur_track          rmb     ddos_ndrives    ; $069b (4 x 1 byte)
069F                  ddos_step_rate          rmb     ddos_ndrives    ; $069f (4 x 1 byte)
06A3                  ddos_ntracks            rmb     ddos_ndrives    ; $06a3 (4 x 1 byte)
06A7                  ddos_nsectors           rmb     ddos_ndrives    ; $06a7 (4 x 1 byte) sectors x track
06AB                  ddos_density            rmb     ddos_ndrives    ; $06ab (4 x 1 byte)
06AF                  ddos_sec_per_side       rmb     ddos_ndrives    ; $06af (4 x 1 byte)
06B3                                          rmb     10              ; $06b3
06BD                  ddos_fcbs               rmb     ddos_nfcbs*sizeof_fcb   ; $06bd (10 x 31) FIBs
07F3                  ddos_fcbs_end
07F3                  ddos_07F3               rmb     1               ; $07f3
07F4                                          rmb     1               ; $07f4
07F5                  ddos_eof_return         rmb     1               ; $07f5
                      
E000                  cart_rom2               equ     $e000
E002                  cart_rom2_init          equ     $e002
                      
                      ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
                      
C000                                  org     $c000
                                      setdp   0
                      
C000  444B                            fcc     /DK/
C002  2070                            bra     new_init
                      
C004  C16E            __DSKCOM        fdb     DSKCOM 					; vector to low level I/O toutine
C006  00EA                            fdb     DSKCOM_data			; address of command byte
C008  D772                            fdb     validate_filename	; parse - scan - verify file name
C00A  CA89                            fdb     open_file				; locate or search a FIB
C00C  D079                            fdb     create_file			; create new file, backup old
C00E  DF0A            __LENFIL        fdb     LENFIL					; 
C010  DF50            __CLOSAL        fdb     CLOSAL					; 
C012  DF6B                            fdb     close_file				; close 1 file
C014  CB1D                            fdb     read_file				;
C016  CD9F                            fdb     write_file				;
C018  D24F            __GETFRE        fdb     GETFRE					;
C01A  D0FC            __DELETE        fdb     DELETE					;
C01C  D1F1                            fdb     protect_file			;
C01E  D220            __RENAME        fdb     RENAME					;
C020  D315            __GETDIR        fdb     GETDIR					; get directory entry
C022  D36B                            fdb     buf_read_sector		; read sector to buffer
C024  C741                            fdb     backup_directory		; cleanup buffers and copy directory
C026  D3D6                            fdb     read_lsn				; 
C028  D3D3                            fdb     write_lsn				; 
C02A  D3D1                            fdb     verify_lsn				;
C02C  C933                            fdb     initialise_disk		;
C02E  C3A0                            fdb     ddos_error_codes		; 
                      
                                      ; $c030 XXX coverage?
C030  98                              fcb     $98
                      
C031  4449534B3A00    msg_disk        fcc     /DISK:/,0
                      
C037  DC8A            L_C037          ldd     bas_null
C039  DDF6                            std     DSKCOM_timeout  ; and DSKCOM_dunno
C03B  FD0697                          std     ddos_drive_on+0
C03E  FD0699                          std     ddos_drive_on+2
C041  ED81            10              std     ,x++
C043  8C07FE                          cmpx    #$07fe
C046  25F9                            blo     10B
C048  8E062D                          ldx     #ddos_buffers-7
C04B  6F14                            clr     -12,x           ; ddos_drive1+5
C04D  6F1A                            clr     -6,x            ; ddos_drive2+5
C04F  6F84                            clr     ,x              ; ddos_drive3+5
C051  6F06                            clr     6,x             ; ddos_drive4+5
C053  CC0408                          ldd     #$0408
C056  3007            20              leax    sizeof_buffer,x ; x = ddos_buffers
C058  6F02                            clr     2,x
C05A  ED04                            std     4,x
C05C  6F06                            clr     6,x
C05E  5C                              incb
C05F  4A                              deca
C060  26F4                            bne     20B
                                      ;
C062                  do_fdc_terminate
C062  86D0                            lda     #$d0            				; Terminate command
C064  B7FF40                          sta     reg_fdc_command				; put into command register
C067  39                              rts											; return
                      
C068  8C059F          ddos_init       cmpx    #$059f
C06B  2306                            bls     $c073
C06D  BD852B                          jsr     $852b
C070  BDBA77                          jsr     $ba77
C073  39										  rts
                                      ;
C074  8E0600          new_init        ldx     #ddos_tmp0
C077  8DBE                            bsr     L_C037
C079  CC0C24                          ldd     #$0c24
C07C  D719                            stb     bas_basic_start
C07E  BDAA87                          jsr     bas_init_gfx_new_1
C081  96BA                            lda     bas_gfx_base
C083  8B06                            adda    #$06
C085  97B7                            sta     bas_gfx_end
C087  9EB0                            ldx     bas_usr_table_ptr
C089  CE0683                          ldu     #ddos_usr_vectors
C08C  DFB0                            stu     bas_usr_table_ptr
C08E  C614                            ldb     #$14
C090  BDB7CC                          jsr     bas_cpxub
C093  8EC6CC                          ldx     #ram_init_table
C096  E680            10              ldb     ,x+
C098  2707                            beq     20F
C09A  EE81                            ldu     ,x++
C09C  BDB7CC                          jsr     bas_cpxub
C09F  20F5                            bra     10B
C0A1  A64D            20              lda     13,u
C0A3  2604                            bne     30F
C0A5  862F                            lda     #$2f
C0A7  A74D                            sta     13,u
C0A9  CC137E          30              ldd     #$137e
C0AC  31C84C                          leay    $4c,u           ; y = bas_ram_hooks
C0AF  E7A0            40              stb     ,y+
C0B1  EE81                            ldu     ,x++
C0B3  EFA1                            stu     ,y++
C0B5  4A                              deca
C0B6  26F7                            bne     40B
C0B8  7C060A                          inc     ddos_default_drive
C0BB  8E4549                          ldx     #$4549          ; "EI"
C0BE  BCE000                          cmpx    cart_rom2
C0C1  10271F3D                        lbeq    cart_rom2_init
                                      ;
C0C5  1CAF                            andcc   #$af
C0C7  8EB4B2                          ldx     #$b4b2
C0CA  BD90E5                          jsr     bas_print_string
C0CD  8EC34C                          ldx     #$c34c
C0D0  BD90E5                          jsr     $90e5
C0D3  8EC6B4                          ldx     #$c6b4
C0D6  7EB447                          jmp     $b447
C0D9  12                          	  nop
C0DA  9E88                            ldx     <$88
C0DC  8C0400                          cmpx    #$0400
C0DF  2703                            beq     $c0e4
C0E1  7EB54A          50              jmp     $b54a
C0E4  39										  rts
                      
C0E5  BDC80A          BOOT_dispatch   jsr     L_C80A
C0E8  1026C8C8                        lbne    bas_sn_error
C0EC  F7060A                          stb     ddos_default_drive
C0EF  D7EB                            stb     DSKCOM_drive
C0F1  8D4A                            bsr     do_boot
C0F3  7E8344                          jmp     bas_system_error
                      
                      ; attempt a call to DSKCOM with retries
                      
C0F6  CC0003          test_tr00_se03  ldd     #$0003
C0F9  DDEC                            std     DSKCOM_track    			 ; TR00 SE03
C0FB  C607            test_sector     ldb     #fdop_test_sector
C0FD  8C                              fcb     $8c                     ; cmpx - comment byte
C0FE  C604            write_sector    ldb     #fdop_write_sector      ; possibly skipped
C100  8C                              fcb     $8c                     ; cmpx - comment byte
C101  C603            write_sector_nr ldb     #fdop_write_sector_nr   ; possibly skipped
C103  8C                              fcb     $8c                     ; cmpx - comment byte
C104  C602            read_sector     ldb     #fdop_read_sector       ; possibly skipped
C106  3402            L_C106          pshs    a
C108  8602                            lda     #$02    ; number of retries
C10A  EDE3                            std     ,--s
C10C  8D59            10              bsr     DSKCOM_seek
C10E  2506                            bcs     20F
C110  E661                            ldb     1,s
C112  8D58                            bsr     DSKCOM_B
C114  2422                            bcc     60F
                                      ; operation failed - where appropriate, attempt to fix
                                      ; alignment by moving the head forward & back a track
C116  6AE4            20              dec     ,s
C118  2B1B                            bmi     50F
C11A  C180                            cmpb    #$80
C11C  2717                            beq     50F
C11E  6DE4                            tst     ,s
C120  260A                            bne     40F
C122  0AEC                            dec     DSKCOM_track
C124  2B02                            bmi     30F
C126  8D3F                            bsr     DSKCOM_seek
C128  0CEC            30              inc     DSKCOM_track
C12A  20E0                            bra     10B
C12C  96EC            40              lda     DSKCOM_track
C12E  5F                              clrb            ; fdop_restore
C12F  8D3B                            bsr     DSKCOM_B
C131  97EC                            sta     DSKCOM_track
C133  20D7                            bra     10B
C135  1A01            50              orcc    #$01
C137  21                              fcb     $21     ; brn - comment byte
C138  5F              60              clrb            ; possibly skipped
C139  3262                            leas    2,s
C13B  3582                            puls    a,pc
                      
C13D  8D2B            do_boot         bsr     DSKCOM_read_address_s0
C13F  C180                            cmpb    #$80
C141  2723                            beq     30F
C143  8DB1                            bsr     test_tr00_se03
C145  251F                            bcs     30F
C147  9E4F                            ldx     $004f
C149  8C4F53                          cmpx    #$4f53
C14C  2616                            bne     20F
C14E  CC2600                          ldd     #$2600
C151  DDEE                            std     DSKCOM_bufptr
C153  8DAF            10              bsr     read_sector
C155  250F                            bcs     30F
C157  0CEE                            inc     DSKCOM_bufptr
C159  0CED                            inc     DSKCOM_sector
C15B  96ED                            lda     DSKCOM_sector
C15D  8113                            cmpa    #$13
C15F  25F2                            blo     10B
C161  7E2602                          jmp     $2602
C164  C68E            20              ldb     #ddos_err_BT
C166  39              30              rts
                      
C167  C601            DSKCOM_seek     ldb     #fdop_seek
C169  8C                              fcb     $8c             ; cmpx - comment byte

C16A                  DSKCOM_read_address_s0										; Fun4 called by Fun3
C16A  C608                            ldb     #fdop_read_address_s0  	; read_address command
C16C  D7EA            DSKCOM_B        stb     DSKCOM_command				; put into variable
C16E  347B            DSKCOM          pshs    cc,a,dp,x,y,u					; save registers
C170  1A50                            orcc    #$50								; disable interrupts
C172  66E4                            ror     ,s								; flags E-H convert to EF-I (disabled interrupts)
C174  0FF0                            clr     DSKCOM_status					; clear error status byte
C176  96EA                            lda     DSKCOM_command				; get command
C178  8108                            cmpa    #$08								; is read_address command?
C17A  2224                            bhi     20F								; if higher, exit
C17C  B6FF40                          lda     reg_fdc_status				; read command register
C17F  BDC062                          jsr     do_fdc_terminate				; send a terminate command
C182  B70605                          sta     ddos_timeout_count			; set drive timeout to $d0
C185  D6EB                            ldb     DSKCOM_drive					; get drive number
C187  5A                              decb										; decrement by 1
C188  C104                            cmpb    #$04								; is higher than 3 (out of range)?
C18A  2411                            bhs     10F								; yes, goto drive number error
C18C  8E06A3                          ldx     #ddos_ntracks					; point to number of tracks table
C18F  3A                              abx											; add offset (drive number)
C190  6D14                            tst     -12,x           				; test drive valid flags (ddos_drive_on)
C192  2715                            beq     30F								; if 0, goto 30F
C194  96EC                            lda     DSKCOM_track					
C196  A184                            cmpa    ,x              ; ddos_ntracks
C198  2515                            blo     40F								
C19A  C687                            ldb     #ddos_err_TR
C19C  8C                              fcb     $8c             ; cmpx - comment byte
C19D  C628            10              ldb     #bas_err_DN     ; possibly skipped
C19F  8C                              fcb     $8c             ; cmpx - comment byte
C1A0  C6A4            20              ldb     #ddos_err_PR    ; possibly skipped
C1A2  69E4                            rol     ,s
C1A4  357B                            puls    cc,a,dp,x,y,u
C1A6  1600E0                          lbra    sec_rts_C289
                                      ;
C1A9  8612            30              lda     #$12								; get default value 18
C1AB  A704                            sta     4,x             				; as sectors x track in table
C1AD  A70C                            sta     12,x            				; as sec_per_side in table
C1AF  A618            40              lda     -8,x            				; get ddos_cur_track from table
C1B1  B7FF41                          sta     reg_fdc_track					; put in WD2797 track register
C1B4  EA08                            orb     8,x             				; or with ddos_density from table
C1B6  CA24                            orb     #$24								; set bits 3-4
C1B8  F7FF48                          stb     reg_ddos_control				; put into WD2797 latch register
C1BB  F70607                          stb     ddos_control_mask			; and into system control mask
C1BE  CEFEE5                          ldu     #reg_pia0_cra-$1c			; point to PIA0CRA - $1c
C1C1  C602            50              ldb     #$02								; counter to 2
C1C3  33C81C                          leau    $1c,u							; add $1c to U pointer
C1C6  A6C4            60              lda     ,u								; get a byte
C1C8  3402                            pshs    a									; onto stack
C1CA  84FC                            anda    #$fc								; reset bits 0-1
C1CC  A7C1                            sta     ,u++								; put it back and point to PIA0CRB
C1CE  5A                              decb										; decrement counter
C1CF  26F5                            bne     60B								; if not 0, loopback to 60B
C1D1  1183FF21                        cmpu    #reg_pia1_cra					; points U to PIA1CRA?
C1D5  25EA                            blo     50B								; if lower loopback to 50B
C1D7  8A37                            ora     #$37								; sets bits 5-4 and 2-1-0
C1D9  A75E                            sta     -2,u								; puts it in PIA1CRB
C1DB  8603                            lda     #$03								; put 3
C1DD  3402                            pshs    a       						; in stack as three retries
C1DF  96ED                            lda     DSKCOM_sector					; get sector number
C1E1  A10C                            cmpa    12,x            				; compare to sec_per_side in table
C1E3  230A                            bls     70F								; if not greater goto 70F
C1E5  A00C                            suba    12,x            ; ddos_sec_per_side
C1E7  C602                            ldb     #$02
C1E9  FA0606                          orb     ddos_command_mask
C1EC  F70606                          stb     ddos_command_mask	; side select = 1
C1EF  B7FF42          70              sta     reg_fdc_sector				; put into WD2797 sector register
C1F2  109E8A          80              ldy     bas_null						; get 16 bits zero
C1F5  9EEE                            ldx     DSKCOM_bufptr					; get system buffer address
C1F7  D6EA                            ldb     DSKCOM_command				; get system command
C1F9  58                              lslb										; double it to get offset to function table
C1FA  86FF                            lda     #$ff								; change to $FF
C1FC  1F8B                            tfr     a,dp								; as direct page
C1FE  CEDFBF                          ldu     #fdop_dispatch				; point to function table
C201  ADD5                            jsr     [b,u]							; call routine at that offset
C203  97F0                            sta     DSKCOM_status
C205  250D                            bcs     90F
C207  B40609                          anda    ddos_status_mask
C20A  97F0                            sta     DSKCOM_status
C20C  270E                            beq     110F
C20E  96EA                            lda     DSKCOM_command
C210  8107                            cmpa    #$07
C212  2704                            beq     100F    ; don't retry fdop_test_sector
C214  6AE4            90              dec     ,s
C216  26DA                            bne     80B
C218  1A01            100             orcc    #$01
C21A  2019                            bra     130F
                                      ; no (unmasked) error
C21C  7D0609          110             tst     ddos_status_mask
C21F  2A14                            bpl     130F
C221  7D0608                          tst     ddos_verify_flag
C224  270C                            beq     120F
C226  D6EC                            ldb     DSKCOM_track
C228  C114                            cmpb    #$14
C22A  2706                            beq     120F
C22C  C110                            cmpb    #$10
C22E  1CFE                            andcc   #$fe
C230  2603                            bne     130F
C232  17FEC6          120             lbsr    test_sector
C235  3261            130             leas    1,s
C237  6964                            rol     4,s
C239  8E069A                          ldx     #ddos_cur_track-1
C23C  D6EB                            ldb     DSKCOM_drive
C23E  3A                              abx
C23F  B6FF41                          lda     reg_fdc_track
C242  91EC                            cmpa    DSKCOM_track
C244  2710                            beq     140F
C246  F60609                          ldb     ddos_status_mask
C249  C119                            cmpb    #$19
C24B  2609                            bne     140F
C24D  C6FF                            ldb     #$ff
C24F  D7F0                            stb     DSKCOM_status
C251  50                              negb
C252  EA64                            orb     4,s
C254  E764                            stb     4,s
C256  A784            140             sta     ,x              ; ddos_cur_track
C258  8EFF01                          ldx     #reg_pia0_cra
C25B  3506                            puls    a,b
C25D  A78822                          sta     $22,x           ; reg_pia1_crb
C260  E78820                          stb     $20,x           ; reg_pia1_cra
C263  3506                            puls    a,b
C265  A702                            sta     2,x             ; reg_pia0_crb
C267  E784                            stb     ,x              ; reg_pia0_cra
C269  7F0606                          clr     ddos_command_mask       ; side select = 0
C26C  5F                              clrb
C26D  357B                            puls    cc,a,dp,x,y,u
C26F  241A                            bcc     rts_C28B
C271  D6F0                            ldb     DSKCOM_status
C273  2A06                            bpl     150F
C275  CB02                            addb    #$02
C277  2B0B                            bmi     170F
C279  200B                            bra     180F
                                      ; compute error code from status bits 7..2:
                                      ; SK, WP, RT, RF, CC, LD
C27B  1F98            150             tfr     b,a
C27D  5F                              clrb
C27E  5C              160             incb
C27F  49                              rola
C280  2504                            bcs     180F
C282  26FA                            bne     160B
C284  C613            170             ldb     #$13    ; ??? error
C286  58              180             lslb
C287  CA80                            orb     #$80
C289  1A01            sec_rts_C289    orcc    #$01
C28B  39              rts_C28B        rts
                      
                                      setdp   $ff
                      
C28C                  fdop_restore_dispatch
C28C  7F00EC                          clr     DSKCOM_track
                                      ;
C28F                  fdop_seek_dispatch
C28F  FC00EB                          ldd     DSKCOM_drive    ; and DSKCOM_track
C292  5D                              tstb
C293  270F                            beq     20F             ; TR00, therefore Restore
C295  D141                            cmpb    reg_fdc_track
C297  2607                            bne     10F
C299  4F                              clra
C29A  B70609                          sta     ddos_status_mask
C29D  1F8B                            tfr     a,dp
C29F  39                              rts
C2A0  D743            10              stb     reg_fdc_data
C2A2  C610                            ldb     #$10            ; Seek
C2A4  8E069E          20              ldx     #ddos_step_rate-1
C2A7  EA86                            orb     a,x
C2A9  8619                            lda     #$19
C2AB  8E0050                          ldx     #$0050
C2AE  2014                            bra     40F
                                      ;
C2B0                  fdop_read_address_s0_dispatch
C2B0  8E0012                          ldx     #$0012
C2B3  7F0606                          clr     ddos_command_mask       ; side select = 0
                                      ;
C2B6                  fdop_read_address_dispatch
C2B6  C6C0                            ldb     #$c0            ; Read Address
C2B8  2005                            bra     30F
                                      ;
C2BA                  fdop_test_sector_dispatch
C2BA  8E004F                          ldx     #$004f
                                      ;
C2BD                  fdop_read_sector_dispatch
C2BD  C688                            ldb     #$88            ; Read Sector
C2BF  863F            30              lda     #$3f
C2C1  FA0606                          orb     ddos_command_mask       ; or in side select bit
C2C4  B70609          40              sta     ddos_status_mask
C2C7  D740                            stb     reg_fdc_command
C2C9  D623            50              ldb     reg_pia1_crb
C2CB  2B13                            bmi     80F
C2CD  313F                            leay    -1,y
C2CF  26F8                            bne     50B
C2D1  48                              lsla
C2D2  2AF5                            bpl     50B
C2D4  86D0            60              lda     #$d0            ; Terminate
C2D6  9740                            sta     reg_fdc_command
C2D8  4F                              clra
C2D9  1F8B                            tfr     a,dp            ; TR00, therefore Restore
C2DB  86FE                            lda     #$fe
C2DD  20AA                            bra     sec_rts_C289
                                      ;
C2DF  13              70              sync
C2E0  9643            80              lda     reg_fdc_data
C2E2  D622                            ldb     reg_pia1_pdrb
C2E4  A780                            sta     ,x+
C2E6  8C0051                          cmpx    #$0051
C2E9  26F4                            bne     70B
C2EB  13              90              sync
C2EC  9643                            lda     reg_fdc_data
C2EE  D622                            ldb     reg_pia1_pdrb
C2F0  20F9                            bra     90B
                      
C2F2                  fdop_write_sector_dispatch
                                      ; write sector, ignore not ready error
C2F2  865F                            lda     #$5f
C2F4  8C                              fcb     $8c     ; cmpx - comment byte
                                      ;
C2F5                  fdop_write_sector_nr_dispatch
                                      ; write sector, don't ignore not ready error
C2F5  86DF                            lda     #$df    ; possibly skipped
C2F7  C6A8                            ldb     #$a8    ; Write Sector
C2F9  8D15                            bsr     send_write_cmd
C2FB  A680                            lda     ,x+
C2FD  D623            10              ldb     reg_pia1_crb
C2FF  2B09                            bmi     30F
C301  313F                            leay    -1,y
C303  26F8                            bne     10B
C305  20CD                            bra     60B
C307  A680            20              lda     ,x+
C309  13                              sync
C30A  9743            30              sta     reg_fdc_data
C30C  9622                            lda     reg_pia1_pdrb
C30E  20F7                            bra     20B
                      
C310  B70609          send_write_cmd  sta     ddos_status_mask
                                      ; enable write precompensation for tracks > 16
C313  8610                            lda     #$10
C315  9141                            cmpa    reg_fdc_track
C317  2D01                            blt     10F
C319  4F                              clra
C31A  BA0607          10              ora     ddos_control_mask
C31D  9748                            sta     reg_ddos_control
C31F  FA0606                          orb     ddos_command_mask       ; or in side select bit
C322  D740                            stb     reg_fdc_command
C324  39                              rts
                      
C325                  fdop_write_track_dispatch
C325  CC47F4                          ldd     #$47f4  ; Write Track
C328  8DE6                            bsr     send_write_cmd
C32A  EC81            10              ldd     ,x++
C32C  13              20              sync
C32D  D743                            stb     reg_fdc_data
C32F  D122                            cmpb    reg_pia1_pdrb
C331  4A                              deca
C332  26F8                            bne     20B
C334  A680                            lda     ,x+
C336  13                              sync
C337  9743                            sta     reg_fdc_data
C339  D122                            cmpb    reg_pia1_pdrb
C33B  20ED                            bra     10B
                      
C33D  9640            ddos_nmi_handle lda     reg_fdc_status
C33F  5F                              clrb
C340  1F9B                            tfr     b,dp
C342  326C                            leas    12,s
C344  4D                              tsta
C345  39                              rts
                      
                                      setdp   0
                      
C346                  ddos_firq_handle
C346  B1FF20                          cmpa    reg_pia1_pdra
C349  B1FF22                          cmpa    reg_pia1_pdrb
C34C  3B                              rti
                      
C34D  444F53706C757320352E30200D msg_copyright   fcc     /DOSplus 5.0 /,$0d
C35A  28432920335320313938390D0000                 fcc     /(C) 3S 1989/,$0d,$00,0
                      
                                      ; 2:1 sector interleave (data reversed)
                                      ; note: the 0 terminating the previous string is also used
                                      ; to terminate this data working backwards
                                      ;fcb    0
C368  120911081007                    fcb     $12,$09,$11,$08,$10,$07
C36E  0F060E050D04                    fcb     $0f,$06,$0e,$05,$0d,$04
C374  0C030B020A01                    fcb     $0c,$03,$0b,$02,$0a,$01
C379                  fmt_interleave  equ     *-1
                      
                                      ; formatting data is stored slightly compressed:
                                      ;   repeat, value, next
                                      ; writes <repeat> bytes of <value>, followed by one byte
                                      ; of <next>
                      
                                      ; each track starts with this:
                      
C37A  354E4E          fmt_track_pre   fcb     $35,$4e,$4e
C37D  080000                          fcb     $08,$00,$00
C380  03F6FC                          fcb     $03,$f6,$fc
C383  1F4E4E                          fcb     $1f,$4e,$4e
                      
                                      ; this precedes the variable data in the formatting
                                      ; commands for each sector:
                      
C386  070000          fmt_sector_pre  fcb     $07,$00,$00
C389  03F5FE                          fcb     $03,$f5,$fe
                      
                                      ; then this completes each sector:
                      
C38C  01F74E          fmt_sector_rest fcb     $01,$f7,$4e
C38F  144E4E                          fcb     $14,$4e,$4e
C392  0B0000                          fcb     $0b,$00,$00
C395  03F5FB                          fcb     $03,$f5,$fb
C398  00E5F7                          fcb     $00,$e5,$f7
C39B  174E4E                          fcb     $17,$4e,$4e
                      
                                      ; after all 18 sectors (in the order specified by
                                      ; fmt_interleave), this finishes off the track:
                      
C39E  004E            fmt_track_post  fcb     $00,$4e         ;,$4e
                                      ; note: *three* bytes are copied in this last chunk, the
                                      ; 'N' from the first error code is reused as a cheeky
                                      ; extra $4e
                      
C3A0                  ddos_error_codes
C3A0  4E52534B57505254                 fcc     /NR/,/SK/,/WP/,/RT/
C3A8  524643434C444254                 fcc     /RF/,/CC/,/LD/,/BT/
C3B0  4956464444464653                 fcc     /IV/,/FD/,/DF/,/FS/
C3B8  5054504546464645                 fcc     /PT/,/PE/,/FF/,/FE/
C3C0  4E45544650523F3F                 fcc     /NE/,/TF/,/PR/,/??/
                      
C3C8  415554CF        ddos_words      fcc     /AUT/,'O+$80
C3CC  4241434B55D0                    fcc     /BACKU/,'P+$80
C3D2  424545D0                        fcc     /BEE/,'P+$80
C3D6  424F4FD4                        fcc     /BOO/,'T+$80
C3DA  43484149CE                      fcc     /CHAI/,'N+$80
C3DF  434F50D9                        fcc     /COP/,'Y+$80
C3E3  4352454154C5                    fcc     /CREAT/,'E+$80
C3E9  4449D2                          fcc     /DI/,'R+$80
C3EC  44524956C5                      fcc     /DRIV/,'E+$80
C3F1  44534B494E49D4                  fcc     /DSKINI/,'T+$80
C3F8  46524541C4                      fcc     /FREA/,'D+$80
C3FD  4657524954C5                    fcc     /FWRIT/,'E+$80
C403  4552524FD2                      fcc     /ERRO/,'R+$80
C408  4B494CCC                        fcc     /KIL/,'L+$80
C40C  4C4F41C4                        fcc     /LOA/,'D+$80
C410  4D455247C5                      fcc     /MERG/,'E+$80
C415  50524F544543D4                  fcc     /PROTEC/,'T+$80
C41C  574149D4                        fcc     /WAI/,'T+$80
C420  52454E414DC5                    fcc     /RENAM/,'E+$80
C426  534156C5                        fcc     /SAV/,'E+$80
C42A  53524541C4                      fcc     /SREA/,'D+$80
C42F  5357524954C5                    fcc     /SWRIT/,'E+$80
C435  5645524946D9                    fcc     /VERIF/,'Y+$80
C43B  46524FCD                        fcc     /FRO/,'M+$80
C43F  464C524541C4                    fcc     /FLREA/,'D+$80
C445  535741D0                        fcc     /SWA/,'P+$80
                      
C449  535552453F00    msg_sure        fcc     /SURE?/,0
                      
                                      ; $c44f XXX coverage
C44F  3410            L_C44F          pshs    x
C451  CC0740                          ldd     #$0740
C454  EA82            10              orb     ,-x
C456  53                              comb
C457  1026F7DF                        lbne    L_BC3A
C45B  4A                              deca
C45C  2AF6                            bpl     10B
C45E  5C                              incb
C45F  4C                              inca
C460  3590                            puls    x,pc
                      
                                      ; $c462 XXX coverage
C462  8602            10              lda     #$02
C464  B4FF20                          anda    reg_pia1_pdra
C467  2651                            bne     ddos_irq_handle
C469  8DE4                            bsr     L_C44F
C46B  8DE2                            bsr     L_C44F
C46D  2743                            beq     40F
C46F  E642                            ldb     2,u
C471  6DC4                            tst     ,u
C473  273D                            beq     40F
C475  A1C4                            cmpa    ,u
C477  2603                            bne     20F
C479  54                              lsrb
C47A  54                              lsrb
C47B  54                              lsrb
C47C  EDC4            20              std     ,u
C47E  86FF                            lda     #$ff
C480  A782            30              sta     ,-x
C482  8C0151                          cmpx    #$0151
C485  26F9                            bne     30B
C487  2031                            bra     ddos_irq_handle
C489  C65F                            ldb     #$5f
C48B  8EBBE9                          ldx     #$bbe9
C48E  AC6A                            cmpx    10,s
C490  2728                            beq     ddos_irq_handle
C492  AC6E                            cmpx    14,s
C494  2724                            beq     ddos_irq_handle
C496  ACE810                          cmpx    $10,s
C499  271F                            beq     ddos_irq_handle
C49B  8EBF20                          ldx     #$bf20
C49E  C401                            andb    #$01
C4A0  271B                            beq     50F
C4A2  CE011D                          ldu     #$011d
C4A5  8E015A                          ldx     #$015a
C4A8  A617                            lda     -9,x
C4AA  4C                              inca
C4AB  2705                            beq     40F
C4AD  ECC4                            ldd     ,u
C4AF  5A                              decb
C4B0  27B0                            beq     10B
C4B2  EDC4            40              std     ,u
C4B4  780151                          lsl     $0151
C4B7  740151                          lsr     $0151
                                      ;
                      
C4BA  8E9D3D          ddos_irq_handle ldx     #$9d3d
C4BD  3410            50              pshs    x
C4BF  4F                              clra
C4C0  1F8B                            tfr     a,dp
C4C2  0DF6                            tst     DSKCOM_timeout
C4C4  2620                            bne     60F
C4C6  B60605                          lda     ddos_timeout_count
C4C9  271B                            beq     60F
C4CB  7A0605                          dec     ddos_timeout_count
C4CE  2616                            bne     60F
C4D0  DE4F                            ldu     $004f
C4D2  BDC78A                          jsr     L_C78A
C4D5  1026BE6B                        lbne    bas_system_error
C4D9  DF4F                            stu     $004f
C4DB  B60607                          lda     ddos_control_mask
C4DE  84FB                            anda    #$fb
C4E0  B7FF48                          sta     reg_ddos_control
C4E3  B70607                          sta     ddos_control_mask
C4E6  39              60              rts
                      
C4E7                  ddos_tok_dispatch
C4E7  DDE9                            fdb     AUTO_dispatch
C4E9  C79E                            fdb     BACKUP_dispatch
C4EB  DEA0                            fdb     BEEP_dispatch
C4ED  C0E5                            fdb     BOOT_dispatch
C4EF  D682                            fdb     CHAIN_dispatch
C4F1  CCD3                            fdb     COPY_dispatch
C4F3  D8D3                            fdb     CREATE_dispatch
C4F5  DC39                            fdb     DIR_dispatch
C4F7  C5F6                            fdb     DRIVE_dispatch
C4F9  C8D1                            fdb     DSKINIT_dispatch
C4FB  D916                            fdb     FREAD_dispatch
C4FD  D9A1                            fdb     FWRITE_dispatch
C4FF  C5D3                            fdb     ERROR_dispatch
C501  DB2F                            fdb     KILL_dispatch
C503  D50D                            fdb     LOAD_dispatch
C505  D464                            fdb     MERGE_dispatch
C507  DB0D                            fdb     PROTECT_dispatch
C509  DCF2                            fdb     WAIT_dispatch
C50B  DB57                            fdb     RENAME_dispatch
C50D  D5DF                            fdb     SAVE_dispatch
C50F  C62E                            fdb     SREAD_dispatch
C511  C681                            fdb     SWRITE_dispatch
C513  C57F                            fdb     VERIFY_dispatch
C515  C601                            fdb     FROM_dispatch
C517  D90E                            fdb     FLREAD_dispatch
C519  DECB                            fdb     SWAP_dispatch
                      
C51B                  msg_insert_source
C51B  494E5345525420534F555243450D00                 fcc     /INSERT SOURCE/,$0d,0
C52A  494E534552542044455354494E4154494F4E0D00 msg_insert_dest fcc     /INSERT DESTINATION/,$0d,0
C53E                  msg_formatting_track
C53E  464F524D415454494E47                 fcc     /FORMATTING/
C548  20545241434B0D00 msg__track      fcc     / TRACK/,$0d,0
C550                  msg_files_bytes_free
C550  46494C45532C204259544553204652454500                 fcc     /FILES, BYTES FREE/,0
C562                  msg_press_any_key
C562  505245535320414E59204B45590D00                 fcc     /PRESS ANY KEY/,$0d,0
                      
C571                  ddos_ftok_dispatch
C571  DD73                            fdb     LOF_dispatch
C573  DD8D                            fdb     FREE_dispatch
C575  C593                            fdb     ERL_dispatch
C577  C59C                            fdb     ERR_dispatch
C579  C597                            fdb     HIMEM_dispatch
C57B  DD34                            fdb     LOC_dispatch
C57D  C5A2                            fdb     FREstr_dispatch
                      
C57F  270C            VERIFY_dispatch beq     20F											; if no parameter assume ON
C581  81C2                            cmpa    #$c2											; is it OFF?
C583  2604                            bne     10F											; no, goto next test
C585  C6FF                            ldb     #$ff											; yes, put value $FF for OFF
C587  2005                            bra     30F											; save it
C589  8188            10              cmpa    #$88											; is it ON?
C58B  2666                            bne     sn_err_C5F3								; no, show syntax error
C58D  5F              20              clrb													; yes, put value $00	for ON
C58E  F70608          30              stb     ddos_verify_flag							; in variable
C591  0E9F                            jmp     CHRGET
                      
C593  FC0617          ERL_dispatch    ldd     ddos_erl_line_num
C596  8C                              fcb     $8c             ; cmpx - comment byte
C597  DC27            HIMEM_dispatch  ldd     bas_ram_top     ; possibly skipped
C599  7E8C37          10              jmp     GIVABF
C59C  4F              ERR_dispatch    clra
C59D  F60619                          ldb     ddos_err_last
C5A0  20F7                            bra     10B
C5A2  BD8CD7          FREstr_dispatch jsr     force_garbage_collect
C5A5  DC23                            ldd     bas_string_top
C5A7  9321                            subd    bas_stack_top
C5A9  20EE                            bra     10B
                      
C5AB                  ddos_tok_handle
C5AB  81FF                            cmpa    #$ff
C5AD  2744                            beq     sn_err_C5F3
C5AF  80CE                            suba    #$ce
C5B1  2B40                            bmi     sn_err_C5F3
C5B3  811A                            cmpa    #num_ddos_tok
C5B5  2406                            bhs     10F
C5B7  8EC4E7                          ldx     #ddos_tok_dispatch
C5BA  7E84ED                          jmp     bas_tok_handle
C5BD  6E9F0137        10              jmp     [$0137]
                      
C5C1                  ddos_ftok_handle
C5C1  C044                            subb    #$44
C5C3  2B2E                            bmi     sn_err_C5F3
C5C5  C10E                            cmpb    #$0e
C5C7  2406                            bhs     10F
C5C9  8EC571                          ldx     #ddos_ftok_dispatch
C5CC  7E8A0B                          jmp     bas_ftok_handle
C5CF  6E9F013C        10              jmp     [$013c]
                      
C5D3  8181            ERROR_dispatch  cmpa    #$81
C5D5  261C                            bne     sn_err_C5F3
C5D7  9D9F                            jsr     CHRGET
C5D9  81BC                            cmpa    #$bc
C5DB  2616                            bne     sn_err_C5F3
C5DD  9D9F                            jsr     CHRGET
C5DF  BD869A                          jsr     L_869A
C5E2  DC2B                            ldd     $002b
C5E4  81FA                            cmpa    #$fa
C5E6  1024C5A3                        lbhs    bas_fc_error
C5EA  FD0615                          std     ddos_error_goto_line
C5ED  DA2B                            orb     $002b
C5EF  F70614                          stb     ddos_error_goto_flag
C5F2  39                              rts
                      
C5F3  7E89B4          sn_err_C5F3     jmp     bas_sn_error
                      
C5F6                  DRIVE_dispatch
C5F6  27FB                            beq     sn_err_C5F3
C5F8  BDC811                          jsr     get_drive_arg
C5FB  26F6                            bne     sn_err_C5F3
C5FD  F7060A                          stb     ddos_default_drive
C600  39                              rts
                      
C601  C6ED            FROM_dispatch   ldb     #ddos_ext_cmd
C603  BDD746                          jsr     L_D746
C606  2670                            bne     bne_bas_err_C678
C608  8E02DC                          ldx     #$02dc
C60B  4F                              clra
C60C  5A                              decb
C60D  1F02                            tfr     d,y
C60F  5F                              clrb
C610  1F03                            tfr     d,u
C612  BDCB26                          jsr     L_CB26
C615  2661                            bne     bne_bas_err_C678
C617  BDDF6D                          jsr     L_DF6D
C61A  265C                            bne     bne_bas_err_C678
C61C  8E02DB                          ldx     #$02db
C61F  7F03D6                          clr     $03d6
C622  7E837D                          jmp     L_837D
                      
C625  BD89AA          L_C625          jsr     CkComa
C628  BD8A94                          jsr     GETVAR
C62B  7E8877                          jmp     bas_get_expression
                      
C62E  8D30            SREAD_dispatch  bsr     get_sector_cmd_args
C630  8DF3                            bsr     L_C625
C632  3450                            pshs    x,u
C634  8DEF                            bsr     L_C625
C636  AF62                            stx     2,s
C638  BDC104                          jsr     read_sector
C63B  2561                            bcs     bas_err_C69E
C63D  DEEE                            ldu     DSKCOM_bufptr
C63F  3510                            puls    x
C641  8D09                            bsr     L_C64C
C643  1F13                            tfr     x,u
C645  3510                            puls    x
C647  8D03                            bsr     L_C64C
C649  0FF6            L_C649          clr     DSKCOM_timeout
C64B  39                              rts
                      
C64C  3450            L_C64C          pshs    x,u
C64E  C680                            ldb     #$80
C650  BD8C52                          jsr     L_8C52
C653  3384                            leau    ,x
C655  3510                            puls    x
C657  E784                            stb     ,x
C659  EF02                            stu     2,x
C65B  3510                            puls    x
C65D  7EB7CC          cpxub_C65D      jmp     bas_cpxub
                      
C660                  get_sector_cmd_args
C660  2791                            beq     sn_err_C5F3
C662  BDC811                          jsr     get_drive_arg
C665  D7EB                            stb     DSKCOM_drive
C667  BD8E7E                          jsr     L_8E7E
C66A  D7EC                            stb     DSKCOM_track
C66C  BD8E7E                          jsr     L_8E7E
C66F  D7ED                            stb     DSKCOM_sector
C671  C6FF                            ldb     #$ff
C673  D7F6                            stb     DSKCOM_timeout
C675  BDD393                          jsr     L_D393
C678                  bne_bas_err_C678
C678  2624                            bne     bas_err_C69E
C67A  6F02                            clr     2,x
C67C  AE05                            ldx     5,x
C67E  9FEE                            stx     DSKCOM_bufptr
C680  39              rts_C680        rts
                      
C681  8DDD            SWRITE_dispatch bsr     get_sector_cmd_args
C683  5F                              clrb
C684  6F80            10              clr     ,x+
C686  5A                              decb
C687  26FB                            bne     10B
C689  8D1F                            bsr     L_C6AA
C68B  DEEE                            ldu     DSKCOM_bufptr
C68D  8D12                            bsr     L_C6A1
C68F  8D19                            bsr     L_C6AA
C691  DEEE                            ldu     DSKCOM_bufptr
C693  33C90080                        leau    $80,u
C697  8D08                            bsr     L_C6A1
C699  BDC101                          jsr     write_sector_nr
C69C  24AB                            bcc     L_C649
C69E  7E8344          bas_err_C69E    jmp     bas_system_error
                      
C6A1  5D              L_C6A1          tstb
C6A2  27DC                            beq     rts_C680
C6A4  2AB7                            bpl     cpxub_C65D
C6A6  C680                            ldb     #$80
C6A8  20B3                            bra     cpxub_C65D
                      
C6AA  BD89AA          L_C6AA          jsr     CkComa
C6AD  7E9B7E                          jmp     L_9B7E
                      
                                      ; $c6b0 XXX coverage
C6B0  12                              nop
C6B1  7EB3EA                          jmp     L_B3EA
                      
C6B4  12              reset_vector    nop
C6B5  4F                              clra
C6B6  1F8B                            tfr     a,dp
C6B8  BDC8D7                          jsr     L_C8D7
C6BB  7F0609                          clr     ddos_status_mask
C6BE  7F0605                          clr     ddos_timeout_count
C6C1  7F0613                          clr     ddos_auto_flag
C6C4  8635                            lda     #$35
C6C6  B7FF03                          sta     reg_pia0_crb
C6C9  7EB44F                          jmp     bas_warm_start
                      
                                      ; ram initialisation data - format is:
                                      ;   length      - 1 byte
                                      ;   destination - 2 bytes
                                      ;   data...     - <length> bytes
                                      ; length==0 indicates end of data
                      
C6CC                  ram_init_table
C6CC  1E                              fcb     $1e
C6CD  012A                            fdb     bas_stub1
C6CF  1A                              fcb     num_ddos_tok            ; bas_stub1_nwords
C6D0  C3C8                            fdb     ddos_words              ; bas_stub1_words
C6D2  C5AB                            fdb     ddos_tok_handle         ; bas_stub1_tok_handle
C6D4  07                              fcb     $07                     ; bas_stub1_nfwords
C6D5  DFD1                            fdb     ddos_fwords             ; bas_stub1_fwords
C6D7  C5C1                            fdb     ddos_ftok_handle        ; bas_stub1_ftok_handle
C6D9  00                              fcb     $00                     ; bas_stub2_nwords
C6DA  0000                            fdb     $0000                   ; bas_stub2_words
C6DC  89B4                            fdb     bas_sn_error            ; bas_stub2_tok_handle
C6DE  00                              fcb     $00                     ; bas_stub2_nfwords
C6DF  0000                            fdb     $0000                   ; bas_stub2_fwords
C6E1  89B4                            fdb     bas_sn_error            ; bas_stub2_ftok_handle
C6E3  00                              fcb     $00                     ; bas_stub3_nwords
C6E4  0000                            fdb     $0000                   ; XXX bas_stub3_words
C6E6  0000                            fdb     $0000                   ; XXX bas_stub3_tok_handle
C6E8  00                              fcb     $00                     ; XXX bas_stub3_nfwords
C6E9  0000                            fdb     $0000                   ; XXX bas_stub3_fwords
C6EB  0000                            fdb     $0000                   ; XXX bas_stub3_ftok_handle
                      
C6ED  03                              fcb     $03
C6EE  01A0                            fdb     bas_hook_screen_access
C6F0  7EDD05                          jmp     ddos_screen_hook        ; bas_hook_screen_access
                      
C6F3  04                              fcb     $04
C6F4  069F                            fdb     ddos_step_rate
C6F6  02020202                        fcb     $02,$02,$02,$02
                      
C6FA  09                              fcb     $09
C6FB  0109                            fdb     $0109
C6FD  7EC33D                          jmp     ddos_nmi_handle
C700  7EC4BA                          jmp     ddos_irq_handle
C703  7EC346                          jmp     ddos_firq_handle
                      
C706  00                              fcb     0                       ; end of block copy data
                      
                                      ; init code then goes on to populate RAM hooks, each
                                      ; copied with a preceeding JMP instruction:
                      
C707  DA64                            fdb     ddos_hook_dev_open      ; $015e - Device open
C709  DA5C                            fdb     ddos_hook_verify_devn   ; $0161 - Verify device number
C70B  DEF4                            fdb     ddos_hook_dev_init      ; $0164 - Device init
C70D  D9DF                            fdb     ddos_hook_chrout        ; $0167 - Output char in A to DEVN
C70F  D862                            fdb     ddos_hook_chrin         ; $016a - Input char from DEVN to A
C711  DDC3                            fdb     ddos_hook_input         ; $016d - Input from DEVN using INPUT
C713  DDC4                            fdb     ddos_hook_print         ; $0170 - Output to DEVN using PRINT
C715  DACC                            fdb     ddos_hook_close_all     ; $0173 - Close all files
C717  DAD9                            fdb     ddos_hook_close         ; $0176 - Close file
C719  DFA4                            fdb     ddos_hook_interpret_tok ; $0179 - Interpret token in A as command
C71B  C28B                            fdb     rts_C28B                ; $017c - Re-request input from keyboard
C71D  C28B                            fdb     rts_C28B                ; $017f - Check keys - scan for BREAK, SHIFT+'@'
C71F  DE2B                            fdb     ddos_hook_line_input    ; $0182 - Line input from DEVN using LINE INPUT
C721  C28B                            fdb     rts_C28B                ; $0185 - Close BASIC file read, goto cmd mode
C723  DD9C                            fdb     ddos_hook_check_eof     ; $0188 - Check EOF on DEVN
C725  C28B                            fdb     rts_C28B                ; $018b - Evaluate expression
C727  C28B                            fdb     rts_C28B                ; $018e - User hook into bas_system_error
C729  D81B                            fdb     ddos_hook_sys_error     ; $0191 - Sys hook into bas_system_error
C72B  D4F5                            fdb     ddos_hook_run           ; $0194 - Called by RUN
                      
C72D  9D9F            BACKUP_DIR      jsr     CHRGET
C72F  5F                              clrb
C730  81C4                            cmpa    #$c4
C732  2603                            bne     10F
C734  9D9F                            jsr     CHRGET
C736  53                              comb
C737  3404            10              pshs    b
C739  BDC808                          jsr     get_opt_drive
C73C  D7EB                            stb     DSKCOM_drive
C73E  3504                            puls    b
C740  21                              fcb     $21     ; brn - comment byte

                                      ; copy updated dir sectors from tr20 to tr16
C741                  backup_directory
C741  5F                              clrb            ; possibly skipped
C742  340E                            pshs    a,b,dp
C744  8D44                            bsr     L_C78A
C746  2654                            bne     60F
C748  BDD2C2                          jsr     L_D2C2
C74B  264F                            bne     60F
C74D  A6C818                          lda     $18,u
C750  A7E4                            sta     ,s
C752  BDDBCE                          jsr     L_DBCE
C755  2645                            bne     60F
C757  C68D                            ldb     #$8d
C759  6D4B                            tst     11,u
C75B  2B3F                            bmi     60F
C75D  A64D                            lda     13,u
C75F  C604                            ldb     #$04
C761  3D                              mul
C762  A661                            lda     1,s
C764  2A03                            bpl     10F
C766  50                              negb
C767  31AB                            leay    d,y
C769  E762            10              stb     2,s
C76B  BDD36B          20              jsr     buf_read_sector
C76E  262C                            bne     60F
C770  EC84                            ldd     ,x
C772  A361                            subd    1,s
C774  ED84                            std     ,x
C776  6302                            com     2,x
C778  3121                            leay    1,y
C77A  8603                            lda     #$03
C77C  A4E4                            anda    ,s
C77E  2604                            bne     30F
C780  8D08                            bsr     L_C78A
C782  2618                            bne     60F
C784  6AE4            30              dec     ,s
C786  26E3                            bne     20B
C788  3512                            puls    a,x

                                      ; fall through
C78A  8E062D          L_C78A          ldx     #ddos_buffers-sizeof_buffer
C78D  3007            40              leax    sizeof_buffer,x
C78F  BDD3E4                          jsr     L_D3E4
C792  2607                            bne     50F
C794  6F02                            clr     2,x
C796  8C0649                          cmpx    #ddos_buffers+(ddos_nbuffers-1)*sizeof_buffer
C799  26F2                            bne     40B
C79B  39              50              rts
C79C  3592            60              puls    a,x,pc
                      
C79E  81D5            BACKUP_dispatch cmpa    #$d5											; is token for 'DIR'?
C7A0  262A                            bne     40F											; no, jump to normal BACKUP
C7A2  8D89                            bsr     BACKUP_DIR									; execute copy between T16 and 20 as required
C7A4  2675                            bne     bas_err_C81B								; if error, show it
C7A6  39                              rts														; return
C7A7  8612            10              lda     #$12											; default value for sectors x track
C7A9  3272            L_C7A9          leas    -14,s										; make a 14 bytes hole in stack
C7AB  1F43                            tfr     s,u											; U points to base of hole data
C7AD  E7C4                            stb     ,u											; save source drive number in hole
C7AF  ED48                            std     8,u											; save sectors x track and source drive into hole
C7B1  1F30                            tfr     u,d											; get stack value
C7B3  4A                              deca													; leave 256 bytes 
C7B4  931F                            subd    bas_free_start							; subtract init of basic (calculate free space)
C7B6  4D                              tsta													; equal or more than 256 bytes?
C7B7  2204                            bhi     20F											; yes, skip next two
C7B9  C60C                            ldb     #$0c											; code for OM error (out of memory)
C7BB  200C                            bra     30F											; return
C7BD  A747            20              sta     7,u											; save number of sectors readables
C7BF  CCC51A                          ldd     #msg_insert_source-1					; point to "insert source" message
C7C2  ED41                            std     1,u											; save into stack hole
C7C4  CB0F                            addb    #$0f											; point to "insert destination" message
C7C6  ED4A                            std     10,u											; save into stack hole
C7C8  5F                              clrb													; Z=1, no error
C7C9  6EF80E          30              jmp     [$0e,s]										; equates return without moving S pointer
                                      															; in fact now the hole is 16 bytes instead of 14
C7CC  8D3A            40              bsr     get_opt_drive								; get drive argument (origin)
C7CE  8DD7                            bsr     10B											; fill values in stack hole
C7D0  2649                            bne     bas_err_C81B								; if error show it
C7D2  4F                              clra													; high byte = 0. Track number to begin with
C7D3  5C                              incb													; B=1. Sector number
C7D4  ED45                            std     5,u											; save in hole
C7D6  ED4E                            std     14,u											; again
C7D8  DC1F                            ldd     bas_free_start							; get beginning of free RAM
C7DA  ED43                            std     3,u											; put into hole
C7DC  ED4C                            std     12,u											; again
C7DE  9DA5                            jsr     bas_poll_char								; get next char
C7E0  2752                            beq     80F											; if no more params goto 80F
C7E2  81BC                            cmpa    #$bc											; is token for 'TO'?
C7E4  261F                            bne     sn_err_C805								; no, show error
C7E6  9D9F                            jsr     CHRGET										; read next char
C7E8  8D27                            bsr     get_drive_arg								; get drive (destination)
C7EA  E749                            stb     9,u											; save in stack hole
C7EC  8D30                            bsr     opt_comma_8bit							; is there param numSides?
C7EE  2744                            beq     80F											; if no char, goto 80F
C7F0  5A                              decb													; decrement numSides
C7F1  2705                            beq     50F											; if now is zero, goto 50F (requested 1)
C7F3  5A                              decb													; decrement again
C7F4  260F                            bne     sn_err_C805								; if not 0 it was > 2 so show error
C7F6  6848                            lsl     8,u											; double sectors x track in hole
C7F8  8D24            50              bsr     opt_comma_8bit							; is there numTracks param?
C7FA  2738                            beq     80F											; no, goto 80F
C7FC  3444                            pshs    b,u											; save registers
C7FE  BDC8DD                          jsr     L_C8DD										; validate numTracks 
C801  3544                            puls    b,u											; restore registers
C803  2731                            beq     90F											; if no errors, goto 90F
C805  7E89B4          sn_err_C805     jmp     bas_sn_error								; show SN error
                      
                      ; check for optional drive argument, otherwise return default
C808  9DA5            get_opt_drive   jsr     bas_poll_char								; getchar
C80A  2605            L_C80A          bne     get_drive_arg								; if not 0, get drive number
C80C  F6060A                          ldb     ddos_default_drive						; else get default drive (DEVD)
C80F  0EA5            60              jmp     bas_poll_char								; get char and return to caller
                      ;
                      ; get drive argument, DN error if invalid
C811  8D19            get_drive_arg   bsr     get_8bit									; get dest drive number
C813  2704                            beq     70F											; if 0, show error
C815  C104                            cmpb    #$04											; is 1-2-3-4?
C817  23F6                            bls     60B											; yes, goto 60B
C819  C628            70              ldb     #bas_err_DN								; error code for incorrect drive number
C81B  7E8344          bas_err_C81B    jmp     bas_system_error							; show error
                      
C81E  9DA5            opt_comma_8bit  jsr     bas_poll_char								; getchar
C820  2730                            beq     rts_C852									; if no char, return
C822  BD89AA                          jsr     CkComa										; jump over comma and get next char
C825  8D05            get_8bit_or_fc  bsr     get_8bit									; get needed chars and convert to number in B
C827  1027C362                        lbeq    bas_fc_error								; if 0, show error
C82B  39                              rts														; return
                      
C82C  3460            get_8bit        pshs    y,u											; save registers
C82E  BD8E51                          jsr     Get8Bit										; convert ASCII to number
C831  5D                              tstb													; test result
C832  35E0                            puls    y,u,pc										; restore registers and return
C834  C628            80              ldb     #$28											; default value for numTracks 
																											; it gets here with number of tracks in B

                      																	; SEEMS A GOOD POINT TO INTERCEPT
C836  A648            90              lda     8,u											; get sectors x track
C838  3D                              mul														; calculate total sectors of disk
C839  1F02                            tfr     d,y											; to Y counter
C83B  BDC8EE                          jsr     pmsg_sure_wkey_y							; show message and wait for Y to continue
C83E  26C5                            bne     sn_err_C805								; if not OK, show error
C840  33E4                            leau    ,s											; user stack point to system stack
C842  4F                              clra													; read sectors counter to 0

C843  3121            100             leay    1,y											; increment discNumTracks counter
C845  30C4                            leax    ,u											; X point to the stack base address
C847  8D6A                            bsr     L_C8B3										; if same drive, ask for source disk

C849  313F            110             leay    -1,y											; decrement counter
C84B  2606                            bne     120F											; if not yet 0, goto 120F
C84D  8D1D                            bsr     L_C86C										; control operation to perform next
C84F  32C810                          leas    $10,u										; clean stack
C852  39              rts_C852        rts														; return
                                      ;
C853  A147            120             cmpa    7,u											; filled all RAM sectors?
C855  260E                            bne     130F											; not yet, goto 130F
C857  8D13                            bsr     L_C86C										; control operation to perform next
C859  3406                            pshs    a,b											; save registers
C85B  DC1F                            ldd     bas_free_start							; get beginning of FREE RAM
C85D  ED4C                            std     12,u											; put in hole
C85F  ED43                            std     3,u											; again
C861  3506                            puls    a,b											; restore registers
C863  20DE                            bra     100B											; loopback to ask for source if needed
C865  C602            130             ldb     #$02											; command code for READ
C867  8D12                            bsr     L_C87B										; do operation
C869  4C                              inca													; increment read sectors counter
C86A  20DD                            bra     110B											; loopback to 110B
                      
C86C  4D              L_C86C          tsta													; is 0?
C86D  270B                            beq     rts_C87A									; yes, return
C86F  3049                            leax    9,u											; point to destination drive number in hole
C871  8D40                            bsr     L_C8B3										; if same drive, ask for destination drive
C873  C604                            ldb     #$04											; operation WRITE
C875  8D04            10              bsr     L_C87B										; apply operation
C877  4A                              deca													; decrement counter
C878  26FB                            bne     10B											; if not zero, loopback
C87A  39              rts_C87A        rts														; return
                      
C87B  3406            L_C87B          pshs    a,b											; save counter and command
C87D  A684                            lda     ,x											; get source drive number
C87F  97EB                            sta     DSKCOM_drive								; into system variable
C881  EC03                            ldd     3,x											; get 1st RAM byte to fill 
C883  DDEE                            std     DSKCOM_bufptr								; into system buffer pointer
C885  EC05                            ldd     5,x											; get track-sector numbers
C887  DDEC                            std     DSKCOM_track    							; into system variables
C889  E661                            ldb     1,s											; get command
C88B  BDC106                          jsr     L_C106										; execute requested operation
C88E                  bcs_bas_err_C88E
C88E  258B                            bcs     bas_err_C81B								; if error, show it
C890  6C06                            inc     6,x											; increment sector in hole
C892  A648                            lda     8,u											; get sectors x track
C894  A106                            cmpa    6,x											; have read all track sectors?
C896  2417                            bhs     30F											; no, go for next one
C898  C601                            ldb     #$01											; put value 1
C89A  E706                            stb     6,x											; as next sector to read
C89C  D7ED                            stb     DSKCOM_sector								; save B at system variable for sectorNumber
C89E  5C                              incb													; makes it equal 2
C89F  E161                            cmpb    1,s											; equals value in stack hole?
C8A1  270A                            beq     20F											; yes, exit via 20F
																											; VERIFIES all sectors of one track
C8A3  BDC0FB          10              jsr     test_sector								; reads/verifies that sector
C8A6  25E6                            bcs     bcs_bas_err_C88E							; if error, show it
C8A8  0CED                            inc     DSKCOM_sector								; increment sector counter
C8AA  4A                              deca													; decrement counter
C8AB  26F6                            bne     10B											; not yet 0, loopback
C8AD  6C05            20              inc     5,x											; increment track number
C8AF  6C03            30              inc     3,x											; increment RAM sector (1st byte of pointer)
C8B1  3586                            puls    a,b,pc										; restore registers and return
                      
C8B3  E6C4            L_C8B3          ldb     ,u											; get source drive number
C8B5  E149                            cmpb    9,u											; is the same as destination?
C8B7  26C1                            bne     rts_C87A									; no, return
                                      ;
C8B9  3472            L_C8B9          pshs    a,x,y,u										; save registers
C8BB  F70605                          stb     ddos_timeout_count						; put B at $605
C8BE  BDBA77                          jsr     bas_clear_screen							; clear text screen
C8C1  AE61                            ldx     1,s											; get "insert source" address (-1)
C8C3  AE01                            ldx     1,x										; WHAT DOES THIS????
C8C5  8D02                            bsr     pmsg_anykey_wkey_y						; show message and wait for key
C8C7  35F2                            puls    a,x,y,u,pc									; restore registers and return
                      
C8C9                  pmsg_anykey_wkey_y
C8C9  BD90E5                          jsr     bas_print_string							; show string
C8CC  8EC561                          ldx     #msg_press_any_key-1					; ask for a key
C8CF  2020                            bra     pstr_wkey_y								; wait for key and return
                      
C8D1                  DSKINIT_dispatch
hbreak *0xC8D1  8D2B                            bsr     L_C8FE
C8D3  1025BA6D                        lbcs    bas_system_error
C8D7  8E06AB          L_C8D7          ldx     #ddos_density
C8DA  7EC037                          jmp     L_C037
                      
																											; Detects non standard formats
C8DD  C128            L_C8DD          cmpb    #$28											; is 40 tracks?
C8DF  271C                            beq     rts_C8FD									; yes, ok, exit
C8E1  C150                            cmpb    #$50											; is 80 tracks?
C8E3  2718                            beq     rts_C8FD									; yes, ok, exit
C8E5  1F98                            tfr     b,a											; A gets numtracks
C8E7  8D3C                            bsr     L_C925									   ; show number
C8E9  8EC548                          ldx     #msg__track								; point to message
C8EC  2003                            bra     pstr_wkey_y								; show message and return
                      
C8EE                  pmsg_sure_wkey_y
C8EE  8EC448                          ldx     #msg_sure-1
                                      ; fall through
C8F1  BD90E5          pstr_wkey_y     jsr     bas_print_string
C8F4  BD852B          waitkey_y       jsr     bas_wait_key
C8F7  0F87                            clr     $0087
C8F9  84DF                            anda    #$df
C8FB  8159                            cmpa    #'Y
C8FD  39              rts_C8FD        rts
                      
C8FE  C610            L_C8FE          ldb     #$10
C900  81C6                            cmpa    #$c6											; is the token for '/'?
C902  2603                            bne     10F											; no, skip next two
C904  9D9F                            jsr     CHRGET										; get next char
C906  50                              negb													; b=$f0 (flag to leave T16 useable for DATA)
C907  D7E6            10              stb     $00e6
C909  BDC808                          jsr     get_opt_drive
C90C  D7EB                            stb     DSKCOM_drive
C90E  0FF4                            clr     DSKCOM_disktype
C910  BDC81E                          jsr     opt_comma_8bit
C913  271C                            beq     30F
C915  5A                              decb
C916  C101                            cmpb    #$01
C918  2310                            bls     20F
C91A  C6A4            rts_err_PR      ldb     #ddos_err_PR
C91C  1A01            sec_rts_C91C    orcc    #$01
C91E  39              rts_C91E        rts
                      
C91F  8610            L_C91F          lda     #$10											; place to write to on the text screen
C921  9789                            sta     bas_cursor_pos+1							; to the lower byte of screen address (column)
C923  96EC                            lda     DSKCOM_track								; get track number
                                      ; fall through
C925  DE8A            L_C925          ldu     bas_null									; gets 16 bit zero
C927  7EDCE4                          jmp     L_DCE4										; show track number and control break conditions
                      
C92A  D7F4            20              stb     DSKCOM_disktype
C92C  BDC81E                          jsr     opt_comma_8bit
C92F  2602                            bne     initialise_disk
C931  C628            30              ldb     #$28
C933  D7F2            initialise_disk stb     DSKCOM_buflen
C935  96EB                            lda     DSKCOM_drive
C937  8E06A2                          ldx     #ddos_ntracks-1
C93A  E786                            stb     a,x
C93C  8D9F                            bsr     L_C8DD
C93E  26DA                            bne     rts_err_PR
C940  BDC16A                          jsr     DSKCOM_read_address_s0
C943  C180                            cmpb    #ddos_err_NR
C945  27D5                            beq     sec_rts_C91C
C947  8E0800                          ldx     #$0800
C94A  9FEE                            stx     DSKCOM_bufptr
C94C  BDC0F6                          jsr     test_tr00_se03
C94F  C188                            cmpb    #ddos_err_RF
C951  2704                            beq     40F
C953  8D99                            bsr     pmsg_sure_wkey_y
C955  26C3                            bne     rts_err_PR
C957  BDBA77          40              jsr     bas_clear_screen
C95A  8EC53D                          ldx     #msg_formatting_track-1
C95D  BD90E5                          jsr     bas_print_string
C960  8DBD            50              bsr     L_C91F
C962  0FF3                            clr     DSKCOM_xferlen
C964  0FED                            clr     DSKCOM_sector
C966  BDCA16                          jsr     L_CA16
C969  25B3                            bcs     rts_C91E
C96B  0DF4                            tst     DSKCOM_disktype
C96D  2709                            beq     60F
C96F  0CF3                            inc     DSKCOM_xferlen
C971  0AED                            dec     DSKCOM_sector
C973  BDCA16                          jsr     L_CA16
C976  25A6                            bcs     rts_C91E
C978  0CEC            60              inc     DSKCOM_track
C97A  96EC                            lda     DSKCOM_track
C97C  91F2                            cmpa    DSKCOM_buflen
C97E  25E0                            blo     50B
C980  0AEC                            dec     DSKCOM_track
C982  DEEE                            ldu     DSKCOM_bufptr
C984  DC8A                            ldd     bas_null
C986  EDC1            70              std     ,u++
C988  11830A00                        cmpu    #$0a00
C98C  26F8                            bne     70B
C98E  CC890A                          ldd     #$890a
C991  A7C4            80              sta     ,u
C993  33C819                          leau    $19,u
C996  5A                              decb
C997  26F8                            bne     80B
C999  8E08FA                          ldx     #$08fa
C99C  96E6                            lda     $00e6
C99E  A701                            sta     1,x
C9A0  96F2                            lda     DSKCOM_buflen
C9A2  C612                            ldb     #$12
C9A4  0DF4                            tst     DSKCOM_disktype
C9A6  2701                            beq     90F
C9A8  58                              lslb
C9A9  ED02            90              std     2,x
C9AB  43                              coma
C9AC  53                              comb
C9AD  ED04                            std     4,x
C9AF  C606                            ldb     #$06
C9B1  8D60                            bsr     cpxub_CA13
                                      ; the value $0168 also *happens* to be the destination
                                      ; address of the chrout hook, and is used for indirection
                                      ; elsewhere
C9B4                  L_C9B4          equ     *+1
C9B3  CC0168                          ldd     #$0168          ; TR20 SE01 (single-sided0
C9B6  8E0634                          ldx     #ddos_buffers
C9B9  ED84                            std     buffer_lsn,x
C9BB  5C                              incb
C9BC  ED07                            std     buffer_lsn+sizeof_buffer,x
C9BE  DCEA                            ldd     DSKCOM_command  ; b = DSKCOM_drive
C9C0  ED02                            std     buffer_in_use,x
C9C2  ED09                            std     buffer_in_use+sizeof_buffer,x
C9C4  0F89                            clr     bas_cursor_pos+1
C9C6  8EDFF6                          ldx     #msg___check-1
C9C9  BD90E5                          jsr     bas_print_string

; =============================================================================================================================================

C9CC  BDC91F          100             jsr     L_C91F										; show track number ($ec) and control break conditions
C9CF  B608FD                          lda     $08fd										; get number of sectors x track
C9D2  0FED                            clr     DSKCOM_sector								; sector number to 0
C9D4  0CED            110             inc     DSKCOM_sector								; increment sector number to process ($ed)
C9D6  BDC0FB                          jsr     test_sector								; read-verify that sector
C9D9  2537                            bcs     rts_CA12									; if error, return
C9DB  4A                              deca													; decrement sector counter
C9DC  26F6                            bne     110B											; if not 0, loopback

C9DE  BDD14E                          jsr     L_D14E										; here the track number can be wrecked
C9E1  0AEC                            dec     DSKCOM_track								; decrement track counter ($ec)
C9E3  2AE7                            bpl     100B											; if not negative, loopback (works from N down to 0 included)

; =============================================================================================================================================

																											; here begins the Directory track process
C9E5  8614                            lda     #$14											; directory track number
C9E7  97EC                            sta     DSKCOM_track								; to variable
C9E9  108EC0FE                        ldy     #write_sector								; point to write_sector function
C9ED  8D04                            bsr     120F											; write track
C9EF  2521                            bcs     rts_CA12									; if error, return
C9F1  313D                            leay    -3,y            							; point to test_sector function

																											; this routine processes all directory tracks (the 2 FAT and 16 dir sectors)
C9F3  8E0800          120             ldx     #$0800										; point to 1st buffer
C9F6  9FEE                            stx     DSKCOM_bufptr								; save it to $ee
C9F8  0FED                            clr     DSKCOM_sector								; put 0 in $ed (sector)
C9FA  8D0E                            bsr     L_CA0A										; write FAT 1st sector
C9FC  0CEE                            inc     DSKCOM_bufptr								; pass to next buffer ($0900)
C9FE  8D0A                            bsr     L_CA0A										; write FAT 2nd sector
CA00  0CEE                            inc     DSKCOM_bufptr								; pass to next buffer ($0a00)
CA02  8610                            lda     #$10											; ready for 16 sectors
CA04  8D04            10              bsr     L_CA0A										; write one
CA06  4A                              deca													; decrement counter
CA07  26FB                            bne     10B											; loop back if not all done
CA09  39                              rts														; return
                      
CA0A  0CED            L_CA0A          inc     DSKCOM_sector								; increments sector
CA0C  ADA4                            jsr     ,y											; gosub ,Y
CA0E  2402                            bcc     rts_CA12									; if no error return
CA10  3262                            leas    2,s											; clear return address (stop writting to dir sectors)
CA12  39              rts_CA12        rts														; return one level upper
                      
CA13  7EB7CC          cpxub_CA13      jmp     bas_cpxub
                      
CA16  DEEE            L_CA16          ldu     DSKCOM_bufptr
CA18  8EC37A                          ldx     #fmt_track_pre
CA1B  311F                            leay    -1,x            ; y = fmt_interleave
CA1D  C60C                            ldb     #$0c
CA1F  8DF2                            bsr     cpxub_CA13
CA21  8EC386          10              ldx     #fmt_sector_pre
CA24  C606                            ldb     #$06
CA26  8DEB                            bsr     cpxub_CA13
CA28  8601                            lda     #$01
CA2A  D6EC                            ldb     DSKCOM_track
CA2C  EDC1                            std     ,u++
CA2E  D6F3                            ldb     DSKCOM_xferlen
CA30  E7C0                            stb     ,u+
CA32  E6A4                            ldb     ,y
CA34  EDC1                            std     ,u++
CA36  A7C0                            sta     ,u+
CA38  C612                            ldb     #$12
CA3A  8DD7                            bsr     cpxub_CA13
CA3C  6DA2                            tst     ,-y
CA3E  26E1                            bne     10B
CA40  C603                            ldb     #$03
CA42  8DCF                            bsr     cpxub_CA13
CA44  BDC167                          jsr     DSKCOM_seek
CA47  25C9                            bcs     rts_CA12
CA49  C605                            ldb     #fdop_write_track
CA4B  7EC16C                          jmp     DSKCOM_B
                      
CA4E  8E06BD          L_CA4E          ldx     #ddos_fcbs
CA51  0FF1                            clr     DSKCOM_fcb
CA53  0CF1            10              inc     DSKCOM_fcb
CA55  CE0650                          ldu     #ddos_cur_drive_info
CA58  1F12                            tfr     x,y
CA5A  C60C                            ldb     #$0c
CA5C  A6C0            20              lda     ,u+
CA5E  A1A0                            cmpa    ,y+
CA60  2604                            bne     30F
CA62  5A                              decb
CA63  26F7                            bne     20B
CA65  39                              rts
CA66  30881F          30              leax    sizeof_fcb,x
CA69  8C07E9                          cmpx    #$07e9
CA6C  25E5                            blo     10B
CA6E  39                              rts
                      
CA6F  C60A            find_free_fcb   ldb     #$0a
CA71  D7F1                            stb     DSKCOM_fcb
CA73  8E07F3                          ldx     #ddos_fcbs_end
CA76  3088E1          10              leax    -sizeof_fcb,x
CA79  6D84                            tst     ,x              ; fcb_file_name[0]
CA7B  2706                            beq     rts_CA83
CA7D  0AF1                            dec     DSKCOM_fcb
CA7F  26F5                            bne     10B
CA81  C6A2                            ldb     #ddos_err_TF
CA83  39              rts_CA83        rts
                      
                                      ; $c084 XXX coverage - this ever called?
CA84                  validate_and_open
CA84  BDD772                          jsr     validate_filename
CA87  26FA                            bne     rts_CA83
                      
                                      ; copy dir ent to file control block
CA89  8DC3            open_file       bsr     L_CA4E
CA8B  2607                            bne     10F
CA8D  6D0F                            tst     15,x
CA8F  2A4B                            bpl     80F
CA91  5F                              clrb
CA92  202C                            bra     50F
CA94  B6067D          10              lda     ddos_067D
CA97  270B                            beq     20F
CA99  810B                            cmpa    #$0b
CA9B  2407                            bhs     20F
CA9D  BDDF40                          jsr     L_DF40
CAA0  6D84                            tst     ,x
CAA2  2704                            beq     L_CAA8
CAA4  8DC9            20              bsr     find_free_fcb
CAA6  26DB                            bne     rts_CA83
                                      ;
CAA8  C60C            L_CAA8          ldb     #$0c
CAAA  3384                            leau    ,x      ; u -> fcb
CAAC  BDD239                          jsr     copy_cur_drive_info_to_u
CAAF  1E89                            exg     a,b
CAB1  BDDBA5                          jsr     L_DBA5
CAB4  6C05                            inc     drive_num_open_files,x
CAB6  C612                            ldb     #$12
CAB8  6FC5            30              clr     b,u
CABA  5A                              decb
CABB  2AFB                            bpl     30B
CABD  E743                            stb     3,u
CABF  5C              40              incb
CAC0  F70681          50              stb     ddos_0681
CAC3  BDD315                          jsr     GETDIR
CAC6  26BB                            bne     rts_CA83
CAC8  A684                            lda     ,x
CACA  8581                            bita    #$81
CACC  271B                            beq     110F
CACE  8508                            bita    #$08
CAD0  2607                            bne     70F
CAD2  F60681          60              ldb     ddos_0681
CAD5  C19F                            cmpb    #$9f
CAD7  25E6                            blo     40B
CAD9  BDDF42          70              jsr     L_DF42
CADC  300C            80              leax    12,x
CADE  5F              90              clrb
CADF  6D03                            tst     3,x
CAE1  2A02                            bpl     100F
CAE3  C6A0                            ldb     #$a0
CAE5  96F1            100             lda     DSKCOM_fcb
CAE7  5D                              tstb
CAE8  39                              rts
                                      ;
CAE9  3101            110             leay    1,x
CAEB  BDDF42                          jsr     L_DF42
CAEE  C60B                            ldb     #$0b
CAF0  A680            120             lda     ,x+
CAF2  A1A0                            cmpa    ,y+
CAF4  26DC                            bne     60B
CAF6  5A                              decb
CAF7  26F7                            bne     120B
CAF9  3001                            leax    1,x
CAFB  B60681                          lda     ddos_0681
CAFE  A78811                          sta     $11,x
CB01  ECA4                            ldd     ,y
CB03  ED09                            std     9,x
CB05  EC24                            ldd     4,y
CB07  ED0F                            std     15,x
CB09  EC22                            ldd     2,y
CB0B  ED0D                            std     13,x
CB0D  5F                              clrb
CB0E  ED0B                            std     11,x
CB10  4F                              clra
CB11  ED07                            std     7,x
CB13  43                              coma
CB14  53                              comb
CB15  ED05                            std     5,x
CB17  A634                            lda     -12,y
CB19  ED03                            std     3,x
CB1B  20C1                            bra     90B
                      
                                      ; read data from file to memory
CB1D  97F1            read_file       sta     DSKCOM_fcb
CB1F  4F                              clra													; value for READ
CB20  8C                              fcb     $8c     									; cmpx - comment byte
CB21  8601            L_CB21          lda     #$01    									; possibly skipped --- comes here if write VERIFY is OFF
CB23  8C                              fcb     $8c     									; cmpx - comment byte
CB24  86FF            L_CB24          lda     #$ff    									; possibly skipped --- comes here if write VERIFY is ON
CB26  97F5            L_CB26          sta     DSKCOM_rwv_flag							; store at read-write-verify system variable ($00 = READ)
CB28  10BF0661                        sty     ddos_0661
CB2C  277C                            beq     L_CBAA
CB2E  FF0669                          stu     ddos_0669
CB31  F70663                          stb     ddos_0663
CB34  3410                            pshs    x
CB36  BDDF42                          jsr     L_DF42
CB39  A60B                            lda     11,x
CB3B  97EB                            sta     DSKCOM_drive
CB3D  0DF5                            tst     DSKCOM_rwv_flag							; has value READ ($00))?
CB3F  260B                            bne     20F											; no, goto 20F
CB41  FC0661                          ldd     ddos_0661
CB44  E30D                            addd    13,x
CB46  2402                            bcc     10F
CB48  6C0C                            inc     12,x
CB4A  ED0D            10              std     13,x
CB4C  3510            20              puls    x
CB4E  F60663                          ldb     ddos_0663
CB51  4F              L_CB51          clra
CB52  50                              negb
CB53  2601                            bne     40F
CB55  4C                              inca
CB56  10B30661        40              cmpd    ddos_0661
CB5A  2303                            bls     50F
CB5C  FC0661                          ldd     ddos_0661
CB5F  3416            50              pshs    a,b,x
CB61  FE0669                          ldu     ddos_0669
CB64  BDCC0E                          jsr     L_CC0E
CB67  260E                            bne     L_CB77
CB69  1F02                            tfr     d,y
CB6B  A60F                            lda     15,x
CB6D  8502                            bita    #$02
CB6F  2709                            beq     70F
CB71  0DF5                            tst     DSKCOM_rwv_flag							; has value READ ($00)?
CB73  2705                            beq     70F											; yes, goto 70F
CB75  C698                            ldb     #$98											; code for Protection error (PT) (?)
CB77  3264            L_CB77          leas    4,s											; clean stack
CB79  39                              rts														; return with Z=0
                                      ;
CB7A  AE62            70              ldx     2,s
CB7C  6D61                            tst     1,s
CB7E  262C                            bne     120F
CB80  0DF5                            tst     DSKCOM_rwv_flag							; has value READ ($00)?
CB82  2707                            beq     80F											; yes, goto 80F
CB84  2A0A                            bpl     90F											; if not $FF, goto 90F (verify OFF)
CB86  BDD3D1                          jsr     verify_lsn									; verify (=$FF)									
CB89  2008                            bra     100F											; go test result
CB8B  BDD3D6          80              jsr     read_lsn									; read
CB8E  2003                            bra     100F											; skip next
CB90  BDD3D3          90              jsr     write_lsn									; write
CB93  26E2            100             bne     L_CB77
CB95  6C62                            inc     2,s
CB97  BE0669                          ldx     ddos_0669
CB9A  3001                            leax    1,x
CB9C  BF0669                          stx     ddos_0669
CB9F  7A0661                          dec     ddos_0661
CBA2  FC0661                          ldd     ddos_0661
CBA5  3516                            puls    a,b,x
CBA7  26A8                            bne     L_CB51
CBA9  39                              rts
                                      ;
CBAA  5F              L_CBAA          clrb
CBAB  39                              rts
                                      ;
CBAC  0DF5            120             tst     DSKCOM_rwv_flag							; is value $FF (ON)?
CBAE  2B41                            bmi     160F											; yes, goto 160F
CBB0  BDD36B                          jsr     buf_read_sector
CBB3  26C2                            bne     L_CB77
CBB5  BF0667                          stx     ddos_0667
CBB8  10AE62                          ldy     2,s
CBBB  F60663                          ldb     ddos_0663
CBBE  0DF5                            tst     DSKCOM_rwv_flag							; is it READ?
CBC0  2723                            beq     140F											; yes, goto 140F
CBC2  86FF                            lda     #$ff
CBC4  A702                            sta     2,x
CBC6  AE05                            ldx     5,x
CBC8  3A                              abx
CBC9  E661                            ldb     1,s
CBCB  A6A0            130             lda     ,y+
CBCD  A780                            sta     ,x+
CBCF  5A                              decb
CBD0  26F9                            bne     130B
CBD2  1F10                            tfr     x,d
CBD4  5D                              tstb
CBD5  261A                            bne     160F
CBD7  BE0667                          ldx     ddos_0667
CBDA  3420                            pshs    y
CBDC  BDD3E4                          jsr     L_D3E4
CBDF  3520                            puls    y
CBE1  2694                            bne     L_CB77
CBE3  200C                            bra     160F
CBE5  AE05            140             ldx     5,x
CBE7  3A                              abx
CBE8  E661                            ldb     1,s
CBEA  A680            150             lda     ,x+
CBEC  A7A0                            sta     ,y+
CBEE  5A                              decb
CBEF  26F9                            bne     150B
CBF1  BE0669          160             ldx     ddos_0669
CBF4  3001                            leax    1,x
CBF6  BF0669                          stx     ddos_0669
CBF9  1F21                            tfr     y,x
CBFB  FC0661                          ldd     ddos_0661
CBFE  A3E1                            subd    ,s++
CC00  FD0661                          std     ddos_0661
CC03  3262                            leas    2,s
CC05  27A3                            beq     L_CBAA
CC07  7F0663                          clr     ddos_0663
CC0A  5F                              clrb
CC0B  16FF43                          lbra    L_CB51
                      
CC0E  BDDF42          L_CC0E          jsr     L_DF42
CC11  1F30            10              tfr     u,d
CC13  A38813                          subd    $13,x
CC16  250D                            blo     20F
CC18  4D                              tsta
CC19  260A                            bne     20F
CC1B  E18817                          cmpb    $17,x
CC1E  2405                            bhs     20F
CC20  E38815                          addd    $15,x
CC23  2012                            bra     30F
CC25  1F30            20              tfr     u,d
CC27  A38818                          subd    $18,x
CC2A  250E                            blo     40F
CC2C  4D                              tsta
CC2D  260B                            bne     40F
CC2F  E1881C                          cmpb    $1c,x
CC32  2406                            bhs     40F
CC34  E3881A                          addd    $1a,x
CC37  1A04            30              orcc    #$04
CC39  39                              rts
CC3A  3440            40              pshs    u
CC3C  8D3E                            bsr     L_CC7C
CC3E  260B                            bne     50F
CC40  FC066B                          ldd     ddos_066B
CC43  10B3066D                        cmpd    ddos_066D
CC47  2204                            bhi     60F
CC49  C69A                            ldb     #$9a
CC4B  35C0            50              puls    u,pc
CC4D  E022            60              subb    2,y
CC4F  8200                            sbca    #$00
CC51  ED8813                          std     $13,x
CC54  A622                            lda     2,y
CC56  A78817                          sta     $17,x
CC59  ECA4                            ldd     ,y
CC5B  ED8815                          std     $15,x
CC5E  1F20                            tfr     y,d
CC60  3440                            pshs    u
CC62  A3E1                            subd    ,s++
CC64  3540                            puls    u
CC66  C113                            cmpb    #$13
CC68  2410                            bhs     70F
CC6A  A625                            lda     5,y
CC6C  A7881C                          sta     $1c,x
CC6F  EC23                            ldd     3,y
CC71  ED881A                          std     $1a,x
CC74  FC066B                          ldd     ddos_066B
CC77  ED8818                          std     $18,x
CC7A  2095            70              bra     10B
                      
CC7C  DC8A            L_CC7C          ldd     bas_null
CC7E  FD066B                          std     ddos_066B
CC81  FF066D                          stu     ddos_066D
CC84  E6881D                          ldb     $1d,x
CC87  F70682                          stb     ddos_0682
CC8A  8D35                            bsr     L_CCC1
CC8C  314C                            leay    12,u
CC8E  C604                            ldb     #$04
CC90  A6C4            10              lda     ,u
CC92  8420                            anda    #$20
CC94  2703                            beq     20F
CC96  A6C818                          lda     $18,u
CC99  3406            20              pshs    a,b
CC9B  4F              30              clra
CC9C  E622                            ldb     2,y
CC9E  F3066B                          addd    ddos_066B
CCA1  FD066B                          std     ddos_066B
CCA4  10B3066D                        cmpd    ddos_066D
CCA8  2225                            bhi     50F
CCAA  3123                            leay    3,y
CCAC  6A61                            dec     1,s
CCAE  26EB                            bne     30B
CCB0  E6E4                            ldb     ,s
CCB2  2719                            beq     40F
CCB4  3262                            leas    2,s
CCB6  F70682                          stb     ddos_0682
CCB9  8D06                            bsr     L_CCC1
CCBB  3141                            leay    1,u
CCBD  C607                            ldb     #$07
CCBF  20CF                            bra     10B
                                      ;
CCC1  3410            L_CCC1          pshs    x
CCC3  BDD315                          jsr     GETDIR
CCC6  1F13                            tfr     x,u
CCC8  3510                            puls    x
CCCA  2604                            bne     60F
CCCC  39                              rts
                                      ;
CCCD  313D            40              leay    -3,y
CCCF  5F              50              clrb
CCD0  3262            60              leas    2,s
CCD2  39              rts_CCD2        rts
                      
CCD3  BDDACF          COPY_dispatch   jsr     L_DACF
CCD6  4F                              clra
CCD7  BDC7A9                          jsr     L_C7A9
CCDA  262D                            bne     bas_err_CD09
CCDC  9DA5                            jsr     bas_poll_char
CCDE  81C6                            cmpa    #$c6
CCE0  260B                            bne     10F
CCE2  9D9F                            jsr     CHRGET
CCE4  63C4                            com     ,u
CCE6  30E4                            leax    ,s
CCE8  C601                            ldb     #$01
CCEA  BDC8B9                          jsr     L_C8B9
CCED  BDD744          10              jsr     L_D744
CCF0  2617                            bne     bas_err_CD09
CCF2  A766                            sta     6,s
CCF4  BDDF0A                          jsr     LENFIL
CCF7  2610                            bne     bas_err_CD09
CCF9  6084                            neg     ,x
CCFB  BDDB52                          jsr     assert_TO_tok
CCFE  8D0C                            bsr     L_CD0C
CD00  BDD744                          jsr     L_D744
CD03  2720                            beq     20F
CD05  C1A0                            cmpb    #$a0
CD07  271C                            beq     20F
CD09  7E8344          bas_err_CD09    jmp     bas_system_error
                                      ;
CD0C  306B            L_CD0C          leax    11,s
CD0E  6D62            L_CD0E          tst     2,s
CD10  27C0                            beq     rts_CCD2
CD12  C601                            ldb     #$01
CD14  BDC8B9                          jsr     L_C8B9
CD17  3442                            pshs    a,u
CD19  96EB                            lda     DSKCOM_drive
CD1B  BDDB07                          jsr     L_DB07
CD1E  BDD2C2                          jsr     L_D2C2
CD21  26E6                            bne     bas_err_CD09
CD23  35C2                            puls    a,u,pc
                                      ;
CD25  A769            20              sta     9,s
CD27  BDD079                          jsr     create_file
CD2A  26DD            30              bne     bas_err_CD09
CD2C  A666                            lda     6,s
CD2E  BDDF40                          jsr     L_DF40
CD31  300C                            leax    12,x
CD33  6D14                            tst     -12,x
CD35  2A02                            bpl     40F
CD37  6014                            neg     -12,x
CD39  EC84            40              ldd     ,x
CD3B  10A304                          cmpd    4,x
CD3E  2506                            blo     50F
CD40  A602                            lda     2,x
CD42  A106                            cmpa    6,x
CD44  2750                            beq     80F
CD46  EE84            50              ldu     ,x
CD48  A602                            lda     2,x
CD4A  A765                            sta     5,s
CD4C  EF63                            stu     3,s
CD4E  EC67                            ldd     7,s
CD50  E364                            addd    4,s
CD52  ED64                            std     4,s
CD54  2402                            bcc     60F
CD56  6C63                            inc     3,s
CD58  A663            60              lda     3,s
CD5A  A004                            suba    4,x
CD5C  250C                            blo     70F
CD5E  EC64                            ldd     4,s
CD60  A305                            subd    5,x
CD62  2306                            bls     70F
CD64  EC05                            ldd     5,x
CD66  A301                            subd    1,x
CD68  ED67                            std     7,s
CD6A  A602            70              lda     2,x
CD6C  EE84                            ldu     ,x
CD6E  30E4                            leax    ,s
CD70  8D9C                            bsr     L_CD0E
CD72  1F89                            tfr     a,b
CD74  A666                            lda     6,s
CD76  10AE67                          ldy     7,s
CD79  9E1F                            ldx     bas_free_start
CD7B  BDCB1D                          jsr     read_file
CD7E                  bne_bas_err_CD7E
CD7E  2689                            bne     bas_err_CD09
CD80  8D8A                            bsr     L_CD0C
CD82  A669                            lda     9,s
CD84  BDDF40                          jsr     L_DF40
CD87  300C                            leax    12,x
CD89  10AE04                          ldy     4,x
CD8C  E606                            ldb     6,x
CD8E  EE67                            ldu     7,s
CD90  9E1F                            ldx     bas_free_start
CD92  8D0B                            bsr     write_file
CD94  2094                            bra     30B
CD96  BDDACF          80              jsr     L_DACF
CD99  26E3                            bne     bne_bas_err_CD7E
CD9B  32E810                          leas    $10,s
CD9E  39                              rts
                      
                                      ; write data from memory to file, verify if on
CD9F  BF0671          write_file      stx     ddos_0671									; save received parameters
CDA2  FF0673                          stu     ddos_0673									;
CDA5  10BF0675                        sty     ddos_0675									;
CDA9  F70677                          stb     ddos_0677									;
CDAC  BDDF40                          jsr     L_DF40										; get FIB address in X
CDAF  E60B                            ldb     11,x											; get drive number
CDB1  D7EB                            stb     DSKCOM_drive								; put in variable ($eb)
CDB3  BDDF0A          10              jsr     LENFIL										; get LOF									
CDB6  270C                            beq     20F											; if OK, goto 20F
CDB8  C19C                            cmpb    #$9c
CDBA  2617                            bne     rts_CDD3
CDBC  96F1                            lda     DSKCOM_fcb
CDBE  BDD079                          jsr     create_file
CDC1  27F0                            beq     10B
CDC3  39                              rts
CDC4  11B30675        20              cmpu    ddos_0675									; sector in U > sector received Y?
CDC8  220A                            bhi     40F											; yes goto 40F
CDCA  2505                            blo     30F											; if lower, show error
CDCC  B10677                          cmpa    ddos_0677									; bytes in A >= bytes received B?
CDCF  2403                            bhs     40F											; yes, goto 40F
CDD1  C69A            30              ldb     #$9a											; code for Read Past End error
CDD3  39              rts_CDD3        rts														; return
CDD4  3402            40              pshs    a												; save bytes LS
CDD6  FC0673                          ldd     ddos_0673									; get 2 lower bytes of initial address
CDD9  F30676                          addd    ddos_0675+1								; add 2 lower bytes of LOF
CDDC  3404                            pshs    b												; save calculated bytes
CDDE  1F89                            tfr     a,b											; save bytes LS in reg B
CDE0  B60675                          lda     ddos_0675									; get higher byte of LOF
CDE3  8900                            adca    #$00											; apply carry
CDE5  3440                            pshs    u												; stack U to
CDE7  A3E1                            subd    ,s++											; subtract from D
CDE9  1F98                            tfr     b,a											; restore bytes LS
CDEB  3504                            puls    b												; restore calculated bytes
CDED  2227                            bhi     60F											; if D > U, goto 60F
CDEF  2504                            blo     50F											; if D < U, goto 50F
CDF1  E0E4                            subb    ,s											; substract saved bytes LS
CDF3  2425                            bcc     70F											; if not carry, goto 70F
CDF5  3261            50              leas    1,s											; clean stack
CDF7  8ECB21                          ldx     #L_CB21										; return point if verify OFF
CDFA  7D0608                          tst     ddos_verify_flag							; is verify OFF ($FF)?
CDFD  2607                            bne     L_CE06										; yes, goto L_CE06
CDFF  8D05                            bsr     L_CE06										; gosub L_CE06, so come back
CE01  26D0                            bne     rts_CDD3									; if received B was NOT zero, return
CE03  8ECB24                          ldx     #L_CB24										; else set return point for next routine, verify ON
                                      ;
CE06  3410            L_CE06          pshs    x												; sets the return address on the stack (L_CB21 or L_CB24)
CE08  BE0671                          ldx     ddos_0671									; restore received registers
CE0B  10BE0673                        ldy     ddos_0673									;
CE0F  FE0675                          ldu     ddos_0675									;
CE12  F60677                          ldb     ddos_0677									; restore received B register. Sets/Clears zero flag
CE15  39                              rts														; equals jmp ,X (received and pushed register)
                                      ;
CE16  E0E4            60              subb    ,s											; substract saved bytes LS
CE18  8200                            sbca    #$00											; affect carry/borrow to A
CE1A  8D04            70              bsr     L_CE20
CE1C  27D7                            beq     50B
CE1E  3582                            puls    a,pc
                      
CE20  3272            L_CE20          leas    -14,s
CE22  EDE4                            std     ,s
CE24  ED6A                            std     10,s
CE26  8601                            lda     #$01
CE28  97F6                            sta     DSKCOM_timeout							; IRQ lock out
CE2A  BDD2C2                          jsr     L_D2C2
CE2D  260B                            bne     10F											; if error, clean stack and return
CE2F  AF68                            stx     8,s											; save pointer to drive info
CE31  BDDF42                          jsr     L_DF42										; calculate FIB address in X
CE34  E6881E                          ldb     $1e,x										; get number of last dir entry in use
CE37  BDD315                          jsr     GETDIR										; load dir sector with that entry in a buffer
CE3A  266C            10              bne     70F											; if error, clean stack and return
CE3C  AF64                            stx     4,s											; save dir entry pointer
CE3E  EF6C                            stu     12,s											; save I/O buffer pointer
CE40  8619                            lda     #$19											; put value 25
CE42  A742                            sta     2,u											; at flags byte in I/O buffer
CE44  4F                              clra													; high byte to 0
CE45  E68818                          ldb     $18,x										; get bytes in last sector of entry
CE48  2601                            bne     20F											; if not 0, skip next
CE4A  4C                              inca													; increment high byte (=256 bytes)
CE4B  E3E4            20              addd    ,s											; add header length
CE4D  5D                              tstb													; is last byte 0?
CE4E  2601                            bne     30F											; no, skip next
CE50  4A                              deca													; decrement high byte
CE51  EDE4            30              std     ,s											; update value in stack
CE53  4D                              tsta													; is high byte 0?
CE54  2758                            beq     80F											; yes, goto 80F
CE56  C604                            ldb     #$04											; number of extents
CE58  310C                            leay    12,x											; point to 1st extent 
CE5A  A684                            lda     ,x											; get entry flags
CE5C  8501                            bita    #$01											; is it an extension?
CE5E  2704                            beq     40F											; no, goto 40F
CE60  3101                            leay    1,x											; point to 1st extent
CE62  C607                            ldb     #$07											; number of extents in this case
CE64  6D22            40              tst     2,y											; are there sectors?
CE66  2612                            bne     50F											; no, end of data
CE68  CCFFFF                          ldd     #$ffff										; put $FFFF
CE6B  ED66                            std     6,s											; in stack
CE6D  313D                            leay    -3,y											; point to file extension (BIN)
CE6F  10AF62                          sty     2,s											; save it
CE72  AE68                            ldx     8,s											; get I/O bufer pointer
CE74  6D02                            tst     2,x											; test frelen
CE76  2674                            bne     130F											; if not 0, goto 130F
CE78  2063                            bra     110F											; else goto 110F
CE7A  6D22            50              tst     2,y
CE7C  2705                            beq     60F
CE7E  3123                            leay    3,y
CE80  5A                              decb
CE81  26F7                            bne     50B
CE83  313D            60              leay    -3,y
CE85  4F                              clra
CE86  E622                            ldb     2,y
CE88  E3A4                            addd    ,y
CE8A  ED66                            std     6,s
CE8C  10AF62                          sty     2,s
CE8F  AE68                            ldx     8,s
CE91  6D02                            tst     2,x
CE93  2748                            beq     110F
CE95  EC66                            ldd     6,s
CE97  A303                            subd    3,x
CE99  2764                            beq     150F
CE9B  BDCF57                          jsr     200F
CE9E  2774                            beq     170F
CEA0  C194                            cmpb    #$94
CEA2  2748                            beq     130F
                                      ;
CEA4  EE6C            L_CEA4          ldu     12,s
CEA6  6342                            com     2,u
CEA8  326E            70              leas    14,s
CEAA  0FF6                            clr     DSKCOM_timeout
CEAC  5D                              tstb
CEAD  39                              rts
                                      ;
CEAE  EE64            80              ldu     4,s
CEB0  BDDF42                          jsr     L_DF42
CEB3  EC6A                            ldd     10,s
CEB5  E38811                          addd    $11,x
CEB8  2403                            bcc     90F
CEBA  6C8810                          inc     $10,x
CEBD  ED8811          90              std     $11,x
CEC0  E7C818                          stb     $18,u
CEC3  5F                              clrb
CEC4  20DE                            bra     L_CEA4
CEC6  A722            100             sta     2,y
CEC8  A602                            lda     2,x
CECA  A0E4                            suba    ,s
CECC  A702                            sta     2,x
CECE  4F                              clra
CECF  E6E4                            ldb     ,s
CED1  E303                            addd    3,x
CED3  ED03                            std     3,x
CED5  A661                            lda     1,s
CED7  A0E0                            suba    ,s+
CED9  A7E4                            sta     ,s
CEDB  27D1                            beq     80B

CEDD  8D78            110             bsr     200F
CEDF  26C3            120             bne     L_CEA4
CEE1  AE68                            ldx     8,s
CEE3  EF03                            stu     3,x
CEE5  A702                            sta     2,x
CEE7  11A366                          cmpu    6,s
CEEA  2713                            beq     150F
CEEC  EC62            130             ldd     2,s
CEEE  1F02                            tfr     d,y
CEF0  A364                            subd    4,s
CEF2  C113                            cmpb    #$13
CEF4  242D                            bhs     180F
CEF6  3123                            leay    3,y
CEF8  10AF62                          sty     2,s
CEFB  EC03            140             ldd     3,x
CEFD  EDA4                            std     ,y
CEFF  A6E4            150             lda     ,s
CF01  A102                            cmpa    2,x
CF03  2502                            blo     160F
CF05  A602                            lda     2,x
CF07  10AE62          160             ldy     2,s
CF0A  3402                            pshs    a
CF0C  AB22                            adda    2,y
CF0E  24B6                            bcc     100B
CF10  3502                            puls    a
CF12  20D8                            bra     130B
CF14  AE68            170             ldx     8,s
CF16  3442                            pshs    a,u
CF18  E602                            ldb     2,x
CF1A  AE03                            ldx     3,x
CF1C  BDD185                          jsr     L_D185
CF1F  3542                            puls    a,u
CF21  20BC                            bra     120B
CF23  4C              180             inca
CF24  BDD278                          jsr     L_D278
CF27  26B6                            bne     120B
CF29  10AE64                          ldy     4,s
CF2C  A7A818                          sta     $18,y
CF2F  E6A4                            ldb     ,y
CF31  CA20                            orb     #$20
CF33  E7A4                            stb     ,y
CF35  EF64                            stu     4,s
CF37  C619                            ldb     #$19
CF39  31C5                            leay    b,u
CF3B  EE6C                            ldu     12,s
CF3D  6342                            com     2,u
CF3F  E702                            stb     2,x
CF41  AF6C                            stx     12,s
CF43  BDDF42                          jsr     L_DF42
CF46  A7881E                          sta     $1e,x
CF49  6FA2            190             clr     ,-y
CF4B  5A                              decb
CF4C  26FB                            bne     190B
CF4E  6CA0                            inc     ,y+
CF50  10AF62                          sty     2,s
CF53  AE68                            ldx     8,s
CF55  20A4                            bra     140B

CF57  10FF0601        200             sts     ddos_tmp1					; save stack pointer
CF5B  3277                            leas    -9,s							; 9 bytes hole
CF5D  6F64                            clr     4,s							; clear 5th byte
CF5F  BDD2C2                          jsr     L_D2C2						;
CF62  102600E6                        lbne    rts_stmp_D04C				; if error goto rts_stmp_D04C
CF66  3194                            leay    [,x]							; get dir LSN for drive
CF68  EEE811                          ldu     $11,s						; get the pushed $FFFF
CF6B  EF65                            stu     5,s							; save here
CF6D  3041                            leax    1,u							; increment value
CF6F  270F                            beq     210F							; if it was $FFFF, goto 210F
CF71  8D6D                            bsr     bra_D052_CFE0
CF73  2637                            bne     260F
CF75  118305A0                        cmpu    #$05a0
CF79  2505                            blo     210F
CF7B  CE058E                          ldu     #$058e
CF7E  201F                            bra     250F
CF80  33A4            210             leau    ,y							; get dir LSN
CF82  86FF            220             lda     #$ff							; put value $FF
CF84  A7E4                            sta     ,s							; on stack
CF86  33C8EE          230             leau    -18,u						; deduct 18 sectors
CF89  EF7E                            stu     -2,s							; save under stack (why not have a greater hole?)
CF8B  2B0C                            bmi     240F							; if negative, goto 240F
CF8D  8D51                            bsr     bra_D052_CFE0				; goto D052
CF8F  27F1                            beq     220B							; if bit=0, goto 220B 
CF91  6DE4                            tst     ,s							; is >=0 1st byte in stack?
CF93  2A17                            bpl     260F							; yes , goto 260F
CF95  EFE4                            stu     ,s							; save free sector found					
CF97  20ED                            bra     230B							; back to 230B
CF99  EEE4            240             ldu     ,s
CF9B  2A0F                            bpl     260F
CF9D  33A4                            leau    ,y
CF9F  33C812          250             leau    $12,u
CFA2  11830B88                        cmpu    #$0b88
CFA6  2406                            bhs     270F
CFA8  8D36                            bsr     bra_D052_CFE0
CFAA  27F3                            beq     250B
CFAC  207F            260             bra     390F
CFAE  86FF            270             lda     #$ff
CFB0  A767                            sta     7,s
CFB2  A664                            lda     4,s
CFB4  DE8A            280             ldu     bas_null
CFB6  44                              lsra
CFB7  2503                            bcs     290F
CFB9  CE05A0                          ldu     #$05a0
CFBC  8D22            290             bsr     bra_D052_CFE0
CFBE  C6BD                            ldb     #$bd
CFC0  A680            300             lda     ,x+
CFC2  261E                            bne     320F
CFC4  3348                            leau    8,u
CFC6  5A                              decb
CFC7  26F7                            bne     300B
CFC9  C102            310             cmpb    #$02
CFCB  2460                            bhs     390F
CFCD  E167                            cmpb    7,s
CFCF  225C                            bhi     390F
CFD1  A667                            lda     7,s
CFD3  4C                              inca
CFD4  264D                            bne     380F
CFD6  E767                            stb     7,s
CFD8  EF65                            stu     5,s
CFDA  A664                            lda     4,s
CFDC  8803                            eora    #$03
CFDE  20D4                            bra     280B
                                      ;
CFE0  2070            bra_D052_CFE0   bra     L_D052
                                      ;
CFE2  5F              320             clrb
CFE3  E768                            stb     8,s
CFE5  3440                            pshs    u
CFE7  5C              330             incb
CFE8  A680                            lda     ,x+
CFEA  4C                              inca
CFEB  27FA                            beq     330B
CFED  E16A                            cmpb    10,s
CFEF  2304                            bls     340F
CFF1  E76A                            stb     10,s
CFF3  EFE4                            stu     ,s
CFF5  301F            340             leax    -1,x
CFF7  8608                            lda     #$08
CFF9  3D                              mul
CFFA  33CB                            leau    d,u
CFFC  5F              350             clrb
CFFD  A680                            lda     ,x+
CFFF  26E6                            bne     330B
D001  3348                            leau    8,u
D003  1F10                            tfr     x,d
D005  C1BD                            cmpb    #$bd
D007  25F3                            blo     350B
D009  3540                            puls    u
D00B  8D45                            bsr     L_D052
D00D  3348                            leau    8,u
D00F  A684                            lda     ,x
D011  E668                            ldb     8,s
D013  C101                            cmpb    #$01
D015  2205                            bhi     370F
D017  335F            360             leau    -1,u
D019  48                              lsla
D01A  24FB                            bcc     360B
D01C  48              370             lsla
D01D  24AA                            bcc     310B
D01F  335F                            leau    -1,u
D021  20F9                            bra     370B
D023  EE65            380             ldu     5,s
D025  8D2B                            bsr     L_D052
D027  2604                            bne     390F
D029  C694                            ldb     #$94
D02B  201F                            bra     rts_stmp_D04C
D02D  8D23            390             bsr     L_D052
D02F  5F                              clrb
D030  5C              400             incb
D031  2715                            beq     420F
D033  3402                            pshs    a
D035  43                              coma
D036  A484                            anda    ,x
D038  A784                            sta     ,x
D03A  3502                            puls    a
D03C  48                              lsla
D03D  2404                            bcc     410F
D03F  8601                            lda     #$01
D041  3001                            leax    1,x
D043  A584            410             bita    ,x
D045  26E9                            bne     400B
D047  21                              fcb     $21     ; brn - comment byte
D048  5A              420             decb            ; possibly skipped
D049  1F98                            tfr     b,a
D04B  5F                              clrb
D04C  10FE0601        rts_stmp_D04C   lds     ddos_tmp1
D050  5D                              tstb
D051  39                              rts
                      
D052  3460            L_D052          pshs    y,u											; save sectors pointers
D054  8601                            lda     #$01											; 1 side
D056  118305A0                        cmpu    #$05a0										; is U > 1440?
D05A  2507                            blo     10F											; no, goto 10F
D05C  3121                            leay    1,y
D05E  33C9FA60                        leau    -$05a0,u
D062  48                              lsla
D063  3440            10              pshs    u												; save sector pointer
D065  A76C                            sta     12,s											; save numsides							
D067  BDD36B                          jsr     buf_read_sector							; read sector Y
D06A  26E0                            bne     rts_stmp_D04C								; if error goto rts_stmp_D04C
D06C  86FF                            lda     #$ff											; put $FF
D06E  A702                            sta     2,x											; in I/O buffer flag (valid dirty)
D070  3506                            puls    a,b											; get U pushed value
D072  BDD1DD                          jsr     L_D1DD										; calculate Byte in FAT and bit mask
D075  A584                            bita    ,x											; is that bit On in tha pointed FAT byte?
D077  35E0                            puls    y,u,pc										; restore registers and return
                      
                                      ; create a file/dir entry with backup
D079  B7067D          create_file     sta     ddos_067D
D07C  BDDF42                          jsr     L_DF42
D07F  8D4F                            bsr     L_D0D0
D081  6D03                            tst     3,x
D083  2B43                            bmi     30F
D085  EC5C                            ldd     -4,u
D087  FD067A                          std     ddos_067A
D08A  A65E                            lda     -2,u
D08C  B7067C                          sta     ddos_067C
D08F  CC4241                          ldd     #$4241
D092  ED5C                            std     -4,u
D094  864B                            lda     #$4b
D096  A75E                            sta     -2,u
D098  BDCA89          10              jsr     open_file
D09B  C1A0                            cmpb    #$a0
D09D  270D                            beq     20F
D09F  5D                              tstb
D0A0  262D                            bne     rts_D0CF
D0A2  8D58                            bsr     DELETE
D0A4  2629                            bne     rts_D0CF
D0A6  BDDF6D                          jsr     L_DF6D
D0A9  27ED                            beq     10B
D0AB  39                              rts
D0AC  BDDF6D          20              jsr     L_DF6D
D0AF  B6067D                          lda     ddos_067D
D0B2  BDD220                          jsr     RENAME
D0B5  2618                            bne     rts_D0CF
D0B7  BDDF6D                          jsr     L_DF6D
D0BA  2613                            bne     rts_D0CF
D0BC  FC067A                          ldd     ddos_067A
D0BF  FD0658                          std     ddos_cur_drive_info+8
D0C2  B6067C                          lda     ddos_067C
D0C5  B7065A                          sta     ddos_cur_drive_info+10
D0C8  BDCA89          30              jsr     open_file
D0CB  260B                            bne     L_D0D8
D0CD  C69E                            ldb     #$9e
D0CF  39              rts_D0CF        rts
                      
D0D0  C60C            L_D0D0          ldb     #$0c
D0D2  CE0650          L_D0D2          ldu     #ddos_cur_drive_info
D0D5  7EB7CC          cpxub_D0D5      jmp     bas_cpxub
                      
D0D8  C1A0            L_D0D8          cmpb    #$a0
D0DA  26F3                            bne     rts_D0CF
D0DC  97F1                            sta     DSKCOM_fcb
D0DE  4F                              clra
D0DF  BDD278                          jsr     L_D278
D0E2  26EB                            bne     rts_D0CF
D0E4  BDDF42                          jsr     L_DF42
D0E7  A7881D                          sta     $1d,x
D0EA  A7881E                          sta     $1e,x
D0ED  C61C                            ldb     #$1c
D0EF  6F85            10              clr     b,x
D0F1  5A                              decb
D0F2  C10C                            cmpb    #$0c
D0F4  24F9                            bhs     10B
D0F6  6FC0                            clr     ,u+
D0F8  C618                            ldb     #$18
D0FA  20D9                            bra     cpxub_D0D5
                      
                                      ; deletes file and frees sectors
D0FC  BDD20D          DELETE          jsr     L_D20D
D0FF  2641                            bne     60F
D101  E6881D                          ldb     $1d,x
D104  8D3D                            bsr     L_D143
D106  314C                            leay    12,u
D108  C604                            ldb     #$04
D10A  A6C4            10              lda     ,u
D10C  8420                            anda    #$20
D10E  2703                            beq     20F
D110  A6C818                          lda     $18,u
D113  3406            20              pshs    a,b
D115  C681                            ldb     #$81
D117  E7C4                            stb     ,u
D119  E70F                            stb     15,x
D11B  3410                            pshs    x
D11D  AEA1            30              ldx     ,y++
D11F  E6A0                            ldb     ,y+
D121  2708                            beq     40F
D123  3420                            pshs    y
D125  8D5E                            bsr     L_D185
D127  3520                            puls    y
D129  2612                            bne     L_D13D
D12B  6A63            40              dec     3,s
D12D  26EE                            bne     30B
D12F  3510                            puls    x
D131  E6E1                            ldb     ,s++
D133  270A                            beq     50F
D135  8D0C                            bsr     L_D143
D137  3141                            leay    1,u
D139  C607                            ldb     #$07
D13B  20CD                            bra     10B
D13D  3264            L_D13D          leas    4,s
D13F  0FF6            50              clr     DSKCOM_timeout
D141  5D                              tstb
D142  39              60              rts
                      
D143  3410            L_D143          pshs    x
D145  BDD23F                          jsr     L_D23F
D148  26F3                            bne     L_D13D
D14A  1F13                            tfr     x,u
D14C  3590                            puls    x,pc
                      
D14E  4F              L_D14E          clra													; value 0
D14F  3402                            pshs    a												; onto stack
D151  F608FD                          ldb     $08fd										; get number of sectors x track
D154  3416                            pshs    a,b,x										; put d,x onto stack
D156  96EC                            lda     DSKCOM_track								; get track number
D158  91E6                            cmpa    $00e6										; is it equal to contents of $e6?
D15A  2704                            beq     10F											; yes, skip next two
D15C  8114                            cmpa    #$14											; is it the directory track?
D15E  2609                            bne     20F											; no, goto 20F
D160  C112            10              cmpb    #$12											; is disc single sided?
D162  2739                            beq     40F											; yes, clean stack and return
D164  54                              lsrb													; no, then reduce number of tracks to the half 
D165  E761                            stb     1,s											; put value into pushed B
D167  48                              lsla													; double the track number
D168  4C                              inca													; and increment it by one

D169  3D              20              mul														; calculate 1st track sector
D16A  ED62                            std     2,s											; put value into pushed X
D16C  8EC9B4                          ldx     #L_C9B4										; point to L_C984
D16F  3194            30              leay    [,x]											; y gets value $0168 (T20 S1 for single sided discs)
D171  EC62                            ldd     2,s											; get updated value of pushed X
D173  8305A0                          subd    #$05a0										; deduct #1440
D176  2428                            bcc     50F											; if disc is greater (720k) goto 50F
D178  E3E4                            addd    ,s											; adds updated value of pushed D
D17A  2F28                            ble     60F											; if negative go read_sector
D17C  E764                            stb     4,s											; save value at 1st pushed hole (with value 0)
D17E  50                              negb													; change sign
D17F  EB61                            addb    1,s											; add pushed B (in fact deduced B from stacked value)
D181  E761                            stb     1,s											; update stacked B
D183  201F                            bra     60F											; go read_sector
                                      ;
D185  4F              L_D185          clra
D186  3402                            pshs    a
D188  3416                            pshs    a,b,x
D18A  BDD2C2                          jsr     L_D2C2
D18D  260E                            bne     40F
D18F  A64C                            lda     12,u
D191  E6C810                          ldb     $10,u
D194  3D                              mul
D195  A3E4                            subd    ,s
D197  A362                            subd    2,s
D199  2AD4                            bpl     30B
D19B  C690                            ldb     #$90
D19D  3265            40              leas    5,s											; clean stack
D19F  39                              rts														; return

D1A0  3121            50              leay    1,y											; increment y
D1A2  ED62                            std     2,s											; update pushed X value

D1A4  BDD36B          60              jsr     buf_read_sector							; search a free buffer and read sector
D1A7  26F4                            bne     40B											; if error, clean stack and return
D1A9  86FF                            lda     #$ff											
D1AB  A702                            sta     2,x
D1AD  EC62                            ldd     2,s
D1AF  8D2C                            bsr     L_D1DD										; convert sector into its byte in the FAT bit representation
D1B1  A7E4                            sta     ,s
D1B3  E661                            ldb     1,s
D1B5  A6E4            70              lda     ,s
D1B7  AA84                            ora     ,x
D1B9  A784                            sta     ,x
D1BB  5A                              decb
D1BC  2715                            beq     90F
D1BE  68E4                            lsl     ,s
D1C0  24F3                            bcc     70B
D1C2  8601                            lda     #$01
D1C4  A7E4                            sta     ,s
D1C6  3001                            leax    1,x
D1C8  40                              nega
D1C9  C108            80              cmpb    #$08
D1CB  25E8                            blo     70B
D1CD  A780                            sta     ,x+
D1CF  C008                            subb    #$08
D1D1  26F6                            bne     80B
D1D3  8E05A0          90              ldx     #$05a0
D1D6  3264                            leas    4,s
D1D8  E6E0                            ldb     ,s+
D1DA  26A9                            bne     L_D185
D1DC  39                              rts
                      
D1DD  44              L_D1DD          lsra 													; divide A:B
D1DE  56                              rorb													;
D1DF  44                              lsra													;
D1E0  56                              rorb													;
D1E1  44                              lsra													;
D1E2  56                              rorb													; by 8 ($156->$02a) sector to ByteNum
D1E3  AE05                            ldx     5,x											; get I/O buffer address
D1E5  3A                              abx														; calculate Byte in FAT
D1E6  A665                            lda     5,s											; get $56
D1E8  8407                            anda    #$07											; now $06
D1EA  CEA672                          ldu     #$a672										; points to the end of ROM bits table
D1ED  40                              nega													; to make it negative and go backwards
D1EE  A6C6                            lda     a,u											; get 2^6 = 64 ($40)
D1F0  39                              rts														; return
                      
                                      ; protect/unprotect a file
D1F1  BDDF40          protect_file    jsr     L_DF40
D1F4  A60F                            lda     15,x
D1F6  2B25                            bmi     L_D21D
D1F8  5D                              tstb
D1F9  2703                            beq     10F
D1FB  8A02                            ora     #$02
D1FD  8C                              fcb     $8c     ; cmpx - comment byte
D1FE  84FD            10              anda    #$fd    ; possibly skipped
D200  A70F                            sta     15,x
D202  E6881D                          ldb     $1d,x
D205  8D38                            bsr     L_D23F
D207  2603                            bne     20F
D209  A784                            sta     ,x
D20B  5F                              clrb
D20C  39              20              rts
                      
D20D  97F1            L_D20D          sta     DSKCOM_fcb
D20F  BDDF42          L_D20F          jsr     L_DF42
D212  A60F                            lda     15,x
D214  2B07                            bmi     L_D21D
D216  8502                            bita    #$02
D218  2705                            beq     10F
D21A  C698                            ldb     #$98
D21C  39                              rts
D21D  C69C            L_D21D          ldb     #$9c
D21F  39              10              rts
                      
                                      ; rename a file
D220  8DEB            RENAME          bsr     L_D20D
D222  2612                            bne     10F
D224  1F13                            tfr     x,u
D226  8D0F                            bsr     L_D237
D228  E6C812                          ldb     $12,u
D22B  8D12                            bsr     L_D23F
D22D  2607                            bne     10F
D22F  3301                            leau    1,x
D231  8D04                            bsr     L_D237
D233  0FF6                            clr     DSKCOM_timeout
D235  5F                              clrb
D236  39              10              rts
                      
D237  C60B            L_D237          ldb     #$0b
D239                  copy_cur_drive_info_to_u
D239  8E0650                          ldx     #ddos_cur_drive_info
D23C  7EB7CC                          jmp     bas_cpxub
                      
D23F  3406            L_D23F          pshs    a,b
D241  BDD315                          jsr     GETDIR
D244  2679                            bne     rts2_D2BF
D246  1F32                            tfr     u,y
D248  86FE                            lda     #$fe
D24A  A722                            sta     2,y
D24C  5F                              clrb
D24D  3586                            puls    a,b,pc
                      
                                      ; gets free space on disk
D24F  8D71            GETFRE          bsr     L_D2C2
D251  266E                            bne     rts_D2C1
D253  3194                            leay    [,x]
D255  9E8A                            ldx     bas_null
D257  8D04                            bsr     10F
D259  2666                            bne     rts_D2C1
D25B  3121                            leay    1,y
D25D  3410            10              pshs    x
D25F  BDD36B                          jsr     buf_read_sector
D262  265B                            bne     rts2_D2BF
D264  EE05                            ldu     5,x
D266  3510                            puls    x
D268  C6BD                            ldb     #$bd
D26A  A6C0            20              lda     ,u+
D26C  44              30              lsra
D26D  2402                            bcc     40F
D26F  3001                            leax    1,x
D271  4D              40              tsta
D272  26F8                            bne     30B
D274  5A                              decb
D275  26F3                            bne     20B
D277  39                              rts
                      
D278  B7067E          L_D278          sta     ddos_067E
D27B  8D45                            bsr     L_D2C2
D27D  2642                            bne     rts_D2C1
D27F  AE84                            ldx     ,x
D281  3410                            pshs    x
D283  3002                            leax    2,x
D285  BF066F          10              stx     ddos_066F
D288  1F12                            tfr     x,y
D28A  BDD36B                          jsr     buf_read_sector
D28D  2630                            bne     rts2_D2BF
D28F  EE05                            ldu     5,x
D291  C60A                            ldb     #$0a
D293  B6067E                          lda     ddos_067E
D296  4A                              deca
D297  2707                            beq     30F
D299  A6C4            20              lda     ,u
D29B  2B1A                            bmi     40F
D29D  7C067E                          inc     ddos_067E
D2A0  33C819          30              leau    $19,u
D2A3  5A                              decb
D2A4  26F3                            bne     20B
D2A6  BE066F                          ldx     ddos_066F
D2A9  3001                            leax    1,x
D2AB  1F10                            tfr     x,d
D2AD  A3E4                            subd    ,s
D2AF  C112                            cmpb    #$12
D2B1  25D2                            blo     10B
D2B3  C692                            ldb     #$92
D2B5  2008                            bra     rts2_D2BF
D2B7  86FF            40              lda     #$ff
D2B9  A702                            sta     2,x
D2BB  B6067E                          lda     ddos_067E
D2BE  5F                              clrb
D2BF  3262            rts2_D2BF       leas    2,s
D2C1  39              rts_D2C1        rts
                      
																							; Fun3 called by Fun2
D2C2  D6EB            L_D2C2          ldb     DSKCOM_drive					; get drive number
D2C4  CE0697                          ldu     #ddos_drive_on				; point to drive flags
D2C7  33C5                            leau    b,u								; point one after drive
D2C9  BDDBA5                          jsr     L_DBA5							; X points to drive info
D2CC  6D5F                            tst     -1,u								; test drive flags
D2CE  2641                            bne     50F								; if not 0, exit
D2D0  BDC16A                          jsr     DSKCOM_read_address_s0	; Fun4 - highly tied to hdw (low level)
D2D3  9612                            lda     $0012							; get track number
D2D5  2406                            bcc     10F								; if were not error, goto 10F
D2D7  C188                            cmpb    #$88
D2D9  26E6                            bne     rts_D2C1
D2DB  86A0                            lda     #$a0
D2DD  A743            10              sta     3,u								; put value at current track in table
D2DF  108E0168                        ldy     #$0168							; get 1st sector for dir T20 for single sided disc
D2E3  8612                            lda     #$12								; numer of sectors x track for single sided disc
D2E5  A74F                            sta     15,u								; put it at sectors x track in table
D2E7  3450                            pshs    x,u								; save registers
D2E9  BDDBD5                          jsr     L_DBD5						; Fun5 - reads sector
D2EC  260B                            bne     20F								; if error, exit
D2EE  EC4E                            ldd     14,u								; get geodata
D2F0  43                              coma										; complement
D2F1  53                              comb										; both bytes
D2F2  10A34C                          cmpd    12,u								; do equal the ones read?
D2F5  2704                            beq     30F								; yes, so a good drirectory read!, goto 30F
D2F7  C690                            ldb     #$90								; NO, wrong directory sector received (IV error)
D2F9  35D0            20              puls    x,u,pc							; restore registers and return

                                      ;
D2FB  3550            30              puls    x,u
D2FD  A74B                            sta     11,u
D2FF  E74F                            stb     15,u
D301  8614                            lda     #$14
D303  C113                            cmpb    #$13
D305  2502                            blo     40F
D307  48                              lsla
D308  57                              asrb
D309  6F02            40              clr     2,x
D30B  E7C817                          stb     $17,u
D30E  3D                              mul
D30F  ED84                            std     ,x
D311  E7C2            50              stb     ,-u
D313  5F                              clrb
D314  39                              rts
                      
D315  8601            GETDIR          lda     #$01    ; gets a directory entry
D317  4C              10              inca
D318  C00A                            subb    #$0a
D31A  24FB                            bcc     10B
D31C  CB0A                            addb    #$0a
D31E  3406                            pshs    a,b
D320  8DA0                            bsr     L_D2C2
D322  269B                            bne     rts2_D2BF
D324  4F                              clra
D325  E6E0                            ldb     ,s+
D327  E1C818                          cmpb    $18,u
D32A  2418                            bhs     30F
D32C  E384                            addd    ,x
D32E  FD066F                          std     ddos_066F
D331  1F02                            tfr     d,y
D333  8D36                            bsr     buf_read_sector
D335  3502                            puls    a
D337  260A                            bne     20F
D339  1F13                            tfr     x,u
D33B  C619                            ldb     #$19
D33D  3D                              mul
D33E  AE05                            ldx     5,x
D340  308B                            leax    d,x
D342  5F                              clrb
D343  39              20              rts
D344  C69F            30              ldb     #$9f
D346  3582                            puls    a,pc
                      
                                      ; find free buffer
D348  8E0634          buf_find_free   ldx     #ddos_buffers
D34B  DE8A                            ldu     bas_null
D34D  C604                            ldb     #$04
D34F  A602            10              lda     2,x
D351  270F                            beq     20F
D353  10AC84                          cmpy    ,x
D356  260C                            bne     30F
D358  96EB                            lda     DSKCOM_drive
D35A  A103                            cmpa    3,x
D35C  2606                            bne     30F
D35E  8D57                            bsr     L_D3B7
D360  5F                              clrb
D361  39                              rts
D362  1F13            20              tfr     x,u
D364  3007            30              leax    7,x
D366  5A                              decb
D367  26E6                            bne     10B
D369  5A                              decb
D36A  39                              rts
                      
                                      ; find free buffer and read sector
                                      										; Fun6 called by Fun4
D36B  3440            buf_read_sector pshs    u									; save register ($3db)
D36D  8DD9                            bsr     buf_find_free					; search a free buffer
D36F  2771                            beq     999F								; if returns 0, clean stack and return
D371  30C4                            leax    ,u								; points to I/O buffer table
D373  3540                            puls    u									; restore register ($3db)
D375  2604                            bne     10F								; if buffer pointer is not 0, skip next two
D377  8D1A                            bsr     L_D393
D379  2617                            bne     20F
D37B  6F02            10              clr     2,x								; marks flag for buffer 4 as invalid, not used
D37D  10AF84                          sty     ,x								; the magic value '$0168' is put as LSN in buffer
D380  96EB                            lda     DSKCOM_drive					; get drive number
D382  A703                            sta     3,x								; put in buffer 4
D384  3410                            pshs    x									; save register ($649)
D386  AE05                            ldx     5,x								; get buffer address
D388  BDD3D6                          jsr     read_lsn						; here re-calculates $ec-$ed so destroys right sequential value
D38B  3510                            puls    x
D38D  2603                            bne     20F
D38F  6C02                            inc     2,x
D391  5F              ok_D391         clrb
D392  39              20              rts
                      
D393  3462            L_D393          pshs    a,y,u
D395  8E0634          10              ldx     #ddos_buffers
D398  C604                            ldb     #$04
D39A  A604            20              lda     4,x
D39C  4A                              deca
D39D  2705                            beq     30F
D39F  3007                            leax    7,x
D3A1  5A                              decb
D3A2  26F6                            bne     20B
D3A4  8D11            30              bsr     L_D3B7
D3A6  A602                            lda     2,x
D3A8  8119                            cmpa    #$19
D3AA  27E9                            beq     10B
D3AC  4C                              inca
D3AD  2604                            bne     40F
D3AF  6A02                            dec     2,x
D3B1  20E2                            bra     10B
D3B3  8D2F            40              bsr     L_D3E4
D3B5  35E2                            puls    a,y,u,pc
                      
D3B7  C604            L_D3B7          ldb     #$04
D3B9  A604                            lda     4,x
D3BB  CE0634                          ldu     #ddos_buffers
D3BE  A144            10              cmpa    4,u
D3C0  2202                            bhi     20F
D3C2  6A44                            dec     4,u
D3C4  3347            20              leau    7,u
D3C6  5A                              decb
D3C7  26F5                            bne     10B
D3C9  8604                            lda     #$04
D3CB  A704                            sta     4,x
D3CD  39                              rts
                      
D3CE  C606            write_lsn_nr    ldb     #$06    ; write absolute sector, error if NR
D3D0  21                              fcb     $21     ; brn - comment byte
D3D1  5F              verify_lsn      clrb            ; verify absolute sector
D3D2  8C                              fcb     $8c     ; cmpx - comment byte
D3D3  C603            write_lsn       ldb     #$03    ; write absolute sector, no error if NR
D3D5  8C                              fcb     $8c     ; cmpx - comment byte
D3D6  C609            read_lsn        ldb     #$09    ; read absolute sector
D3D8  3450                            pshs    x,u
D3DA  4F                              clra
D3DB  C3C0FB                          addd    #test_sector				; so D points to a drive Routine
D3DE  8D2D                            bsr     L_D40D
D3E0  3510                            puls    x
D3E2  35C0            999             puls    u,pc
                      
D3E4  96EB            L_D3E4          lda     DSKCOM_drive
D3E6  6D02                            tst     2,x
D3E8  2AA7                            bpl     ok_D391
D3EA  3460                            pshs    y,u
D3EC  DEEC                            ldu     DSKCOM_track    ; and DSKCOM_sector
D3EE  3452                            pshs    a,x,u
D3F0  97F6                            sta     DSKCOM_timeout
D3F2  6F02                            clr     2,x
D3F4  A603                            lda     3,x
D3F6  97EB                            sta     DSKCOM_drive
D3F8  3194                            leay    [,x]
D3FA  AE05                            ldx     5,x
D3FC  8DD0                            bsr     write_lsn_nr
D3FE  3552                            puls    a,x,u
D400  2602                            bne     10F
D402  6C02                            inc     2,x
D404  97EB            10              sta     DSKCOM_drive
D406  DFEC                            stu     DSKCOM_track    ; and DSKCOM_sector
D408  0FF6                            clr     DSKCOM_timeout
D40A  5D                              tstb
D40B  35E0                            puls    y,u,pc
                      
D40D  3406            L_D40D          pshs    a,b								; pushes calculated return address (function call)
D40F  4F                              clra										; high byte to 0
D410  9FEE                            stx     DSKCOM_bufptr					; save pointer to system variable
D412  8E06A6                          ldx     #ddos_nsectors-1				; point sectors x track table-1
D415  D6EB                            ldb     DSKCOM_drive					; get drive number
D417  E685                            ldb     b,x								; gets sectors x track (default = $12)
D419  3406                            pshs    a,b								; pushes 16 bits value (high byte = 0)
D41B  6FE2                            clr     ,-s								; create a counter in stack value 0
D41D  1F20                            tfr     y,d								; copies Y into D
D41F  6CE4            10              inc     ,s								; increment track counter
D421  A361                            subd    1,s								; subtract sectors x track from LSN at D
D423  2AFA                            bpl     10B								; if not negative, loopback
D425  A6E1                            lda     ,s++								; get track counter, clean stack
D427  4A                              deca										; decrement by one (we got a negative count)
D428  EBE0                            addb    ,s+								; convert B to positive number
D42A  5C                              incb										; increment it = sector number
D42B  DDEC                            std     DSKCOM_track    				; save calculated track & sector
D42D  39                              rts											; jump to pushed function address
                      
D42E  BD83FF          L_D42E          jsr     L_83FF
D431  2512                            bcs     20F
D433  DC47                            ldd     $0047
D435  A384                            subd    ,x
D437  D31B                            addd    bas_scalar_start
D439  DD1B                            std     bas_scalar_start
D43B  EE84                            ldu     ,x
D43D  A6C0            10              lda     ,u+
D43F  A780                            sta     ,x+
D441  9C1B                            cmpx    bas_scalar_start
D443  26F8                            bne     10B
D445  DC1B            20              ldd     bas_scalar_start
D447  DD43                            std     $0043
D449  DB03                            addb    $0003
D44B  8900                            adca    #$00
D44D  DD41                            std     $0041
D44F  BD831C                          jsr     L_831C
D452  CE02D8                          ldu     #$02d8
D455  A6C0            30              lda     ,u+
D457  A780                            sta     ,x+
D459  9C45                            cmpx    $0045
D45B  26F8                            bne     30B
D45D  9E41                            ldx     $0041
D45F  9F1B                            stx     bas_scalar_start
D461  7E83ED                          jmp     BasVect2
                      
D464  81C6            MERGE_dispatch  cmpa    #$c6
D466  2742                            beq     L_D4AA
D468  8D51                            bsr     L_D4BB
D46A  DE1B                            ldu     bas_scalar_start
D46C  DC19                            ldd     bas_basic_start
D46E  3446                            pshs    a,b,u
D470  3341                            leau    1,u
D472  DF19                            stu     bas_basic_start
D474  BDD5BD                          jsr     L_D5BD
D477  3550                            puls    x,u
D479  DF1B                            stu     bas_scalar_start
D47B  9F19                            stx     bas_basic_start
D47D  3341                            leau    1,u
D47F  ECC1            10              ldd     ,u++
D481  10270125                        lbeq    L_D5AA
D485  ECC1                            ldd     ,u++
D487  FD02DA                          std     $02da
D48A  DD2B                            std     $002b
D48C  5F                              clrb
D48D  8E02DC                          ldx     #$02dc
D490  5C              20              incb
D491  A6C0                            lda     ,u+
D493  A780                            sta     ,x+
D495  26F9                            bne     20B
D497  CB04                            addb    #$04
D499  D703                            stb     $0003
D49B  3440                            pshs    u
D49D  8D8F                            bsr     L_D42E
D49F  3540                            puls    u
D4A1  20DC                            bra     10B
                      
D4A3  DEA6            L_D4A3          ldu     bas_next_char
D4A5  BD8417                          jsr     bas_erase_basic
D4A8  DFA6                            stu     bas_next_char
D4AA  BDDACF          L_D4AA          jsr     L_DACF
D4AD  BDD73C                          jsr     L_D73C
D4B0  2611                            bne     bas_err_D4C3
D4B2  976F                            sta     DEVNUM
D4B4  40                              nega
D4B5  B70611                          sta     ddos_load_not_run
D4B8  7E837A                          jmp     L_837A
                      
D4BB  8D09            L_D4BB          bsr     L_D4C6
D4BD  8101                            cmpa    #$01
D4BF  2710                            beq     rts_D4D1
D4C1  C62C            L_D4C1          ldb     #$2c
D4C3  7E8344          bas_err_D4C3    jmp     bas_system_error
                      
D4C6  C6EA            L_D4C6          ldb     #ddos_ext_bas
D4C8  BDD746                          jsr     L_D746
D4CB  26F6                            bne     bas_err_D4C3
D4CD  8D03                            bsr     L_D4D2
D4CF  26F2                            bne     bas_err_D4C3
D4D1  39              rts_D4D1        rts
                      
D4D2  DE8A            L_D4D2          ldu     bas_null
D4D4  5F                              clrb
                                      ;
D4D5  8E0650          L_D4D5          ldx     #ddos_cur_drive_info
D4D8  108E0009                        ldy     #$0009
D4DC  96F1                            lda     DSKCOM_fcb
D4DE  BDCB1D                          jsr     read_file
D4E1  2611                            bne     10F
D4E3  8655                            lda     #$55
D4E5  8E0650                          ldx     #ddos_cur_drive_info
D4E8  A184                            cmpa    ,x
D4EA  26D5                            bne     L_D4C1
D4EC  43                              coma
D4ED  A108                            cmpa    8,x
D4EF  26D0                            bne     L_D4C1
D4F1  A601                            lda     1,x
D4F3  5F                              clrb
D4F4  39              10              rts
                      
D4F5  7F0614          ddos_hook_run   clr     ddos_error_goto_flag
D4F8  7F0619                          clr     ddos_err_last
D4FB  7F0617                          clr     ddos_erl_line_num
D4FE  7F0618                          clr     ddos_erl_line_num+1
D501  8122                            cmpa    #$22
D503  1026ED84                        lbne    rts_C28B
D507  3262                            leas    2,s
D509  BDB64C                          jsr     L_B64C
D50C  C6                              fcb     $c6     ; ldb #$5f - comment byte
D50D  5F              LOAD_dispatch   clrb            ; possibly skipped
D50E  F70611                          stb     ddos_load_not_run
D511  81C6                            cmpa    #$c6
D513  278E                            beq     L_D4A3
D515  8DAF                            bsr     L_D4C6
D517  8103                            cmpa    #$03
D519  22A6                            bhi     L_D4C1
D51B  4A                              deca
D51C  277B                            beq     L_D599
D51E  DC8A                            ldd     bas_null
D520  ED0C                            std     12,x
D522  ED09                            std     9,x
D524  C609                            ldb     #$09
D526  E70B                            stb     11,x
D528  9DA5                            jsr     bas_poll_char
D52A  2710                            beq     L_D53C
D52C  3410                            pshs    x
D52E  8D63                            bsr     comma_16bit
D530  1F13                            tfr     x,u
D532  3510                            puls    x
D534  1F30                            tfr     u,d
D536  A302                            subd    2,x
D538  EF02                            stu     2,x
D53A  ED0C                            std     12,x
D53C  8D41            L_D53C          bsr     L_D57F
D53E                  bne_bas_err_D53E
D53E  2683                            bne     bas_err_D4C3
D540  8E0650                          ldx     #ddos_cur_drive_info
D543  8602                            lda     #$02
D545  A101                            cmpa    1,x
D547  272A                            beq     L_D573
D549  EC04                            ldd     4,x
D54B  2726                            beq     L_D573
D54D  E30A                            addd    10,x
D54F  ED0A                            std     10,x
D551  8600                            lda     #$00
D553  A909                            adca    9,x
D555  A709                            sta     9,x
D557  EE09                            ldu     9,x
D559  BDD4D5                          jsr     L_D4D5
D55C  26E0                            bne     bne_bas_err_D53E
D55E  EC0A                            ldd     10,x
D560  C30009                          addd    #$0009
D563  ED0A                            std     10,x
D565  C600                            ldb     #$00
D567  E909                            adcb    9,x
D569  E709                            stb     9,x
D56B  EC02                            ldd     2,x
D56D  E30C                            addd    12,x
D56F  ED02                            std     2,x
D571  20C9                            bra     L_D53C
D573  BDDB2B          L_D573          jsr     L_DB2B
D576  7D0611                          tst     ddos_load_not_run
D579  275D                            beq     L_D5D8
D57B  6E9F009D                        jmp     [bas_exec]
                      
D57F  EC0C            L_D57F          ldd     12,x
D581  E306                            addd    6,x
D583  DD9D                            std     bas_exec
D585  10AE04                          ldy     4,x
D588  96F1                            lda     DSKCOM_fcb
D58A  EE09                            ldu     9,x
D58C  E60B                            ldb     11,x
D58E  AE02                            ldx     2,x
D590  7ECB1D          L_D590          jmp     read_file
                      
D593  BD89AA          comma_16bit     jsr     CkComa
D596  7E8E83                          jmp     Get16Bit
                      
D599  7D0611          L_D599          tst     ddos_load_not_run
D59C  270A                            beq     10F
D59E  8D10                            bsr     L_D5B0
D5A0  8D1B                            bsr     L_D5BD
D5A2  BD841F                          jsr     BasVect1
D5A5  7ED6D3                          jmp     L_D6D3
                                      ;
D5A8  8D13            10              bsr     L_D5BD
D5AA  BD841F          L_D5AA          jsr     BasVect1
D5AD  7E8371                          jmp     bas_ok_prompt
                      
D5B0  9DA5            L_D5B0          jsr     bas_poll_char
D5B2  2724                            beq     L_D5D8
D5B4  730611                          com     ddos_load_not_run
D5B7  BD89AA                          jsr     CkComa
D5BA  7E869A                          jmp     L_869A
                      
D5BD  EC04            L_D5BD          ldd     4,x
D5BF  1F02                            tfr     d,y
D5C1  D319                            addd    bas_basic_start
D5C3  8D6F                            bsr     L_D634
D5C5  96F1            L_D5C5          lda     DSKCOM_fcb
D5C7  DE8A                            ldu     bas_null
D5C9  C609                            ldb     #$09
D5CB  9E19                            ldx     bas_basic_start
D5CD  8DC1                            bsr     L_D590
D5CF  8D60                            bsr     L_D631
D5D1  BD83ED                          jsr     BasVect2
D5D4  3002                            leax    2,x
D5D6  9F1B                            stx     bas_scalar_start
D5D8  39              L_D5D8          rts
                      
D5D9  BD8887          L_D5D9          jsr     bas_get_string
D5DC  7E8877                          jmp     bas_get_expression
                      
																														; SAVE command
D5DF  81C6            SAVE_dispatch   cmpa    #$c6
D5E1  2769                            beq     L_D64C
D5E3  8DF4                            bsr     L_D5D9
D5E5  9DA5                            jsr     bas_poll_char
D5E7  2777                            beq     L_D660
D5E9  C6F3                            ldb     #ddos_ext_bin
D5EB  8D4E                            bsr     L_D63B
D5ED  8DA4                            bsr     comma_16bit
D5EF  BF0652                          stx     ddos_cur_drive_info+2
D5F2  8D9F                            bsr     comma_16bit
D5F4  1F10                            tfr     x,d
D5F6  BC0652                          cmpx    ddos_cur_drive_info+2
D5F9  1025F31D                        lblo    rts_err_PR
D5FD  B30652                          subd    ddos_cur_drive_info+2
D600  102BB589                        lbmi    bas_fc_error
D604  FD0654                          std     ddos_cur_drive_info+4
D607  8D8A                            bsr     comma_16bit
D609  BF0656                          stx     ddos_cur_drive_info+6
D60C  C602                            ldb     #$02
                                      ;
D60E  8E0650          L_D60E          ldx     #ddos_cur_drive_info					; points to temp file name
D611  8655                            lda     #$55											; initial 'magic' number
D613  A784                            sta     ,x											; as 1st byte
D615  43                              coma													; ending 'magic' number ($AA)
D616  A708                            sta     8,x											; as end header byte
D618  E701                            stb     1,x											; puts type of file (BAS - BIN - DAT)
D61A  5F                              clrb													; 0 as higher byte
D61B  CE0009                          ldu     #$0009										; header bytes to be skipped
D61E  8D5A                            bsr     L_D67A										; write RAM to disk
D620  2627                            bne     bas_err_D649
D622  C609                            ldb     #$09
D624  BE0652                          ldx     ddos_cur_drive_info+2
D627  FE0654                          ldu     ddos_cur_drive_info+4
D62A  8D4E                            bsr     L_D67A										; verify sectors if VERIFY is ON
D62C  2603                            bne     L_D631
D62E  BDC78A                          jsr     L_C78A										; update FAT and DIR sectors
D631  7EDB2B          L_D631          jmp     L_DB2B										; close file
                      
D634  DD1F            L_D634          std     bas_free_start
D636  C640                            ldb     #$40
D638  7E8331                          jmp     L_8331
                      
D63B  BDD758          L_D63B          jsr     L_D758
D63E  2704            L_D63E          beq     10F
D640  C1A0                            cmpb    #$a0
D642  2605                            bne     bas_err_D649
D644  BDD079          10              jsr     create_file
D647  278F                            beq     L_D5D8
D649  7E8344          bas_err_D649    jmp     bas_system_error
                      
D64C  BDD73C          L_D64C          jsr     L_D73C
D64F  8DED                            bsr     L_D63E
D651  9DA5                            jsr     bas_poll_char
D653  2703                            beq     10F
D655  BD89AA                          jsr     CkComa
D658  D6F1            10              ldb     DSKCOM_fcb
D65A  7F0611                          clr     ddos_load_not_run
D65D  7E8EA6                          jmp     bas_list_to_b
                      
D660  C6EA            L_D660          ldb     #ddos_ext_bas
D662  8DD7                            bsr     L_D63B
D664  9E19                            ldx     bas_basic_start
D666  BF0652                          stx     ddos_cur_drive_info+2
D669  DC1B                            ldd     bas_scalar_start
D66B  9319                            subd    bas_basic_start
D66D  FD0654                          std     ddos_cur_drive_info+4
D670  8E8B8D                          ldx     #bas_fc_error
D673  BF0656                          stx     ddos_cur_drive_info+6
D676  C601                            ldb     #$01
D678  2094                            bra     L_D60E
                      
D67A  96F1            L_D67A          lda     DSKCOM_fcb									; get FIB number
D67C  109E8A                          ldy     bas_null									; 16 bit zero
D67F  7ECD9F                          jmp     write_file									; process write||verify
                      
D682  8D5F            CHAIN_dispatch  bsr     L_D6E3
D684  BDD4BB                          jsr     L_D4BB
D687  B70611                          sta     ddos_load_not_run
D68A  BDD5B0                          jsr     L_D5B0
D68D  FC0654                          ldd     ddos_cur_drive_info+4
D690  1F02                            tfr     d,y
D692  D319                            addd    bas_basic_start
D694  931B                            subd    bas_scalar_start
D696  3406                            pshs    a,b
D698  D31F                            addd    bas_free_start
D69A  8D98                            bsr     L_D634
D69C  ECE4                            ldd     ,s
D69E  270E                            beq     20F
D6A0  DE1B                            ldu     bas_scalar_start
D6A2  30CB                            leax    d,u
D6A4  A6C0            10              lda     ,u+
D6A6  A780                            sta     ,x+
D6A8  9C1F                            cmpx    bas_free_start
D6AA  23F8                            bls     10B
D6AC  200E                            bra     40F
D6AE  9E1F            20              ldx     bas_free_start
D6B0  3001                            leax    1,x
D6B2  338B                            leau    d,x
D6B4  A682            30              lda     ,-x
D6B6  A7C2                            sta     ,-u
D6B8  9C1B                            cmpx    bas_scalar_start
D6BA  24F8                            bhs     30B
D6BC  ECE4            40              ldd     ,s
D6BE  D31B                            addd    bas_scalar_start
D6C0  DD1B                            std     bas_scalar_start
D6C2  3506                            puls    a,b
D6C4  D31D                            addd    bas_array_start
D6C6  DD1D                            std     bas_array_start
D6C8  BD8514                          jsr     bas_RESTORE_dispatch
D6CB  9FA6                            stx     bas_next_char
D6CD  BD8434                          jsr     bas_reset_stack
D6D0  BDD5C5                          jsr     L_D5C5
                                      ; fall through
D6D3  7D0611          L_D6D3          tst     ddos_load_not_run
D6D6  2A05                            bpl     10F
D6D8  DC2B                            ldd     $002b
D6DA  BD85E7                          jsr     L_85E7
D6DD  BD8CD7          10              jsr     force_garbage_collect
D6E0  7E849F                          jmp     bas_run_basic
                      
D6E3  9E1B            L_D6E3          ldx     bas_scalar_start
D6E5  3002                            leax    2,x
D6E7  9C1D            10              cmpx    bas_array_start
D6E9  240A                            bhs     30F
D6EB  6D1F                            tst     -1,x
D6ED  2A02                            bpl     20F
D6EF  8D2B                            bsr     L_D71C
D6F1  3007            20              leax    7,x
D6F3  20F2                            bra     10B
D6F5  DE1D            30              ldu     bas_array_start
D6F7  11931F          40              cmpu    bas_free_start
D6FA  1024B5D9                        lbhs    force_garbage_collect
D6FE  EC42                            ldd     2,u
D700  30CB                            leax    d,u
D702  3410                            pshs    x
D704  6D41                            tst     1,u
D706  2A10                            bpl     60F
D708  E644                            ldb     4,u
D70A  4F                              clra
D70B  58                              lslb
D70C  30CB                            leax    d,u
D70E  3005                            leax    5,x
D710  8D0A            50              bsr     L_D71C
D712  3005                            leax    5,x
D714  ACE4                            cmpx    ,s
D716  25F8                            blo     50B
D718  3540            60              puls    u
D71A  20DB                            bra     40B
                      
D71C  3450            L_D71C          pshs    x,u
D71E  9C21                            cmpx    bas_stack_top
D720  2412                            bhs     10F
D722  E684                            ldb     ,x
D724  270E                            beq     10F
D726  BD8CB3                          jsr     L_8CB3
D729  1F13                            tfr     x,u
D72B  31F4                            leay    [,s]
D72D  AE22                            ldx     2,y
D72F  EF22                            stu     2,y
D731  BDB7CC                          jsr     bas_cpxub
D734  35D0            10              puls    x,u,pc
                      
D736  C6F6            L_D736          ldb     #ddos_ext_none
D738  8D23            L_D738          bsr     L_D75D
D73A  2011                            bra     L_D74D
D73C  9D9F            L_D73C          jsr     CHRGET
D73E  C6EB                            ldb     #$eb
D740  8C                              fcb     $8c                     ; cmpx - comment byte
D741  C6F0            L_D741          ldb     #ddos_ext_dat           ; possibly skipped
D743  8C                              fcb     $8c                     ; cmpx - comment byte
D744  C6F6            L_D744          ldb     #ddos_ext_none          ; possibly skipped
D746  8D15            L_D746          bsr     L_D75D
D748  2603            L_D748          bne     L_D74D
D74A  BDCA89                          jsr     open_file
D74D  3510            L_D74D          puls    x
D74F  3406                            pshs    a,b
D751  BD8D9F                          jsr     DELVAR
D754  3506                            puls    a,b
D756  5D                              tstb
D757  39                              rts
                      
D758  CED748          L_D758          ldu     #L_D748
D75B  2007                            bra     L_D764
                                      ;
D75D  3404            L_D75D          pshs    b
D75F  BDD5D9                          jsr     L_D5D9
D762  3544                            puls    b,u
D764  34C0            L_D764          pshs    u,pc
D766  86DF                            lda     #ddos_exts>>8
D768  1F02                            tfr     d,y
D76A  9E52                            ldx     VARPTR
D76C  AF62                            stx     2,s
D76E  E684                            ldb     ,x
D770  AE02                            ldx     2,x
                                      ;
                                      ; validate filename and copy to current drive block
D772                  validate_filename
D772  3420                            pshs    y
D774  5D                              tstb
D775  274F                            beq     L_D7C6
D777  CE065B                          ldu     #ddos_cur_drive_info+11
D77A  31C4                            leay    ,u
D77C  6F45                            clr     5,u
D77E  860A                            lda     #$0a
D780  6FC2            L_D780          clr     ,-u
D782  4A                              deca
D783  2AFB                            bpl     L_D780
D785  C10E                            cmpb    #$0e
D787  223D                            bhi     L_D7C6
D789  C002                            subb    #$02
D78B  2F1E                            ble     L_D7AB
D78D  863A                            lda     #$3a
D78F  A185                            cmpa    b,x
D791  2606                            bne     L_D799
D793  5C                              incb
D794  A685                            lda     b,x
D796  5A                              decb
D797  2006                            bra     L_D79F
D799  A101            L_D799          cmpa    1,x
D79B  260E                            bne     L_D7AB
D79D  A681                            lda     ,x++
D79F  8030            L_D79F          suba    #$30
D7A1  2304                            bls     L_D7A7
D7A3  8104                            cmpa    #$04
D7A5  2309                            bls     L_D7B0
D7A7  C628            L_D7A7          ldb     #$28
D7A9  35A0                            puls    y,pc
D7AB  CB02            L_D7AB          addb    #$02
D7AD  B6060A                          lda     ddos_default_drive
D7B0  A7A4            L_D7B0          sta     ,y
D7B2  A680            L_D7B2          lda     ,x+
D7B4  8141                            cmpa    #$41
D7B6  2512                            blo     L_D7CA
D7B8  815A                            cmpa    #$5a
D7BA  231C                            bls     L_D7D8
D7BC  8020                            suba    #$20
D7BE  8141                            cmpa    #$41
D7C0  2504                            blo     L_D7C6
D7C2  815A                            cmpa    #$5a
D7C4  2312                            bls     L_D7D8
D7C6  C696            L_D7C6          ldb     #$96
D7C8  35A0                            puls    y,pc
D7CA  812D            L_D7CA          cmpa    #$2d
D7CC  270A                            beq     L_D7D8
D7CE  2DF6                            blt     L_D7C6
D7D0  8130                            cmpa    #$30
D7D2  2524                            blo     L_D7F8
D7D4  8139                            cmpa    #$39
D7D6  22EE                            bhi     L_D7C6
D7D8  A7C0            L_D7D8          sta     ,u+
D7DA  1183065B                        cmpu    #ddos_cur_drive_info+11
D7DE  2605                            bne     L_D7E5
D7E0  5A                              decb
D7E1  26E3                            bne     L_D7C6
D7E3  2024                            bra     L_D809
D7E5  11830658        L_D7E5          cmpu    #ddos_cur_drive_info+8
D7E9  261B                            bne     L_D806
D7EB  5A                              decb
D7EC  271B                            beq     L_D809
D7EE  A680                            lda     ,x+
D7F0  812E                            cmpa    #$2e
D7F2  2704                            beq     L_D7F8
D7F4  812F                            cmpa    #$2f
D7F6  26CE                            bne     L_D7C6
D7F8  11830650        L_D7F8          cmpu    #ddos_cur_drive_info
D7FC  27C8                            beq     L_D7C6
D7FE  6D25                            tst     5,y
D800  26C4                            bne     L_D7C6
D802  6C25                            inc     5,y
D804  333D                            leau    -3,y
D806  5A              L_D806          decb
D807  26A9                            bne     L_D7B2
D809  3540            L_D809          puls    u
D80B  1E32                            exg     u,y
D80D  6D45                            tst     5,u
D80F  2608                            bne     L_D819
D811  A622                            lda     2,y
D813  A75F                            sta     -1,u
D815  ECA4                            ldd     ,y
D817  ED5D                            std     -3,u
D819  5F              L_D819          clrb
D81A  39                              rts
                      
D81B                  ddos_hook_sys_error
D81B  CE0614                          ldu     #ddos_error_goto_flag
D81E  E745                            stb     5,u             ; ddos_error_goto_line
D820  0FF6                            clr     DSKCOM_timeout
D822  BD8018                          jsr     _CASOFF
D825  BDBAC3                          jsr     bas_audio_off
D828  0F6F                            clr     DEVNUM
D82A  9E68                            ldx     $0068
D82C  AF43                            stx     3,u
D82E  3001                            leax    1,x
D830  261D                            bne     30F
D832  5D              10              tstb
D833  102AEA54                        lbpl    rts_C28B
D837  BD8434                          jsr     bas_reset_stack
D83A  C1A0                            cmpb    #$a0
D83C  2605                            bne     20F
D83E  BDDF6D                          jsr     L_DF6D
D841  C6A0                            ldb     #$a0
D843  BD90A5          20              jsr     L_90A5
D846  BD90F8                          jsr     bas_print_question
D849  8EC320                          ldx     #ddos_error_codes-0x80
D84C  7E835E                          jmp     L_835E
                                      ;
D84F  6DC4            30              tst     ,u
D851  27DF                            beq     10B
D853  BD8434                          jsr     bas_reset_stack
D856  6FC4                            clr     ,u
D858  EC41                            ldd     1,u
D85A  DD2B                            std     $002b
D85C  BD85E7                          jsr     L_85E7
D85F  7E849F                          jmp     bas_run_basic
                      
D862                  ddos_hook_chrin
D862  966F                            lda     DEVNUM
D864  102FEA23                        lble    rts_C28B
D868  3262                            leas    2,s
D86A  3474                            pshs    b,x,y,u
D86C  810B                            cmpa    #$0b
D86E  2702                            beq     10F
D870  97F1                            sta     DSKCOM_fcb
D872  BDDD67          10              jsr     L_DD67
D875  E60B                            ldb     11,x
D877  D7EB                            stb     DSKCOM_drive
D879  0DF4                            tst     DSKCOM_disktype
D87B  2706                            beq     20F
D87D  D6F3                            ldb     DSKCOM_xferlen
D87F  2739                            beq     40F
D881  0AF3                            dec     DSKCOM_xferlen
D883  BDDDAC          20              jsr     L_DDAC
D886  263F                            bne     80F
D888  EE0C                            ldu     12,x
D88A  BDCC0E                          jsr     L_CC0E
D88D  267C                            bne     L_D90B
D88F  1F02                            tfr     d,y
D891  1F13                            tfr     x,u
D893  BDD36B                          jsr     buf_read_sector
D896  2673                            bne     L_D90B
D898  AE05                            ldx     5,x
D89A  E64E                            ldb     14,u
D89C  3A                              abx
D89D  A684                            lda     ,x
D89F  6C4E                            inc     14,u
D8A1  2606                            bne     30F
D8A3  AE4C                            ldx     12,u
D8A5  3001                            leax    1,x
D8A7  AF4C                            stx     12,u
D8A9  8122            30              cmpa    #$22
D8AB  2715                            beq     60F
D8AD  7D0612                          tst     ddos_fread_flag
D8B0  2A0C                            bpl     50F
D8B2  812C                            cmpa    #$2c
D8B4  2704                            beq     40F
D8B6  813A                            cmpa    #$3a
D8B8  260B                            bne     70F
D8BA  860D            40              lda     #$0d
D8BC  35F4                            puls    b,x,y,u,pc
D8BE  810D            50              cmpa    #$0d
D8C0  2603                            bne     70F
D8C2  700612          60              neg     ddos_fread_flag
D8C5  35F4            70              puls    b,x,y,u,pc
D8C7  7D0611          80              tst     ddos_load_not_run
D8CA  2A66                            bpl     pe_err_D932
D8CC  BDDAEB                          jsr     L_DAEB
D8CF  0F6F                            clr     DEVNUM
D8D1  20E7                            bra     40B
                      
D8D3  BDD741          CREATE_dispatch jsr     L_D741
D8D6  2704                            beq     L_D8DC
D8D8  C1A0                            cmpb    #$a0
D8DA  265B                            bne     bne_bas_err_D937
D8DC  96F1            L_D8DC          lda     DSKCOM_fcb
D8DE  BDD079                          jsr     create_file
D8E1  2654                            bne     bne_bas_err_D937
D8E3  9DA5                            jsr     bas_poll_char
D8E5  2726                            beq     L_D90D
D8E7  BD89AA                          jsr     CkComa
D8EA  BDD98E                          jsr     L_D98E
D8ED  BDD24F                          jsr     GETFRE
D8F0  9C51                            cmpx    $0051
D8F2  2541                            blo     df_err_D935
D8F4  DC51            10              ldd     $0051
D8F6  8300FF                          subd    #$00ff
D8F9  2B09                            bmi     20F
D8FB  DD51                            std     $0051
D8FD  CCFF00                          ldd     #$ff00
D900  8D06                            bsr     L_D908
D902  20F0                            bra     10B
D904  DC52            20              ldd     VARPTR
D906  2705                            beq     L_D90D
                      
D908  BDCE20          L_D908          jsr     L_CE20
D90B  262A            L_D90B          bne     bne_bas_err_D937
D90D  39              L_D90D          rts
                      
D90E  5F              FLREAD_dispatch clrb
D90F  8D28                            bsr     L_D939
D911  BD9DD2                          jsr     L_9DD2
D914  2007                            bra     L_D91D
                      
D916  C6FF            FREAD_dispatch  ldb     #$ff
D918  8D1F                            bsr     L_D939
D91A  BD872E                          jsr     L_872E
D91D  0DF4            L_D91D          tst     DSKCOM_disktype
D91F  2710                            beq     rts_D931
D921  D6F3                            ldb     DSKCOM_xferlen
D923  270C                            beq     rts_D931
D925  BDDF42                          jsr     L_DF42
D928  4F                              clra
D929  E30D                            addd    13,x
D92B  ED0D                            std     13,x
D92D  2402                            bcc     rts_D931
D92F  6C0C                            inc     12,x
D931  39              rts_D931        rts
                      
D932  C69A            pe_err_D932     ldb     #ddos_err_PE
D934  8C                              fcb     $8c             ; cmpx - comment byte
D935  C694            df_err_D935     ldb     #ddos_err_DF    ; possibly skipped
D937                  bne_bas_err_D937
                                      ; only ever called for BNE
D937  2074                            bra     bne_bas_err_D9AD
                      
D939  F70612          L_D939          stb     ddos_fread_flag
D93C  BD9C76                          jsr     bas_not_direct
D93F  BDD741                          jsr     L_D741
D942  2669                            bne     bne_bas_err_D9AD
D944  8D16                            bsr     L_D95C
D946  B70611                          sta     ddos_load_not_run
D949  BDDF42                          jsr     L_DF42
D94C  7D067E                          tst     ddos_067E
D94F  2709                            beq     10F
D951  FE0664                          ldu     ddos_0664
D954  D6F2                            ldb     DSKCOM_buflen
D956  EF0C                            stu     12,x
D958  E70E                            stb     14,x
D95A  0E9F            10              jmp     CHRGET
                      
D95C  8D71            L_D95C          bsr     L_D9CF
D95E  860B                            lda     #$0b
D960  976F                            sta     DEVNUM
D962  9DA5            10              jsr     bas_poll_char
D964  813B                            cmpa    #$3b
D966  27C9                            beq     rts_D931
D968  BD89AA                          jsr     CkComa
D96B  81E5                            cmpa    #$e5
D96D  260E                            bne     20F
D96F  9D9F                            jsr     CHRGET
D971  8D1B                            bsr     L_D98E
D973  FF0664                          stu     ddos_0664
D976  97F2                            sta     DSKCOM_buflen
D978  7A067E                          dec     ddos_067E
D97B  20E5                            bra     10B
D97D  8180            20              cmpa    #$80
D97F  1026B031                        lbne    bas_sn_error
D983  9D9F                            jsr     CHRGET
D985  BDC825                          jsr     get_8bit_or_fc
D988  D7F3                            stb     DSKCOM_xferlen
D98A  0AF4                            dec     DSKCOM_disktype
D98C  20D4                            bra     10B
                      
D98E  BD8872          L_D98E          jsr     L_8872
D991  0D54                            tst     $0054
D993  102BB1F6                        lbmi    bas_fc_error
D997  0F5B                            clr     $005b
D999  BD9473                          jsr     L_9473
D99C  DE51                            ldu     $0051
D99E  9653                            lda     $0053
D9A0  39                              rts
                      
D9A1  BDD741          FWRITE_dispatch jsr     L_D741
D9A4  2709                            beq     10F
D9A6  C1A0                            cmpb    #ddos_err_NE
D9A8  2603                            bne     bne_bas_err_D9AD
D9AA  BDD079                          jsr     create_file
D9AD                  bne_bas_err_D9AD
D9AD  2623                            bne     bne_bas_err_D9D2
D9AF  8DAB            10              bsr     L_D95C
D9B1  7F0611                          clr     ddos_load_not_run
D9B4  9D9F                            jsr     CHRGET
D9B6  BD903D                          jsr     PRINT_dispatch
D9B9  0DF4                            tst     DSKCOM_disktype
D9BB  2711                            beq     rts_D9CE
D9BD  D6F3                            ldb     DSKCOM_xferlen
D9BF  270D                            beq     rts_D9CE
D9C1  860B                            lda     #$0b
D9C3  976F                            sta     DEVNUM
D9C5  8620                            lda     #$20
D9C7  8D23            20              bsr     L_D9EC
D9C9  5A                              decb
D9CA  26FB                            bne     20B
D9CC  0F6F                            clr     DEVNUM
D9CE  39              rts_D9CE        rts
                      
D9CF  BDDF0C          L_D9CF          jsr     L_DF0C
D9D2                  bne_bas_err_D9D2
D9D2  262D                            bne     bne_bas_err_DA01
D9D4  FF0664                          stu     ddos_0664
D9D7  97F2                            sta     DSKCOM_buflen
D9D9  0FF4                            clr     DSKCOM_disktype
D9DB  7F067E                          clr     ddos_067E
D9DE  39                              rts
                      
D9DF                  ddos_hook_chrout
D9DF  0D6F                            tst     DEVNUM
D9E1  102FE8A6                        lble    rts_C28B
D9E5  3262                            leas    2,s
D9E7  7D0611                          tst     ddos_load_not_run
D9EA  26E2                            bne     rts_D9CE
D9EC  3476            L_D9EC          pshs    a,b,x,y,u
D9EE  D66F                            ldb     DEVNUM
D9F0  C10B                            cmpb    #$0b
D9F2  270A                            beq     L_D9FE
D9F4  D7F1                            stb     DSKCOM_fcb
D9F6  8DD7                            bsr     L_D9CF
D9F8  6D84                            tst     ,x
D9FA  1027DC33                        lbeq    bas_no_error
D9FE  BDD20F          L_D9FE          jsr     L_D20F
DA01                  bne_bas_err_DA01
DA01  2629                            bne     bne_bas_err_DA2C
DA03  E60B                            ldb     11,x
DA05  D7EB                            stb     DSKCOM_drive
DA07  FE0664                          ldu     ddos_0664
DA0A  11A38810                        cmpu    $10,x
DA0E  2612                            bne     L_DA22
DA10  D6F2                            ldb     DSKCOM_buflen
DA12  E18812                          cmpb    $12,x
DA15  260B                            bne     L_DA22
DA17  CC0001                          ldd     #$0001
DA1A  BDCE20                          jsr     L_CE20
DA1D  260D                            bne     bne_bas_err_DA2C
DA1F  FE0664                          ldu     ddos_0664
DA22  BDCC0E          L_DA22          jsr     L_CC0E
DA25  2662                            bne     bne_bas_err_DA89
DA27  1F02                            tfr     d,y
DA29  BDD36B                          jsr     buf_read_sector
DA2C                  bne_bas_err_DA2C
DA2C  265B                            bne     bne_bas_err_DA89
DA2E  86FF                            lda     #$ff
DA30  A702                            sta     2,x
DA32  D6F4                            ldb     DSKCOM_disktype
DA34  2704                            beq     L_DA3A
DA36  D6F3                            ldb     DSKCOM_xferlen
DA38  2720                            beq     L_DA5A
DA3A  EE05            L_DA3A          ldu     5,x
DA3C  1E13                            exg     x,u
DA3E  D6F2                            ldb     DSKCOM_buflen
DA40  3A                              abx
DA41  A6E4                            lda     ,s
DA43  A784                            sta     ,x
DA45  0AF3                            dec     DSKCOM_xferlen
DA47  0CF2                            inc     DSKCOM_buflen
DA49  260F                            bne     L_DA5A
DA4B  1E13                            exg     x,u
DA4D  BDD3E4                          jsr     L_D3E4
DA50  2637                            bne     bne_bas_err_DA89
DA52  FE0664                          ldu     ddos_0664
DA55  3341                            leau    1,u
DA57  FF0664                          stu     ddos_0664
DA5A  35F6            L_DA5A          puls    a,b,x,y,u,pc
                      
DA5C                  ddos_hook_verify_devn
DA5C  2F7A                            ble     rts_DAD8
DA5E  C10A                            cmpb    #$0a
DA60  2267                            bhi     dn_err_DAC9
DA62  3590                            puls    x,pc
                      
DA64                  ddos_hook_dev_open
DA64  BD8887                          jsr     bas_get_string
DA67  BD8DEA                          jsr     L_8DEA
DA6A  EDE0                            std     ,s+
DA6C  BDB7D4                          jsr     L_B7D4
DA6F  5D                              tstb
DA70  102FDDC1                        lble    bas_OPEN_cont
DA74  0F6F                            clr     DEVNUM
DA76  D7F1                            stb     DSKCOM_fcb
DA78  BDDF42                          jsr     L_DF42
DA7B  6D84                            tst     ,x
DA7D  264A                            bne     dn_err_DAC9
DA7F  3414                            pshs    b,x
DA81  BD89AA                          jsr     CkComa
DA84  C6F0                            ldb     #ddos_ext_dat
DA86  BDD738                          jsr     L_D738
                                      ;
DA89                  bne_bas_err_DA89
DA89  2639                            bne     bne_bas_err_DAC4
DA8B  BDCA4E                          jsr     L_CA4E
DA8E  1027DDBC                        lbeq    bas_ao_error
DA92  3514                            puls    b,x
DA94  D7F1                            stb     DSKCOM_fcb
DA96  BDCAA8                          jsr     L_CAA8
DA99  3502                            puls    a
DA9B  C1A0                            cmpb    #$a0
DA9D  270F                            beq     10F
DA9F  5D                              tstb
DAA0  2622                            bne     bne_bas_err_DAC4
DAA2  8149                            cmpa    #$49
DAA4  2732                            beq     rts_DAD8
DAA6  8145                            cmpa    #$45
DAA8  2715                            beq     20F
DAAA  8141                            cmpa    #$41
DAAC  272A                            beq     rts_DAD8
DAAE  814F            10              cmpa    #$4f
DAB0  2714                            beq     40F
DAB2  8145                            cmpa    #$45
DAB4  2710                            beq     40F
DAB6  8141                            cmpa    #$41
DAB8  270C                            beq     40F
DABA  8D2F                            bsr     L_DAEB
DABC  7EB848                          jmp     bas_fm_error
                                      ;
DABF  96F1            20              lda     DSKCOM_fcb
DAC1  BDD0FC                          jsr     DELETE
DAC4                  bne_bas_err_DAC4
DAC4  2665                            bne     bne_bas_err_DB2B
DAC6  16FE13          40              lbra    L_D8DC
                      
DAC9  7EB851          dn_err_DAC9     jmp     bas_dn_error
                      
DACC                  ddos_hook_close_all
DACC  7F07F3                          clr     ddos_07F3
DACF  C604            L_DACF          ldb     #$04
DAD1  8D2A            10              bsr     L_DAFD
DAD3  D6EB                            ldb     DSKCOM_drive
DAD5  5A                              decb
DAD6  26F9                            bne     10B
DAD8  39              rts_DAD8        rts
                      
DAD9                  ddos_hook_close
DAD9  D66F                            ldb     DEVNUM
DADB  102FE7AC                        lble    rts_C28B
DADF  0F6F                            clr     DEVNUM
DAE1  3262                            leas    2,s
DAE3  0DF7                            tst     DSKCOM_dunno
DAE5  270B                            beq     10F
DAE7  2A02                            bpl     L_DAEB
DAE9  D7F1                            stb     DSKCOM_fcb

DAEB  BDDF6D          L_DAEB          jsr     L_DF6D
DAEE  263B                            bne     bne_bas_err_DB2B
DAF0  2018                            bra     20F
DAF2  8E8EE0          10              ldx     #L_8EE0
DAF5  ACE4                            cmpx    ,s
DAF7  27F2                            beq     L_DAEB
DAF9  C104                            cmpb    #$04
DAFB  22CC                            bhi     dn_err_DAC9
DAFD  BDDBA5          L_DAFD          jsr     L_DBA5
DB00  6F05                            clr     5,x
DB02  BDDF50                          jsr     CLOSAL
DB05  2624                            bne     bne_bas_err_DB2B
DB07  BDDF64          L_DB07          jsr     L_DF64
DB0A  0FF6            20              clr     DSKCOM_timeout
DB0C  39              rts_DB0C        rts
                      
DB0D                  PROTECT_dispatch
DB0D  6FE2                            clr     ,-s
DB0F  4D                              tsta
DB10  2A0E                            bpl     L_DB20
DB12  8188                            cmpa    #$88
DB14  2708                            beq     L_DB1E
DB16  81C2                            cmpa    #$c2
DB18  1026AE98        bne_sn_err_DB18 lbne    bas_sn_error
DB1C  6AE4                            dec     ,s
DB1E  9D9F            L_DB1E          jsr     CHRGET
DB20  BDD744          L_DB20          jsr     L_D744
DB23  267D                            bne     bas_err_DBA2
DB25  E6E0                            ldb     ,s+
DB27  5C                              incb
DB28  BDD1F1                          jsr     protect_file
DB2B                  bne_bas_err_DB2B
DB2B  2675            L_DB2B          bne     bas_err_DBA2
DB2D  20BC                            bra     L_DAEB
                      
DB2F  81C6            KILL_dispatch   cmpa    #$c6
DB31  277D                            beq     L_DBB0
DB33  BDD736                          jsr     L_D736
DB36  266A                            bne     bas_err_DBA2
DB38  BDCA89          10              jsr     open_file
DB3B  2665                            bne     bas_err_DBA2
DB3D  BDD0FC                          jsr     DELETE
DB40  20E9                            bra     L_DB2B
                                      ;
DB42  26C8            L_DB42          bne     rts_DB0C
DB44  BDC8F4                          jsr     waitkey_y
DB47  26C3                            bne     rts_DB0C
DB49  3015                            leax    -11,x
DB4B  C60B                            ldb     #$0b
DB4D  BDD0D2                          jsr     L_D0D2
DB50  20E6                            bra     10B
                      
                                      ; ensure the next token is TO
DB52  C6BC            assert_TO_tok   ldb     #$bc
DB54  7E89AC                          jmp     CkChar
                      
DB57  8123            RENAME_dispatch cmpa    #$23
DB59  2721                            beq     10F
DB5B  BDD744                          jsr     L_D744
DB5E  2642                            bne     bas_err_DBA2
DB60  F6065B                          ldb     ddos_cur_drive_info+11
DB63  3406                            pshs    a,b
DB65  8DEB                            bsr     assert_TO_tok
DB67  BDD744                          jsr     L_D744
DB6A  2734                            beq     fe_err_DBA0
DB6C  C1A0                            cmpb    #$a0
DB6E  8DBB                            bsr     L_DB2B
DB70  3506                            puls    a,b
DB72  F1065B                          cmpb    ddos_cur_drive_info+11
DB75  26A1                            bne     bne_sn_err_DB18
DB77  BDD220                          jsr     RENAME
DB7A  20AF                            bra     L_DB2B
DB7C  9D9F            10              jsr     CHRGET
DB7E  BDC811                          jsr     get_drive_arg
DB81  D7EB                            stb     DSKCOM_drive
DB83  8DCD                            bsr     assert_TO_tok
DB85  BDD736                          jsr     L_D736
DB88  2618                            bne     bas_err_DBA2
DB8A  8D42                            bsr     L_DBCE
DB8C  2614                            bne     bas_err_DBA2
DB8E  6A02                            dec     2,x
DB90  BDD237                          jsr     L_D237
DB93  BDC81E                          jsr     opt_comma_8bit
DB96  2702                            beq     20F
DB98  E754                            stb     -12,u
DB9A  BDC78A          20              jsr     L_C78A
DB9D  2603                            bne     bas_err_DBA2
DB9F  39                              rts
                      
DBA0  C69E            fe_err_DBA0     ldb     #$9e
DBA2  7E8344          bas_err_DBA2    jmp     bas_system_error
                      
																								; returns at X pointer to drive info
DBA5  D7EB            L_DBA5          stb     DSKCOM_drive						; put drive number in system variable
DBA7  8606                            lda     #sizeof_drive						; length of drive register
DBA9  3D                              mul												; calculate offset
DBAA  8E0616                          ldx     #ddos_drives-sizeof_drive		; point 6 before drive info table
DBAD  3085                            leax    b,x     ; XXX abx?				; add offset
DBAF  39                              rts												; return
                      
DBB0  CED315          L_DBB0          ldu     #GETDIR
DBB3  9D9F                            jsr     CHRGET
DBB5  BDC80A                          jsr     L_C80A
DBB8  F7065B                          stb     ddos_cur_drive_info+11
DBBB  8DE8                            bsr     L_DBA5
DBBD  6C05                            inc     drive_num_open_files,x
DBBF  5F                              clrb
DBC0  9E8A                            ldx     bas_null
DBC2  3454                            pshs    b,x,u
DBC4  CEDB42                          ldu     #L_DB42
DBC7  8D46                            bsr     L_DC0F
DBC9  3550                            puls    x,u
DBCB  7EDF7D                          jmp     L_DF7D
                      
																							; Fun2 called by Fun1
DBCE  BDD2C2          L_DBCE          jsr     L_D2C2						; Fun3
DBD1  260E                            bne     10F
DBD3  3194                            leay    [,x]
																							; Fun5 called by Fun4
DBD5  BDD36B          L_DBD5          jsr     buf_read_sector		   ; Fun6
DBD8  6F02                            clr     2,x
DBDA  EE05                            ldu     5,x
DBDC  33C900F0                        leau    $f0,u
DBE0  5D                              tstb
DBE1  39              10              rts
                      
																							; Fun1 called by DIR
DBE2  5D              L_DBE2          tstb
DBE3  2603                            bne     $dbe8
DBE5  BDBA77								  jsr		 $ba77
DBE8  8DE4                            bsr     L_DBCE						; Fun2
DBEA  26B6                            bne     bas_err_DBA2				; if error, exit
DBEC  EC5F                            ldd     -1,u
DBEE  271E                            beq     20F
DBF0  3440                            pshs    u
DBF2  BDC925                          jsr     L_C925
DBF5  3510                            puls    x
                                      ;
DBF7  C608            pr_filename     ldb     #$08
DBF9  8D07                            bsr     L_DC02
DBFB  862E                            lda     #$2e
DBFD  BDB54A                          jsr     OUTCHR
DC00  C603                            ldb     #$03
                                      ;
DC02  A680            L_DC02          lda     ,x+
DC04  2602                            bne     10F
DC06  8620                            lda     #$20
DC08  BDB54A          10              jsr     OUTCHR
DC0B  5A                              decb
DC0C  26F4                            bne     L_DC02
DC0E  39              20              rts
                      
DC0F  EFE3            L_DC0F          stu     ,--s
DC11  E665            10              ldb     5,s
DC13  ADF807                          jsr     [$07,s]
DC16  2706                            beq     30F
DC18  C19F                            cmpb    #$9f
DC1A  2686                            bne     bas_err_DBA2
DC1C  35C0            20              puls    u,pc
DC1E  A680            30              lda     ,x+
DC20  8508                            bita    #$08
DC22  26F8                            bne     20B
DC24  8581                            bita    #$81
DC26  260D                            bne     40F
DC28  8DCD                            bsr     pr_filename
DC2A  BD90F5                          jsr     bas_print_space
DC2D  A614                            lda     -12,x
DC2F  8502                            bita    #$02
DC31  ADF4                            jsr     [,s]
DC33  8D5C                            bsr     pr_crlf_DC91
DC35  6C65            40              inc     5,s
DC37  20D8                            bra     10B
                      
DC39                  DIR_dispatch
DC39  CED315                          ldu     #GETDIR						; points to get directory entry function
DC3C  5F                              clrb									; clear B
DC3D  81C6                            cmpa    #$c6							; is A = token for '/'?
DC3F  2604                            bne     10F							; no, goto 10F
DC41  9D9F                            jsr     CHRGET
DC43  C60A                            ldb     #$0a
DC45  3444            10              pshs    b,u							; save registers
DC47  8123                            cmpa    #$23							; is it '#'?
DC49  260A                            bne     20F							; no, goto 20F
DC4B  BDB7DB                          jsr     L_B7DB
DC4E  9DA5                            jsr     bas_poll_char
DC50  2703                            beq     20F
DC52  BD89AA                          jsr     CkComa
DC55  BDC808          20              jsr     get_opt_drive				; get requested drive number or default one
DC58  1026AD58                        lbne    bas_sn_error				; if error, show it
DC5C  D7EB                            stb     DSKCOM_drive				; save drive number
DC5E  BDB63C                          jsr     L_B63C						; test output destination
DC61  D66F                            ldb     <$6f
DC63  BDDBE2                          jsr     $dbe2
DC66  12                              nop
DC67  5F										  clrb
DC68  4F                              clra
DC69  EDE3                            std     ,--s
DC6B  CEDC94                          ldu     #L_DC94
DC6E  8D9F                            bsr     L_DC0F
DC70  200B                            bra     $dc7d
DC72  860D                            lda		 #$0d
DC74  0D6F                            tst     <$6f
DC76  1026D8D0                        lbne	 $b54a
DC7A  7EC0DA                          jmp	    $c0da
DC7D  3552                            puls    a,x,u
DC7F  BDC925                          jsr     L_C925
DC82  8EC54F                          ldx     #msg_files_bytes_free-1
DC85  BD90E5                          jsr     bas_print_string
DC88  BDDD92                          jsr     L_DD92
DC8B  8D59                            bsr     L_DCE6
DC8D  12										  nop
DC8E  12										  nop
DC8F  0F6F                            clr     DEVNUM
DC91  7EDC72              				  jmp     $dc72
                      
DC94  2603            L_DC94          bne     10F
DC96  8620                            lda     #$20
DC98  8C                              fcb     $8c     ; cmpx - comment byte
DC99  8670            10              lda     #$70    ; possibly skipped
DC9B  BDB54A                          jsr     OUTCHR
DC9E  8D32                            bsr     L_DCD2
DCA0  6C66                            inc     6,s
DCA2  D66F                            ldb     DEVNUM
DCA4  2614                            bne     40F
DCA6  E668                            ldb     8,s
DCA8  270B                            beq     30F
DCAA  5A                              decb
DCAB  2605                            bne     20F
DCAD  BD852B                          jsr     bas_wait_key
DCB0  C60C                            ldb     #$0c
DCB2  E768            20              stb     8,s
DCB4  39                              rts
DCB5  9E88            30              ldx     <$88
DCB7  7EC068                          jmp     $c068
DCBA  5C              40              incb
DCBB  2A47                            bpl     rts_DD04
DCBD  6D68                            tst     8,s
DCBF  2643                            bne     rts_DD04
DCC1  D69C            50              ldb     bas_lp_pos
DCC3  C137                            cmpb    #$37
DCC5  243D                            bhs     rts_DD04
DCC7  BD90F5                          jsr     bas_print_space
DCCA  C407                            andb    #$07
DCCC  26F3                            bne     50B
DCCE  AEE1                            ldx     ,s++
DCD0  6E02                            jmp     2,x
                      
DCD2  BDCA6F          L_DCD2          jsr     find_free_fcb
DCD5  260B                            bne     10F
DCD7  E669                            ldb     9,s
DCD9  E7881D                          stb     $1d,x
DCDC  CEFFFF                          ldu     #$ffff
DCDF  BDDF23                          jsr     L_DF23
DCE2  2679            10              bne     bne_bas_err_DD5D

DCE4  8D54            L_DCE4          bsr     L_DD3A										; redirects to L_DD7D to fill FAC
DCE6  BD90F5          L_DCE6          jsr     bas_print_space							; print a space on screen
DCE9  BD9582                          jsr     bas_print_number							; converts FAC to ASCII and prints it
DCEC  BD90F5                          jsr     bas_print_space							; print a space on screen
DCEF  7E851B          L_DCEF          jmp     bas_scan_key								; controls Break and Shift-@ keys and returns
                      
DCF2  2710            WAIT_dispatch   beq     rts_DD04
DCF4  BD8E83                          jsr     Get16Bit
DCF7  9E52                            ldx     VARPTR
DCF9  8DF4            L_DCF9          bsr     L_DCEF
DCFB  C6A0                            ldb     #$a0
DCFD  5A              10              decb
DCFE  26FD                            bne     10B
DD00  301F                            leax    -1,x
DD02  26F5                            bne     L_DCF9
DD04  39              rts_DD04        rts
                      
                                      ; hooks bas_hook_screen_access - CLS, GET, PUT
DD05                  ddos_screen_hook
DD05  3411                            pshs    cc,x
DD07  AE63                            ldx     3,s
DD09  8C8512                          cmpx    #L_8512
DD0C  270D                            beq     20F
DD0E  8C9EEE                          cmpx    #L_9EEE
DD11  2606                            bne     10F
DD13  8190                            cmpa    #$90
DD15  2602                            bne     10F
DD17  86BF                            lda     #$bf
DD19  3591            10              puls    cc,x,pc
DD1B  81A7            20              cmpa    #$a7
DD1D  26FA                            bne     10B
DD1F  9D9F                            jsr     CHRGET
DD21  8D19                            bsr     L_DD3C
DD23  C6CB                            ldb     #$cb
DD25  BD89AC                          jsr     CkChar
DD28  BDD98E                          jsr     L_D98E
DD2B  BDDF42                          jsr     L_DF42
DD2E  EF0C                            stu     12,x
DD30  A70E                            sta     14,x
DD32  35D1                            puls    cc,x,u,pc
                      
DD34  8D06            LOC_dispatch    bsr     L_DD3C
DD36  EE0C                            ldu     12,x
DD38  A60E                            lda     14,x
DD3A  2041            L_DD3A          bra     L_DD7D
                      
DD3C  BD899F          L_DD3C          jsr     L_899F
DD3F  0D06                            tst     VALTYP
DD41  2B12                            bmi     L_DD55
DD43  966F                            lda     DEVNUM
DD45  3402                            pshs    a
DD47  BDB7E0                          jsr     L_B7E0
DD4A  966F                            lda     DEVNUM
DD4C  2F5B                            ble     sn_err_DDA9
DD4E  8D15                            bsr     L_DD65
DD50  3502                            puls    a
DD52  976F                            sta     DEVNUM
DD54  39                              rts
DD55  CED74D          L_DD55          ldu     #L_D74D
DD58  C6F0                            ldb     #ddos_ext_dat
DD5A  BDD764                          jsr     L_D764
DD5D                  bne_bas_err_DD5D
DD5D  2611                            bne     bas_err_DD70
DD5F  BDCA4E                          jsr     L_CA4E
DD62  260A                            bne     no_err_DD6E
DD64  39                              rts
                      
DD65  97F1            L_DD65          sta     DSKCOM_fcb
DD67  BDDF42          L_DD67          jsr     L_DF42
DD6A  6D84                            tst     ,x
DD6C  2696                            bne     rts_DD04
DD6E  C62E            no_err_DD6E     ldb     #$2e
DD70  7E8344          bas_err_DD70    jmp     bas_system_error
                      
DD73  BDD741          LOF_dispatch    jsr     L_D741
DD76  26F8                            bne     bas_err_DD70
DD78  BDDF0A                          jsr     LENFIL
DD7B  26F3                            bne     bas_err_DD70

DD7D  0F06            L_DD7D          clr     VALTYP
DD7F  5F                              clrb
DD80  DD53                            std     $0053
DD82  0F63                            clr     $0063
DD84  86A0                            lda     #$a0
DD86  DD4F                            std     $004f
DD88  DF51                            stu     $0051
DD8A  7E9165                          jmp     L_9165									; normalize FAC
                      
DD8D  BDC808          FREE_dispatch   jsr     get_opt_drive
DD90  D7EB                            stb     DSKCOM_drive
DD92  BDD24F          L_DD92          jsr     GETFRE
DD95  26D9                            bne     bas_err_DD70
DD97  1F13                            tfr     x,u
DD99  4F                              clra
DD9A  20E1                            bra     L_DD7D
                      
DD9C                  ddos_hook_check_eof
DD9C  0D06                            tst     VALTYP
DD9E  2740                            beq     rts_DDE0
DDA0  3262                            leas    2,s
DDA2  8DB1                            bsr     L_DD55
DDA4  8D06            L_DDA4          bsr     L_DDAC
DDA6  7EB81A                          jmp     L_B81A
                      
DDA9  7E89B4          sn_err_DDA9     jmp     bas_sn_error
                      
DDAC  BDDF0C          L_DDAC          jsr     L_DF0C
DDAF  26BF                            bne     bas_err_DD70
DDB1  11A30C                          cmpu    12,x
DDB4  220B                            bhi     20F
DDB6  2504                            blo     10F
DDB8  A10E                            cmpa    14,x
DDBA  2205                            bhi     20F
DDBC  F607F5          10              ldb     ddos_eof_return
DDBF  53                              comb
DDC0  39                              rts
DDC1  5F              20              clrb
DDC2  39                              rts
                      
DDC3                  ddos_hook_input
DDC3  C6                              fcb     $c6     ; lda #$5f - comment byte
DDC4                  ddos_hook_print
DDC4  5F                              clrb            ; possibly skipped
DDC5  966F                            lda     DEVNUM
DDC7  2F17                            ble     rts_DDE0
DDC9  3262                            leas    2,s
DDCB  F70611                          stb     ddos_load_not_run
DDCE  810B                            cmpa    #$0b
DDD0  270E                            beq     rts_DDE0
DDD2  8D91                            bsr     L_DD65
DDD4  AEE4                            ldx     ,s
DDD6  8CB80C                          cmpx    #$b80c
DDD9  2706                            beq     10F
DDDB  7F0612                          clr     ddos_fread_flag
DDDE  0FF4                            clr     DSKCOM_disktype
DDE0  39              rts_DDE0        rts
DDE1  3262            10              leas    2,s
DDE3  3502                            puls    a
DDE5  976F                            sta     DEVNUM
DDE7  20BB                            bra     L_DDA4
                      
DDE9  DC68            AUTO_dispatch   ldd     $0068
DDEB  C30001                          addd    #$0001
DDEE  26B9                            bne     sn_err_DDA9
DDF0  C60A                            ldb     #$0a
DDF2  3406                            pshs    a,b
DDF4  C664                            ldb     #$64
DDF6  3406                            pshs    a,b
DDF8  9DA5                            jsr     bas_poll_char
DDFA  2718                            beq     10F
DDFC  BD8E83                          jsr     Get16Bit
DDFF  DC52                            ldd     VARPTR
DE01  EDE4                            std     ,s
DE03  9DA5                            jsr     bas_poll_char
DE05  270D                            beq     10F
DE07  BDD593                          jsr     comma_16bit
DE0A  DC52                            ldd     VARPTR
DE0C  279B                            beq     sn_err_DDA9
DE0E  ED62                            std     2,s
DE10  9DA5                            jsr     bas_poll_char
DE12  2695                            bne     sn_err_DDA9
DE14  1A50            10              orcc    #$50
DE16  ECE1                            ldd     ,s++
DE18  A3E4                            subd    ,s
DE1A  FD060D                          std     ddos_auto_line_num
DE1D  2403                            bcc     20F
DE1F  7A0613                          dec     ddos_auto_flag
DE22  ECE1            20              ldd     ,s++
DE24  FD060F                          std     ddos_auto_line_inc
DE27  7A0613                          dec     ddos_auto_flag
DE2A  39                              rts
                      
DE2B                  ddos_hook_line_input
DE2B  3456                            pshs    a,b,x,u
DE2D  8E837D                          ldx     #L_837D
DE30  AC68                            cmpx    8,s
DE32  2605                            bne     10F
DE34  7D0613                          tst     ddos_auto_flag
DE37  2602                            bne     20F
DE39  35D6            10              puls    a,b,x,u,pc
DE3B  FC060D          20              ldd     ddos_auto_line_num
DE3E  F3060F                          addd    ddos_auto_line_inc
DE41  2405                            bcc     40F
DE43  7C0613          30              inc     ddos_auto_flag
DE46  27F1                            beq     10B
DE48  FD060D          40              std     ddos_auto_line_num
DE4B  81FA                            cmpa    #$fa
DE4D  24F4                            bhs     30B
DE4F  0689                            ror     bas_cursor_pos+1
DE51  0889                            lsl     bas_cursor_pos+1
DE53  BD8401                          jsr     L_8401
DE56  2506                            bcs     50F
DE58  BD90F8                          jsr     bas_print_question
DE5B  FC060D                          ldd     ddos_auto_line_num
DE5E  BD957A          50              jsr     bas_print_d
DE61  0C89                            inc     bas_cursor_pos+1
DE63  CE03DA                          ldu     #$03da
DE66  8E02DD                          ldx     #$02dd
DE69  5F                              clrb
DE6A  A6C0            60              lda     ,u+
DE6C  2705                            beq     70F
DE6E  A780                            sta     ,x+
DE70  5C                              incb
DE71  20F7                            bra     60B
DE73  8620            70              lda     #$20
DE75  A780                            sta     ,x+
DE77  5C                              incb
DE78  BDB505          80              jsr     bas_input_achar
DE7B  8103                            cmpa    #$03
DE7D  2704                            beq     90F
DE7F  810D                            cmpa    #$0d
DE81  260E                            bne     100F
DE83  7F0613          90              clr     ddos_auto_flag
DE86  BD90A1                          jsr     bas_print_crlf
DE89  8E02DD                          ldx     #$02dd
DE8C  CC0D01                          ldd     #$0d01
DE8F  2008                            bra     110F
DE91  8120            100             cmpa    #$20
DE93  25E3                            blo     80B
DE95  817A                            cmpa    #$7a
DE97  22DF                            bhi     80B
DE99  3268            110             leas    8,s
DE9B  0F85                            clr     $0085
DE9D  7EB5D3                          jmp     L_B5D3
                      
DEA0  2704            BEEP_dispatch   beq     10F
DEA2  BDC825                          jsr     get_8bit_or_fc
DEA5  8C                              fcb     $8c     ; cmpx - comment byte
DEA6  C601            10              ldb     #$01    ; possibly skipped
DEA8  3404                            pshs    b
DEAA  5F                              clrb
DEAB  BDBAED                          jsr     L_BAED
DEAE  4F              20              clra
DEAF  8E0008                          ldx     #$0008
DEB2  BDBE12          30              jsr     CBOUT
DEB5  301F                            leax    -1,x
DEB7  26F9                            bne     30B
DEB9  BD851B                          jsr     bas_scan_key
DEBC  6AE4                            dec     ,s
DEBE  2709                            beq     50F
DEC0  8E8400                          ldx     #$8400
DEC3  301F            40              leax    -1,x
DEC5  26FC                            bne     40B
DEC7  20E5                            bra     20B
DEC9  3584            50              puls    b,pc
                      
DECB  BD8A94          SWAP_dispatch   jsr     GETVAR
DECE  9E39                            ldx     VARPTR_last
DED0  9606                            lda     VALTYP
DED2  3412                            pshs    a,x
DED4  BD89AA                          jsr     CkComa
DED7  BD8A94                          jsr     GETVAR
DEDA  3522                            puls    a,y
DEDC  9106                            cmpa    VALTYP
DEDE  1026A9A0                        lbne    bas_tm_error
DEE2  DE39                            ldu     VARPTR_last
DEE4  8E0005                          ldx     #$0005
DEE7  A6C4            10              lda     ,u
DEE9  E6A4                            ldb     ,y
DEEB  E7C0                            stb     ,u+
DEED  A7A0                            sta     ,y+
DEEF  301F                            leax    -1,x
DEF1  26F4                            bne     10B
DEF3  39              rts_DEF3        rts
                      
DEF4                  ddos_hook_dev_init
DEF4  0D6F                            tst     DEVNUM
DEF6  2FFB                            ble     rts_DEF3
DEF8  3262                            leas    2,s
DEFA  3416                            pshs    a,b,x
DEFC  0F6E                            clr     $006e
DEFE  B607F3                          lda     ddos_07F3
DF01  916F                            cmpa    DEVNUM
DF03  1026D6B5                        lbne    L_B5BC
DF07  7EB5BA                          jmp     L_B5BA
                      
                                      ; length of a file
DF0A  97F1            LENFIL          sta     DSKCOM_fcb									; put FIB number in variable
DF0C  8D34            L_DF0C          bsr     L_DF42										; get FIB address in X
DF0E  6D0F                            tst     15,x											; get flags
DF10  2A03                            bpl     20F											; if not negative, OK
DF12  C69C                            ldb     #$9c											; show error message (File not found)
DF14  39              10              rts														; return
DF15  A60B            20              lda     11,x											; get drive number
DF17  97EB                            sta     DSKCOM_drive								; into variable
DF19  A68812                          lda     $12,x										; get lowest byte of LOF (bytes of last sector)
DF1C  EE8810                          ldu     $10,x										; get two higher bytes of LOF (number of sectors)
DF1F  3141                            leay    1,u
DF21  261B                            bne     40F											; if not $FFFF, exit via 40F
                                      ;
DF23  BDCC7C          L_DF23          jsr     L_CC7C
DF26  26EC                            bne     10B
DF28  F60682                          ldb     ddos_0682
DF2B  E7881E                          stb     $1e,x
DF2E  A6C818                          lda     $18,u
DF31  FE066B                          ldu     ddos_066B
DF34  A78812                          sta     $12,x
DF37  2702                            beq     30F
DF39  335F                            leau    -1,u
DF3B  EF8810          30              stu     $10,x
DF3E  5F              40              clrb													; flag Z=1 (OK)
DF3F  39              rts_DF3F        rts														; return
                      
																											; calculate in X the address for that FIB#
DF40  97F1            L_DF40          sta     DSKCOM_fcb
                                      ; fall through
DF42  3406            L_DF42          pshs    a,b
DF44  96F1                            lda     DSKCOM_fcb
DF46  C61F                            ldb     #sizeof_fcb
DF48  3D                              mul
DF49  8E069E                          ldx     #ddos_fcbs-sizeof_fcb
DF4C  308B                            leax    d,x
DF4E  3586                            puls    a,b,pc
                      
                                      ; close all open files on drive
DF50  860A            CLOSAL          lda     #$0a
DF52  97F1                            sta     DSKCOM_fcb
DF54  96EB                            lda     DSKCOM_drive
DF56  8DEA            10              bsr     L_DF42
DF58  A10B                            cmpa    11,x
DF5A  2604                            bne     20F
DF5C  8D11                            bsr     L_DF6F
DF5E  26DF                            bne     rts_DF3F
DF60  0AF1            20              dec     DSKCOM_fcb
DF62  26F2                            bne     10B
DF64  8E0696          L_DF64          ldx     #ddos_drive_on-1
DF67  6F86                            clr     a,x
DF69  5F              L_DF69          clrb
DF6A  39                              rts
                      
                                      ; close single file
DF6B  97F1            close_file      sta     DSKCOM_fcb
DF6D  8DD3            L_DF6D          bsr     L_DF42
DF6F  6D84            L_DF6F          tst     ,x
DF71  27F6                            beq     L_DF69
DF73  96EB                            lda     DSKCOM_drive
DF75  3402                            pshs    a
DF77  A60B                            lda     11,x
DF79  97EB                            sta     DSKCOM_drive
DF7B  6F84                            clr     ,x
DF7D  BDD2C2          L_DF7D          jsr     L_D2C2
DF80  261C                            bne     L_DF9E
DF82  6D05                            tst     5,x
DF84  2704                            beq     L_DF8A
DF86  6A05                            dec     5,x
DF88  2614                            bne     L_DF9E
DF8A  E602            L_DF8A          ldb     2,x
DF8C  2709                            beq     L_DF97
DF8E  6F02                            clr     2,x
DF90  AE03                            ldx     3,x
DF92  BDD185                          jsr     L_D185
DF95  2607                            bne     L_DF9E
DF97  BDC78A          L_DF97          jsr     L_C78A
DF9A  96EB                            lda     DSKCOM_drive
DF9C  8DC6                            bsr     L_DF64
DF9E  3502            L_DF9E          puls    a
DFA0  97EB                            sta     DSKCOM_drive
DFA2  5D                              tstb
DFA3  39                              rts
                      
DFA4                  ddos_hook_interpret_tok
DFA4  8190                            cmpa    #$90
DFA6  2616                            bne     20F
DFA8  3262                            leas    2,s
DFAA  9E19                            ldx     bas_basic_start
DFAC  9D9F                            jsr     CHRGET
DFAE  270A                            beq     10F
DFB0  BD869A                          jsr     L_869A
DFB3  BD83FF                          jsr     L_83FF
DFB6  1025A64B                        lbcs    bas_ul_error
DFBA  301F            10              leax    -1,x
DFBC  9F33                            stx     $0033
DFBE  39              20              rts
                      
DFBF  C28C            fdop_dispatch   fdb     fdop_restore_dispatch
DFC1  C28F                            fdb     fdop_seek_dispatch
DFC3  C2BD                            fdb     fdop_read_sector_dispatch
DFC5  C2F5                            fdb     fdop_write_sector_nr_dispatch
DFC7  C2F2                            fdb     fdop_write_sector_dispatch
DFC9  C325                            fdb     fdop_write_track_dispatch
DFCB  C2B6                            fdb     fdop_read_address_dispatch
DFCD  C2BA                            fdb     fdop_test_sector_dispatch
DFCF  C2B0                            fdb     fdop_read_address_s0_dispatch
                      
DFD1  4C4FC6          ddos_fwords     fcc     /LO/,'F+$80
DFD4  465245C5                        fcc     /FRE/,'E+$80
DFD8  4552CC                          fcc     /ER/,'L+$80
DFDB  4552D2                          fcc     /ER/,'R+$80
DFDE  48494D45CD                      fcc     /HIME/,'M+$80
DFE3  4C4FC3                          fcc     /LO/,'C+$80
DFE6  465245A4                        fcc     /FRE/,'$+$80
                      
                                      ; note: these must all start within the same page due to
                                      ; some fancy address manipulation
                              if (*&255)>243
                                      rzb     256-(*&255)
                              endif
DFEA                  ddos_exts
00EA                  ddos_ext_bas    equ     *&$ff
DFEA  424153                          fcc     /BAS/
00ED                  ddos_ext_cmd    equ     *&$ff
DFED  434D44                          fcc     /CMD/
00F0                  ddos_ext_dat    equ     *&$ff
DFF0  444154                          fcc     /DAT/
00F3                  ddos_ext_bin    equ     *&$ff
DFF3  42494E                          fcc     /BIN/
00F6                  ddos_ext_none   equ     *&$ff
DFF6  20                              fcc     / /             ; ,/  /
                                      ; note: space characters from following msg___check are
                                      ; used to complete the "   " (none) file extension
                      
DFF7  2020434845434B00 msg___check     fcc     /  CHECK/,0
                      
                                      ; $dfff XXX coverage
DFFF  FF                              fcb     $ff
